
var ImportFileUtil= {

    //导入Excel文件
     importExcel:function(obj, importType)
    {
        var wb;
        var rABS = false;
        var result = {};
        if (!obj.files) {
            return;
        }

        var file = obj.files[0];

        if(Ext.isEmpty(file))
        {
            Ext.Msg.alert('提示', '请选择上传文件.');
            return;
        }

        if(file!=null)
        {
            //console.log(file);
            var fileName= file.name;
            var preFile=fileName.substring(fileName.lastIndexOf('.')+1,fileName.length);
            if(preFile.toLowerCase()!='xls' && preFile.toLowerCase()!='xlsx')
            {
                Ext.Msg.alert('提示','请选择excel文件导入.');
                return;
            }
        }


        var reader = new FileReader();
        reader.onload = function (e) {

            var data = e.target.result;

            if (rABS) {

                wb = XLSX.read(btoa(fixdata(data)), {type: 'base64'});

            } else {

                wb = XLSX.read(data, {type: 'binary'});

            }

            result = XLSX.utils.sheet_to_json(wb.Sheets[wb.SheetNames[0]]);
            //console.log(result);
            //console.log(importType);
            if(importType=='importCustomerInfo'){
                importCustomerInfo(result);
            }
            else if(importType=='importCommodityInfo')
            {
                importCommodityInfo(result);
            }


        };

        if (rABS) {

            reader.readAsArrayBuffer(file);

        } else {

            reader.readAsBinaryString(file);

        }
    },

    /* 导出Excel开始*/
    exportExcel:function (fileName,json, type) {

        var tmpDown; //导出的二进制对象
        var tmpdata = json[0];
        json.unshift({});
        var keyMap = []; //获取keys
        for (var k in tmpdata) {
            keyMap.push(k);
            json[0][k] = k;
        }

        var me = this;
        //var exportFunc = function() {
        var tmpdata = [];//用来保存转换好的json
        json.map((v, i) => keyMap.map((k, j) => Object.assign({}, {
            v: v[k],
            position: (j > 25 ? me.getCharCol(j) : String.fromCharCode(65 + j)) + (i + 1)
        }))).reduce((prev, next) => prev.concat(next)).forEach((v, i) => tmpdata[v.position] = {
            v: v.v
        });

        var outputPos = Object.keys(tmpdata); //设置区域,比如表格从A1到D10
        var tmpWB = {
            SheetNames: ['mySheet'], //保存的表标题
            Sheets: {
                'mySheet': Object.assign({},
                    tmpdata, //内容
                    {
                        '!ref': outputPos[0] + ':' + outputPos[outputPos.length - 1] //设置填充区域
                    })
            }
        };
        tmpDown = new Blob([me.s2ab(XLSX.write(tmpWB,
            {bookType: (type == undefined ? 'xlsx':type),bookSST: false, type: 'binary'}//这里的数据是用来定义导出的格式类型
        ))], {
            type: ""
        }); //创建二进制对象写入转换好的字节流
        mposService.getWinVPosData({value:["operatorSystem"]}, function(success, data) {
            if(success && data) {
                if(data == "AE") {
                    // 安卓
                    var exportData = {};
                    exportData.data = tmpDown;
                    exportData.filename = fileName + ".xlsx";
                    exportData.dirname = "Download";
                    mposService.exportFile(exportData, function(success) {
                        if(success) console.log("导出成功!");
                        else console.log("导出失败!");
                    });
                } else {
                    var href = window.URL.createObjectURL(tmpDown); //创建对象超链接
                    document.getElementById("hf").download=fileName+'.xlsx';
                    document.getElementById("hf").href = href; //绑定a标签
                    document.getElementById("hf").click();//模拟点击实现下载

                    setTimeout(function() { //延时释放
                        URL.revokeObjectURL(tmpDown); //用URL.revokeObjectURL()来释放这个object URL
                    }, 100);
                }
            }
        });
        return;

        var href = window.URL.createObjectURL(tmpDown); //创建对象超链接
        document.getElementById("hf").download=fileName+'.xlsx';
        document.getElementById("hf").href = href; //绑定a标签
        document.getElementById("hf").click();//模拟点击实现下载

        setTimeout(function() { //延时释放
            URL.revokeObjectURL(tmpDown); //用URL.revokeObjectURL()来释放这个object URL
        }, 100);
        //};
        /*mposService.getWinVPosData({value:["operatorSystem"]}, function(success, data) {
            if(success && data) {
                if(data == "AE") {
                    // 安卓
                    var exportData = {};
                    exportData.data = json;
                    exportData.filename = fileName + ".xlsx";
                    exportData.dirname = "Downloads";
                    exportData.sheetname = "mySheet";
                    mposService.exportFile(exportData, function(success) {
                        if(success) console.log("导出成功!");
                        else console.log("导出失败!");
                    });
                } else exportFunc();
            }
        });*/


    },
    /* 导出Excel开始*/
    exportExcelBackup:function (fileName,json, type) {

        var tmpDown; //导出的二进制对象
        var tmpdata = json[0];
        json.unshift({});
        var keyMap = []; //获取keys
        for (var k in tmpdata) {
            keyMap.push(k);
            json[0][k] = k;
        }

        mposService.getWinVPosData("operatorSystem", function(success, data) {
            if(success && data) {
                if(data.resultVal == "AE") {

                }
            }
        });

        var tmpdata = [];//用来保存转换好的json
        json.map((v, i) => keyMap.map((k, j) => Object.assign({}, {
            v: v[k],
            position: (j > 25 ? this.getCharCol(j) : String.fromCharCode(65 + j)) + (i + 1)
        }))).reduce((prev, next) => prev.concat(next)).forEach((v, i) => tmpdata[v.position] = {
            v: v.v
        });

        var outputPos = Object.keys(tmpdata); //设置区域,比如表格从A1到D10
        var tmpWB = {
            SheetNames: ['mySheet'], //保存的表标题
            Sheets: {
                'mySheet': Object.assign({},
                    tmpdata, //内容
                    {
                        '!ref': outputPos[0] + ':' + outputPos[outputPos.length - 1] //设置填充区域
                    })
            }
        };
        tmpDown = new Blob([this.s2ab(XLSX.write(tmpWB,
            {bookType: (type == undefined ? 'xlsx':type),bookSST: false, type: 'binary'}//这里的数据是用来定义导出的格式类型
        ))], {
            type: ""
        }); //创建二进制对象写入转换好的字节流
        var href = window.URL.createObjectURL(tmpDown); //创建对象超链接
        document.getElementById("hf").download=fileName+'.xlsx';
        document.getElementById("hf").href = href; //绑定a标签
        document.getElementById("hf").click();//模拟点击实现下载

        setTimeout(function() { //延时释放
            URL.revokeObjectURL(tmpDown); //用URL.revokeObjectURL()来释放这个object URL
        }, 100);
    },

    s2ab:function(s) { //字符串转字符流
        var buf = new ArrayBuffer(s.length);
        var view = new Uint8Array(buf);
        for (var i = 0; i != s.length; ++i) view[i] = s.charCodeAt(i) & 0xFF;
        return buf;
    },

    // 将指定的自然数转换为26进制表示。映射关系：[0-25] -> [A-Z]。
    getCharCol:function (n) {
        let temCol = '',
            s = '',
            m = 0
        while (n > 0) {
            m = n % 26 + 1
            s = String.fromCharCode(m + 64) + s
            n = (n - m) / 26
        }
        return s
    },

    /* 导出Excel结束*/
    fixdata:function (data) {
        var o = "",
            l = 0,
            w = 10240;
        for(; l < data.byteLength / w; ++l)
            o += String.fromCharCode.apply(null, new Uint8Array(data.slice(l * w, l * w + w)));
        o += String.fromCharCode.apply(null, new Uint8Array(data.slice(l * w)));
        return o;
    }



}
