Ext.define('Seller.view.place.AddPlaceSub', {
	extend : 'Seller.view.place.Place',
	alias : 'widget.addplacesub',
	initialize : function(panel, eOpts) {
		if(Ext.getCmp('place-toolbar'))
			Ext.getCmp('place-toolbar').setTitle('添加桌子');
		//setTimeout(function() {
		if(Ext.getCmp('place-view-delete'))
			Ext.getCmp('place-view-delete').setHidden(true);
		//}, 100);
	},
	checkPermission : function() {
		/**
		 * 1. 手动打开钱箱
		 * 2. 退货
		 * 3. 反结账
		 * 4. 打折
		 * 5. 删除
		 * 6. 撤销订单
		 * 7. 修改
		 * 8. 自定义抹零
		 */
		return new Promise(function(resolve, reject) {
			checkPermissions("16", true).then(function() {resolve();})
			.catch(function(){reject();});
		})
		/*if (!checkPermissions("7", true)) {
			return false;
		}
		return true;*/
	},
	saveViewData : function(viewData) {
		var me = this;
		viewData.id = createSysId();
		viewData.lastUpdateTime=createDateStr();
		viewData.isDelete = '0';
		viewData.syned = "0";
		viewData.status = "0";
		viewData.createId=shouYinEmployee.workId;
		viewData.createTime= createDateStr();
		viewData.lastUpdateId=shouYinEmployee.workId;
		ServicePlaceDao.checkPlaceAndType(viewData.typeId, viewData.placeName, function(success, datas) {
			if(success && datas) {
				if(datas.length && datas.length > 0) {
					showAlert('提示', '当前区域此桌子名称已存在!');
					return;
				}
			}
			ServicePlaceDao.addPlace(viewData, function(success) {
				if (success) {
					me.afterViewData(viewData);
				} else {
					showAlert('提示', '保存出错！');
				}
			});
		});
	},
	afterViewData : function(viewData) {
		this.callParent(arguments);
	}
});
