// 更新商品界面设置 -2018.11.20
function updateCommodityBdySetting() {
	if (bdySetting.ctlines === '2') {
		Ext.getCmp('commodityTypePageDown-btn2').setHidden(false);
		Ext.getCmp('commodityTypePageDown-btn').setHidden(true);
		Ext.getCmp('commodity-type-view').setHeight(100);
		Ext.getCmp('select-commodity-view').commodityTypePage.setLimitCount(16); //显示个数
	} else if (bdySetting.ctlines === '1') {
		Ext.getCmp('commodityTypePageDown-btn').setHidden(false);
		Ext.getCmp('commodityTypePageDown-btn2').setHidden(true);
		Ext.getCmp('commodity-type-view').setHeight(50);
		Ext.getCmp('select-commodity-view').commodityTypePage.setLimitCount(8); //显示个数
	}
	// console.log('商品行数：' + bdySetting.comLines + '，商品列数：' + bdySetting.comColumns);
	if (!Ext.getCmp('select-commodity-view')) return;
	var eleListHeight = getHtmlElementHeight("#showyin-commodity-list"); // 商品列表高度
	if (eleListHeight == 0) return;
	commodityHeight = parseFloat(eleListHeight / bdySetting.comLines).toFixed(0); // 餐桌高度
	if (setting.isCommodityImage == 'true' || setting.isCommodityImage == true) {
		if (commodityHeight > 200) commodityHeight = 200;
	} else {
		if (commodityHeight > 150) commodityHeight = 150;
	}
	commodityWidth = parseFloat(100 / bdySetting.comColumns - 0.1).toFixed(2) + '%'; // 餐桌宽度
}
/**
 *@收银台首页
 *@Author: lijy
 *@Date: 2015-03-01
 */
Ext.define('Seller.view.shouyin.SelectCommodity', {
	extend : 'Ext.Panel',
	xtype : 'selectcommodity',
	requires : ['Seller.view.commodity.CommoditySub','Seller.view.commodity.AddCommoditySub', 'Seller.view.commodity.EditCommoditySub', 'Seller.view.shouyin.CommoditySearch', 'Seller.view.commodity.CommodityTypeSub','Seller.view.commodity.AddCommodityTypeSub', 'Seller.view.commodity.EditCommodityTypeSub', 'Seller.view.commodity.SelectCommodityList', 'Seller.view.commodity.EditSelectCommodity', 'Seller.view.commodity.CommodityWeight'],
	parentContainer : null,
	longTimeClickTimeout : null,
	isLongTimeClick : false,
	/**
	 * 点击分类
	 */
	currCommodityTypeId : null,
	//分页工具
	commodityTypePage : new $.PageUtil({
		//limitCount : 8
		limitCount : bdySetting.ctlines===2 ? 16:8 /* 商品分类占两行 */
	}),
	commodityInfoPage : new $.PageUtil({
		limitCount : 15
	}),
	config : {
		id : 'select-commodity-view',
		layout : 'vbox',
		height : '100%',
		items : [{
			xtype : 'container',
			layout : 'hbox',
			// height : commodityTypeLineNums===2?100:50,
			id : 'commodity-type-view',
			items : [{
				xtype : 'container',
				defaults : {
					width : 55,
					xtype : 'container'
				},
				layout : 'vbox',
				items : [{
					xtype: 'button',
					style : 'padding:0',
					// hidden : commodityTypeLineNums===2 ? true : false,
					// id: commodityTypeLineNums===2 ? 'commodityTypePageDown-btn2' : 'commodityTypePageDown-btn',
					id : 'commodityTypePageDown-btn',
					icon: 'resources/icon/public/left.png',
					cls : 'order-margin sy-tm-button jz-center fy-button',
                    handler: function () {},
				}]
			}, {
				xtype : 'dataview',
				id : 'showyin-commoditytype-list',
				flex : 1,
				scrollable : false,
				store : Ext.create('Ext.data.Store', {
					id : 'showyin-commoditytype-store',
					model : 'Seller.model.CommodityType',
					data : []
				}),
				listeners : {

				},
				itemTpl : new Ext.XTemplate('<tpl if="id == 0"><tpl if="Application.Ftype == Application.MASTER"><div class="commodityType"><div class="commoditytype-button sy-tm-button jz-center" onclick="Ext.getCmp(\'select-commodity-view\').addCommodityType(this)"><img class="jz-center" src="resources/icon/public/tianjia.png" /></div></div></tpl><tpl else><div class="commodityType"><div class="commoditytype-button sy-tm-button jz-center" id="commoditytype{id}" onclick="Ext.getCmp(\'select-commodity-view\').commodityTypeClick(this,\'{id}\',\'{name}\')"><tpl if="name.length&gt;6">{[ this.limitName(values.name) ]}<tpl else>{name}</tpl><div class="numdiv"><span class="numspan"></span></div></div></div></tpl>', {
					limitName : function(name) {
						if (!name)
							return '';
						if (name.length > 6) {
							return name.substring(0, 6) + '...';
						} else {
							return name;
						}
					}
				})
				/*itemTpl : ['<tpl if="id == 0"><div class="commodityType"><div class="commoditytype-button sy-tm-button jz-center" onclick="Ext.getCmp(\'select-commodity-view\').addCommodityType(this)"><img class="jz-center" src="resources/icon/public/tianjia.png"></img></div></div><tpl else><div class="commodityType"><div class="commoditytype-button sy-tm-button jz-center" id="commoditytype{id}" onclick="Ext.getCmp(\'select-commodity-view\').commodityTypeClick(this,\'{id}\',\'{name}\')"><tpl if="name.length&gt;6">{this.limitName(name)}...<tpl else>{name}</tpl><div class="numdiv"><span class="numspan"></span></div></div></div></tpl>'].join('')*/
			//}), {
            }, {
				xtype : 'container',
				defaults : {
					width : 55,
					xtype : 'container'
				},
				layout : 'vbox',
				items : [{
					xtype: 'button',
					style : 'padding:0',
					// hidden : commodityTypeLineNums===2 ? false : true,
					// id: commodityTypeLineNums===2 ? 'commodityTypePageDown-btn' : 'commodityTypePageDown-btn2',
					id : 'commodityTypePageDown-btn2',
					icon: 'resources/icon/public/left.png',
					cls : 'order-margin sy-tm-button jz-center fy-button',
                    handler: function () {},
				}, {
                    xtype: 'button',
                    id: 'commodityTypePageUp-btn',
                    icon: 'resources/icon/public/right.png',
					style: 'padding:0',
                    cls : 'order-margin sy-tm-button jz-center fy-button',
                    handler: function () {},
				}]
			}]
		}, {
			xtype : 'container',
			//height : clientHeight - 205,
			flex : 1,
			cls : 'order-padding',
			layout : 'vbox',
			scrollable : false,
			items : [{
				xtype : 'dataview',
				id : 'showyin-commodity-list',
				flex : 1,
				emptyText : Application.Ftype == Application.SLAVE ? '<center><font style="opacity: 0.3; line-height:450px ;font-size: 50px;font-weight: 400;color: #000;">正在获取商品 请稍后……</font></center>' : '',
				scrollable : false,
				store : Ext.create('Ext.data.Store', {
					id : 'showyin-commodity-store',
					model : 'Seller.model.CommodityInfo',
					data : []
				}),
				listeners : {
					/*itemtouchstart : function(view, index, target, record, e, eOpts) {
                        var me = Ext.getCmp('select-commodity-view');
                        me.isLongTimeClick = false;
                        me.longTimeClickTimeout = setTimeout(function() {
                            me.isLongTimeClick = true;
                        }, 1000);
                    },*/
					/*itemtouchend : function(view, index, target, record, e, eOpts) {
						parabolaX=e.pageX;
						parabolaY=e.pageY-30;
						e.stopPropagation();
						e.stopEvent();
						//alert(record.get('define1'));
						var me = Ext.getCmp('select-commodity-view');
						if (me.longTimeClickTimeout) {
							clearTimeout(me.longTimeClickTimeout);
							me.longTimeClickTimeout = null;
						}
						if (record && record.get('id') == 0) {// 添加商品
							Ext.getCmp('select-commodity-view').addCommodity(this, record.get('typeId'));
							return;
						}

						if (me.isLongTimeClick) {
							me.showEditCommodityView(record);
							me.isLongTimeClick = false;
						} else {
							if (Ext.getCmp('shouyinMainView').shouhanMode == '5') {
								showSoldoutPanel(record);
								return;
							} else if (Ext.getCmp('shouyinMainView').shouhanMode == '2') {// 退货模式
							} else if (record.get('soldoutStatus') == '1') {
								if (record.get('soldoutNum') <= 0) {
									return;
								} else if (record.get('remainNum') <= 0) {
									showAlert('提示', '对不起客官, 该商品已经销售一空了!');
									return;
								} else if (record.get('remainNum') < 1) {
								}
							} else if (record.get('status') == '0') {
								showAlert('提示', '抱歉, 已下架!');
								return;
							} else if (record.get('status') == '2') {
								showAlert('提示', '抱歉, 已经卖完了!');
								return;
							}
							var parentContainer = Ext.getCmp('select-commodity-view').parentContainer;
							if (parentContainer && record.get('id') != '0') {
								var isSupportNorms = record.get("isSupportNorms");
								if (isSupportNorms == "1") {
									me.showNormsView(record);
								} else {
									me.optCommodityForNeed(record);
								}
							}
						}

						if (monitors == 2) {
							if (record.get('soldoutStatus') != '1')
								sendMsg2SetCommodityImg(record.get('name'), record.get('price'), record.get('define1'));
						}
					}*/
				},
				//itemTpl : ['<tpl if="id == 0"><div class="sp-dataview"><div class="addcomimg"></div></div><tpl else> <div class="sp-dataview"><div class="cent"><div class="select{define4} soldout{soldoutStatus}"></div><div class="commodityname"><p>{name}</p></div><div><span id="commodity{id}" class="text-overflow">￥{price}</span></div></div></div></tpl>'].join('')
				itemTpl : ['<tpl if="id == 0"><tpl if="Application.Ftype == Application.MASTER"><div class="sp-dataview"><div class="addcomimg"></div></div></tpl><tpl else> <div class="sp-dataview"><div class="cent"><div class=\"select{define4}', ' <tpl if="soldoutStatus==\'1\'&&(!soldoutNum||soldoutNum<=0)">soldout1<tpl else>soldout0</tpl>\"></div><div class="commodityname"><p>{name}</p></div><div><span id="commodity{id}" class="text-overflow">￥{price}</span></div></div></div></tpl>'].join('')
			}]/*,
            listeners : {
                painted : function() {
                    var x1, x2, y1, y2, x, y;
                    $('#showyin-commodity-list').mousedown(function () {
                        x1 = window.event.clientX;
                        y1 = window.event.clientY;
                    });
                    $('#showyin-commodity-list').mouseup(function () {
                        x2 = window.event.clientX;
                        y2 = window.event.clientY;
                        x = x2 - x1;
                        y = y2 - y1;
                        if (Math.abs(x) > 1.414 * Math.abs(y) && Math.abs(x) > 150) {
                            if (x < 0) {
                                Ext.getCmp('select-commodity-view').upCommodity();
                                return;
                            } else if (x > 0) {
                                Ext.getCmp('select-commodity-view').downCommodity();
                                return;
                            }
                            return;
                        }
                    });
                }
            }*/
		}, /*{
            xtype : 'container',
            width : '100%',
            style : 'background:transparent;box-shadow:none;',
            centered : true,
            id : 'no-commodity-label',
            hidden : true,
            html : '<center><font style="opacity: 0.3; line-height:240px ;font-size: 50px;font-weight: 400;color: #000;">该商品分类下无商品！</font></center>'
        }, */{
			xtype : 'container',
			height : bdySetting.ctlines===2 ? 54 : 60,
			padding : bdySetting.ctlines===2 ? '5 5' : '9 5',
			defaults : {
				xtype : 'container',
				height : bdySetting.ctlines===2 ? 54 : 60
			},
			layout : 'hbox',
			items : [
			{
				xtype : 'container',
				//width : 254,
				width : 280,
				cls : 'sousuo jz-center',
				id : 'search',
				listeners : {
					/*keyup : function(filed, e, eOpts) {
					 if (event && event.keyCode == 13) {
					 showSearch();
					 var key = Ext.getCmp('search').getValue();
					 if (key) {
					 Ext.getCmp('search_view').query(key);
					 }
					 }
					 }*/
				}
			},
			{
				xtype: 'fieldset',
				layout: 'hbox',
				cls: 'search-fieldset',
				height: 42,
				hidden: true,
				style: 'margin-top:0;background:transparent!important;border-radius: 28px;border: 1px solid rgb(255,255,255);',
				items:[
					{
						xtype : 'textfield',
						//width : 254,
						width : 230,
						height:42,
						cls : 'sousuo jz-center',
						id : 'search',
						placeHolder: '搜索宝贝',
						style: 'padding-left:36px;color:#fff;',
						listeners : {
							keyup : function(filed, e, eOpts) {
								/*if (event && event.keyCode == 13) {
								 showSearch();//打开搜索结果面板
								 var key = Ext.getCmp('search').getValue();
								 if (key) {
								 Ext.getCmp('search_view').query(key);
								 }
								 }*/
								//按下确认键搜索宝贝
								if (event && event.keyCode == 13) {
									var newValue = Ext.getCmp('search').getValue();
									if(!newValue){
										return;
									}
									window.commoditySearchCallbackO = {};
									var isQueryPinyinCode = false;
									for(var cbKey in window.commoditySearchCallbackO) {
										if(window.commoditySearchCallbackO.hasOwnProperty(cbKey)) {
											window.commoditySearchCallbackO[cbKey] = null;
											delete window.commoditySearchCallbackO[cbKey];
										}
									}
									var callbackName = 'csCallback' + new Date().getTime();
									window.commoditySearchCallbackO[callbackName] = function(success, res) {
										//if(window.isInputBarCode) window.isInputBarCode = false;
										//console.log(res);
										//console.log(callbackName);
										//console.log(commoditySearchCallbackO);
										if(!(callbackName in commoditySearchCallbackO)) return;
										if(!success || !res || res.length <= 0) {
											if(isQueryPinyinCode) {
												isQueryPinyinCode = false;
												CommodityDao.loadCommodityInfoByPinyinCode(newValue, window.commoditySearchCallbackO[callbackName]);
											} else {
												$("#search-commodity-size")[0].innerHTML = '0';
											}
										}

										if(res.length === 1){
											var id = res[0].id;
											var storeEmpty;
											var selectCommodityView = Ext.getCmp('select-commodity-view');
											var showyinCommodityStore = Ext.getStore('showyin-commodity-store');
											if(!showyinCommodityStore.findRecord("id", id)){
												storeEmpty = true;
												showyinCommodityStore.add(res[0]);
											}
											var record = showyinCommodityStore.findRecord("id", id);
											if(storeEmpty){
												showyinCommodityStore.remove(record);
											}
											if (Ext.getCmp('shouyinMainView').shouhanMode == '5') {
												showSoldoutPanel(record);
												return;
											} else if (Ext.getCmp('shouyinMainView').shouhanMode == '2') {// 退货模式
											} else if (record.get('soldoutStatus') == '1') {
												if (record.get('soldoutNum') <= 0) {
													return;
												} else if (record.get('remainNum') <= 0) {
													showAlert('提示', '对不起客官, 该商品已经销售一空了!');
													return;
												} else if (record.get('remainNum') < 1) {
												}
											} else if (record.get('status') == '0') {
												showAlert('提示', '抱歉, 已下架!');
												return;
											} else if (record.get('status') == '2') {
												showAlert('提示', '抱歉, 已经卖完了!');
												return;
											}
											var parentContainer = Ext.getCmp('select-commodity-view').parentContainer;
											if (parentContainer && record.get('id') != '0') {
												var isSupportNorms = record.get("isSupportNorms");
												if (isSupportNorms == "1") {
													selectCommodityView.showNormsView(record);
												} else {
													/*record.set({'unit':'KG'});*/
													//称重商品
													if(record.get('isWeight') === '1') {
														//启动电子秤
														if(elebalanceSetting.isLaunchElebalance === 'T'){
															launchElebalance(record);
														}else if(elebalanceSetting.isLaunchElebalance === 'F'){//禁用电子秤操作

															// var commodityWeightView = addViewportCenter('commodityWeightView', 'commodityweight', 500, 300, true);
															// showBy(commodityWeightView,Ext.getCmp('shouyinMainView'));
															showCommodityWeightView();

															var commodityWeightContent = Ext.getCmp('commodityweight-view');
															var weightName =  Ext.getCmp('weight-name');
															var weightprice = Ext.getCmp('weight-price');
															var commodityWeight = Ext.getCmp('commodity-weight');

															commodityWeight.setValue('');
															commodityWeight.setReadOnly(false);
															commodityWeight.setPlaceHolder('请输入商品重量');
															weightName.setValue(record.get('name'));
															weightprice.setValue(record.get('price'));

															//将数据存进组件
															commodityWeightContent.setData(record);

														}
													}//禁用电子秤
													else {
														//添加商品
														selectCommodityView.optCommodityForNeed(record);
													}
													Ext.getCmp('search').setValue('');//清空搜索框的值
												}
											}

											if (monitors == 2) {
												if (record.get('soldoutStatus') != '1')
													sendMsg2SetCommodityImg(record.get('name'), record.get('price'), record.get('define1'));
											}
											/*if(storeEmpty){
											 showyinCommodityStore.remove(record);
											 }*/
											return
										}

										showSearch();//打开搜索结果面板
										Ext.getCmp('commoditySearchField').setValue(newValue);//同步搜索框的值
										fillCommoditySearch(res);//填充到结果列表.
									};
									if (newValue) {
										if(checkNumber(newValue)) { // 纯数字为条码
											if(window.isInputBarCode) {
												CommodityDao.loadCommodityInfoByBarCode(newValue, window.commoditySearchCallbackO[callbackName]);
											} else {
												isQueryPinyinCode = true;
												CommodityDao.loadCommodityInfoByBarCode(newValue, window.commoditySearchCallbackO[callbackName]);
											}
										} else {
											CommodityDao.loadCommodityInfoByPinyinCode(newValue, window.commoditySearchCallbackO[callbackName]);
										}
									}
								}
							}
						}
					},
					{
						xtype: 'ebutton',
						width: 60,
						height: 42,
						id: 'search-keyboard',
						cls: 'icon-keyboard',
						style: 'line-height:42px;margin-top:-10px;margin-right:10px;font-size: 30px;color:#fff;background:transparent;border:none;'

					}
				]
			},
            {
				xtype : 'spacer'
			}, {
				xtype: 'button',
				width : 80,
				height : 42,
				id: 'commodityPageDown-btn',
				cls : 'jz-center sy-tm-button',
                icon: 'resources/icon/public/left.png',
				handler : function(){}
			}, {
				xtype : 'label',
				width : 164,
				height : '100%',
				cls : 'jz-center',
				id : 'sy-total-label',
				html : '1/1'
			}, {
				xtype: 'button',
				width : 80,
				height : 42,
				id: 'commodityPageUp-btn',
				//margin : '5px 10px',
				cls : 'jz-center sy-tm-button',
				icon: 'resources/icon/public/right.png',
                handler : function() {
                }
			}]
		}]
	},
	initialize : function(panel, eOpts) {
		setTimeout(checkLoadData(true), 3000);
		/*取消搜索框点击搜索弹框*/
		setTimeout(function() {
			$("#search").click(function() {
				if (Ext.getCmp("shouyinMainView").shouhanMode == 5) {
					return;
				}
				showSearch();
			});
		}, 200);
	},
	optCommodityCombo : function(record, callback) {
		if(record.get('category') == '2') { // 套餐
			var comboMealsJson = record.get('comboMealsJson'); // [{"id":"cm2017062313481073539495436","comboId":"C2017062313481666175710191","commodityPrice":2.0,"commodityName":"c-1","commodityId":"C2017062313371883463650018","commodityNum":1.00,"sumAmount":2.0,"normName":"","sellerId":"S170508135429172717269"},{"id":"cm2017062313481456644006251","comboId":"C2017062313481666175710191","commodityPrice":2.0,"commodityName":"c-2的在国地顺的煌困以有3在要以","commodityId":"C201706231337260004988018019","commodityNum":1.00,"sumAmount":2.0,"normName":"","sellerId":"S170508135429172717269"},{"id":"cm2017062313483232048737785","comboId":"C2017062313481666175710191","commodityPrice":4.0,"commodityName":"c-4","commodityId":"C2017062313373930696623781","commodityNum":1.00,"sumAmount":4.0,"normName":"","sellerId":"S170508135429172717269"}]
			if(!comboMealsJson) {callback && callback(true);}
			var comboMeals = Ext.JSON.decode(comboMealsJson);
			var ids = [];
			for(var idx=0,idlen=comboMeals.length;idx<idlen;idx++) {
				ids.push("\'" + comboMeals[idx].commodityId + "\'");
			}
			CommodityDao.loadCommodityInfoByIds(ids, function(success, commInfo) {
				if(!success || !commInfo || commInfo.length <= 0) {callback && callback(true); return;}
				for(var ci=0,clen=commInfo.length;ci<clen;ci++) {
					if(commInfo[ci].soldoutStatus == '1' && commInfo[ci].soldoutNum <= 0) {
						//showAlert('提示', '<span style="color:red;">' + commInfo[ci].name + '&nbsp;&nbsp;商品不足</span>');
						showAlertWithWH('提示', '<span style="color:red;">' + commInfo[ci].name + '&nbsp;&nbsp;<br>商品不足</span>', 300, 200);
						callback && callback(false);
						return;
					}
				}
				callback && callback(true);
			});
		} else {
			callback && callback(true);
		}
	},
	optCommodityForNeed : function(record, normsName, normsPrice) {// 按需操作商品
		var me = this;
		if (record.get('isTimePrice') == '1') {// 时价菜
			me.showTimePriceView(record, normsName, normsPrice);
		} else {
			me.optCommodityCombo(record, function(success) {
				if(!success) return;
				//if(isClickSoldout) { // 沽清商品
				if (record.get('soldoutStatus') == '1' && record.get('soldoutNum') > 0 && record.get('remainNum') > 0) {
					me.optCommodityForSoldout(record);
				}
				me.parentContainer.addCommodity(record, normsName, normsPrice);
			});
		}
	},
	optCommodityForSoldout : function(record) {// 沽清商品操作
		var remainNum = parseFloat(record.get('remainNum'));
		var soldoutNum = parseFloat(record.get('soldoutNum'));
		if (!remainNum && remainNum != 0) {
			record.set('define3', soldoutNum);
			if (soldoutNum < 1 && soldoutNum > 0) {
				record.set('remainNum', 0);
			} else {
				record.set('remainNum', parseFloat(soldoutNum - 1).toFixed(2));
			}
		} else {
			record.set('define3', remainNum);
			if (remainNum > 0 && remainNum < 1) {
				record.set('remainNum', 0);
			} else {
				record.set('remainNum', parseFloat(remainNum - 1).toFixed(2));
			}
		}
	},
	showTimePriceView : function(record, normsName, normsPrice) {
		showTimePriceView(record, normsName, normsPrice);

		
		return;
		if (!record)
			return;
		var me = this;
		var timePriceView = null;
		var name = normsName ? record.get('name') + '(' + normsName + ')' : record.get('name');
		var price = normsPrice ? normsPrice : record.get('price');
		if (Ext.getCmp('id-time-price-view')) {
			Ext.getCmp('id-time-price-view').show();
			return;
		}
		var soldoutStatus = record.get('soldoutStatus');
		var soldoutNum = parseFloat(record.get('soldoutNum'));
		var remainNum = parseFloat(record.get('remainNum'));
		var isClickSoldout = false;
		if (soldoutStatus == '1' && soldoutNum > 0 && remainNum > 0) {
			isClickSoldout = true;
		}
		timePriceView = Ext.Viewport.add({
			xtype : 'panel',
			id : 'id-time-price-view',
			layout : 'vbox',
			width : 360,
			height : 200,
			modal : true,
			centered : true,
			hideOnMaskTap : false,
			items : [{
				xtype : 'toolbar',
				title : name, //'时价菜设置',
				docked : 'top',
				items : [getDefaultToolbarLeftViewForHandler(function() {
					if (Ext.getCmp('id-time-price-view'))
						Ext.getCmp('id-time-price-view').destroy();
				}), {
					xtype : 'button',
					cls : 'close-button',
					hidden : true,
					handler : function() {
						if (Ext.getCmp('id-time-price-view'))
							Ext.getCmp('id-time-price-view').destroy();
					}
				}, {
					xtype : 'spacer'
				}, {
					xtype : 'button',
					cls : 'sy-tm-button',
					text : '确定',
					handler : function() {
						var timePriceCommPrice = Ext.getCmp('id-time-price-commodity-price').getValue();
						var timePriceCommNum = Ext.getCmp('id-time-price-commodity-num').getValue();
						if (!timePriceCommPrice) {
							showAlert('提示', '请输入商品时价!');
							return;
						} else if (!checkPositiveNumber(timePriceCommPrice)) {
							showAlert('提示', '请输入商品时价的正确格式!');
							return;
						}
						if (!timePriceCommNum) {
							showAlert('提示', '请输入商品数量!');
							return;
						} else if (!checkPositiveNumber(timePriceCommNum)) {
							showAlert('提示', '请输入商品数量的正确格式!');
							return;
						}

						if (Ext.getCmp('shouyinMainView').shouhanMode == '2') {
						} else {
							if (isClickSoldout) {
								if ((remainNum || soldoutNum) && timePriceCommNum > remainNum) {
									if (Ext.getCmp('shouyinMainView').shouhanMode != '2') {
										showCommoditySoldout({
											name : name
										});
										return;
									}
								}
								if (!remainNum && remainNum != 0) {
									record.set('remainNum', parseFloat(soldoutNum - timePriceCommNum).toFixed(2));
								} else
									record.set('remainNum', parseFloat(remainNum - timePriceCommNum).toFixed(2));
							}
						}
						var copyRecord = record.copy(record.get('id'));
						copyRecord.set('price', timePriceCommPrice);
						//copyRecord.set('sellNum', timePriceCommNum);
						copyRecord.set('sellCommNum', timePriceCommNum);
						var updateCommData = null;
						if (normsName && normsPrice >= 0) {
							if (record.get('price') == normsPrice && record.get('price') != timePriceCommPrice) {
								record.set('price', timePriceCommPrice);
								if (!updateCommData)
									updateCommData = {};
								updateCommData.price = timePriceCommPrice;
							}
							var normsPriceArray = ['1', '2', '3', '4', '5', '6', '7', '8'];
							for (var ni = 0, nlen = normsPriceArray.length; ni < nlen; ni++) {
								var normsPriceTxt = 'normsPrice' + normsPriceArray[ni];
								var normsPriceVal = record.get(normsPriceTxt);
								if (normsPriceVal == normsPrice && normsPriceVal != timePriceCommPrice) {
									// (规格大小)修改之后的价格与之前的价格不同
									record.set(normsPriceTxt, timePriceCommPrice);
									if (!updateCommData)
										updateCommData = {};
									updateCommData[normsPriceTxt] = timePriceCommPrice;
									break;
								}
							}
						} else {
							if (price != timePriceCommPrice) {
								record.set('price', timePriceCommPrice);
								if (!updateCommData)
									updateCommData = {};
								updateCommData.price = timePriceCommPrice;
							}
						}
						if (updateCommData) {
							updateCommData.syned = '0';
							CommodityDao.updateCommodity(updateCommData, record.get('id'), function(success) {
								sendCommodityUpdate();
							});
						}
						me.parentContainer.addCommodity(copyRecord, normsName, timePriceCommPrice);
						if (Ext.getCmp('id-time-price-view'))
							Ext.getCmp('id-time-price-view').destroy();
					}
				}]
			}, {
				xtype : 'container',
				layout : 'vbox',
				flex : 1,
				items : [{
					xtype : 'fieldset',
					margin : '5 5 5 5',
					flex : 1,
					defaults : {
						labelWidth : 130
					},
					items : [{
						xtype : 'textfield',
						label : '商品名称',
						value : name,
						hidden : true,
						id : 'id-time-price-commodity-name',
						name : 'commodityName',
						readOnly : true
					}, {
						xtype : 'numberfield',
						label : '单价',
						placeHolder : '最多两位小数',
						name : 'commodityPrice',
						id : 'id-time-price-commodity-price',
						value : price,
					}, {
						xtype : 'numberfield',
						label : '数量',
						placeHolder : '最多两位小数',
						name : 'commodityNum',
						id : 'id-time-price-commodity-num',
						value : 1
					}]
				}]
			}, {
				xtype : 'formpanel',
				hidden : true,
				id : 'time-price-form-panel',
				flex : 1,
				items : [{
					xtype : 'fieldset',
					margin : '0 0 0 0',
					instructions : '',
					flex : 1,
					defaults : {
						labelWidth : 130
					},
					items : [{
						xtype : 'textfield',
						label : '商品名称',
						value : record.get('name'),
						name : 'commodityName',
						readonly : true,
					}, {
						xtype : 'textfield',
						label : '商品价格',
						name : 'commodityPrice',
						value : record.get('price'),
					}, {
						xtype : 'numberfield',
						label : '商口数量',
						name : 'commodityNum',
						value : 1
					}]
				}]
			}]
		});
		timePriceView.show();
	},
	showNormsView : function(record) {// 显示规格
		var me = this;
		var normsView = Ext.getCmp('normsView');
		if (!normsView)
			normsView = Ext.Viewport.add(Ext.create('Seller.view.shouyin.CommodityNorms'));
		showBy(normsView, Ext.getCmp('shouyinMainView'));
		normsView.setData(record);
	},
	showEditCommodityView : function(record) {
		if (Ext.getCmp('optCommodityView')) {
			Ext.getCmp('optCommodityView').show();
		} else {
		    // var editCommodityView = addViewportCenter('editCommodityView', 'editcommoditysub', 550, 320, true);
			var editCommodityView = addViewportCenter('optCommodityView', 'commoditysub', 550, 320, true);
			showBy(editCommodityView, Ext.getCmp('shouyinMainView'));
			Ext.getCmp('commodity-view').setParentContainer(editCommodityView);
		}
		Ext.getCmp('commodity-view').setEditData();
		Ext.getCmp('commodity-view').typeId = record.get('typeId');
		Ext.getCmp('commodity-view').setRecord(record);
	},
	setItemTpl : function(isCommodityImage) {
		addCommImageTpl2 = '<div class="sp-dataview2" style="width:' + commodityWidth + ';height:' + commodityHeight + 'px;">' +
				'<div class="sp-dataview2-shadow">' +
					'<div class="addcomimg"></div>' +
				'</div>' +
			'</div>';
		commNoImageTpl = '';
		frontSpecialCss = 'position:absolute;width:50%;left:50%;bottom:3px;';
		frontSpecialPrice = 'float:right;text-decoration:line-through;margin:0 5px;color:white;display:inline-block;text-align:center;line-height:22px;width:40%;';
		frontSpecialWord = 'position:relative;float:right;background-color:red;color:white;height:22px;width:22px;line-height:22px;border-radius:50%;text-align:center;display:inline-block;';
		frontSpecialWord2 = 'position:relative;float:right;margin:0px 8px 0px 0px;background-color:red;color:white;height:22px;width:22px;line-height:22px;border-radius:50%;text-align:center;display:inline-block;';
		soldoutWord = 'background:rgba(60,60,60,0.3);color:white;width:55px;border-radius:20px;text-align:center;';
		/* (有图模式)有图-特价菜与沽清 */
		specialSoldoutTpl = '<tpl if="isSpecialPrice==1">' +
			'<tpl if="isFrontSpecial==\'1\'">' +
				'<div style="' + frontSpecialCss + '">' +
					'<div id="commodity{id}" style="' + frontSpecialPrice + '">￥{price}</div>' +
					'<div style="' + frontSpecialWord + '" class="jz-center">特</div>' +
				'</div>' +
			'<tpl else>' +
				'<div style="' + frontSpecialCss + '">' +
					'<div style="' + frontSpecialWord2 + '" class="jz-center">特</div>' +
				'</div>' +
			'</tpl>' +
		'</tpl>' +
		'<tpl if="soldoutStatus==\'1\'&&(soldoutNum<=0||soldoutNum<0.01)">' +
			'<div class="select{define4} soldout1"></div>' +
		'<tpl elseif="soldoutStatus==\'1\'">' +
			'<div class="select{define4} soldout0"></div>' +
			'<tpl if="!remainNum && remainNum!=0"><tpl else>' +
				'<div class="remainContainer' + ' <tpl if="isHideSoldout==\'1\'">hideE</tpl>' + '">' +
					'<div class="remainStatus" style="' + soldoutWord + '">剩 {remainNum}</div>' +
				'</div>' +
			'</tpl>' +
		'<tpl else>' +
			'<div class="select{define4} soldout0"></div>' +
		'</tpl>';
		
		/* (有图模式)默认图-特价菜与沽清 */
		var specialSoldoutNotImgTpl = '<tpl if="isSpecialPrice==1">' +
			'<tpl if="isFrontSpecial==1">' +
				'<div style="position:absolute;width:50%;left:50%;bottom:3px;">' +
				    '<div id="commodity{id}" style="float:right;text-decoration:line-through;margin:0 5px;color:white;display:inline-block;text-align:center;line-height:22px;width:40%;">￥{price}</div>' +
				    '<div style="position:relative;float:right;background-color:red;color:white;height:22px;width:22px;line-height:22px;border-radius:50%;text-align:center;display:inline-block;" class="jz-center">特</div>' +
				'</div>' +
			'<tpl else>' +
				'<div style="position:absolute;width:50%;left:50%;bottom:3px;">' +
				    '<div style="position:relative;float:right;margin:0px 8px 0px 0px;background-color:red;color:white;height:22px;width:22px;line-height:22px;border-radius:50%;text-align:center;display:inline-block;" class="jz-center">特</div>' +
				'</div>' +
			'</tpl>' +
		'</tpl>' +
		'<tpl if="soldoutStatus==\'1\'&&(soldoutNum<=0||soldoutNum<0.01)">' +
			'<div class="select{define4} soldout1"></div>' +
		'<tpl elseif="soldoutStatus==\'1\'">' +
			'<div class="select{define4} soldout0"></div>' +
			'<tpl if="!remainNum && remainNum!=0"><tpl else>' +
				'<div class="remainContainer' + ' <tpl if="isHideSoldout==\'1\'">hideE</tpl>' + '">' +
				    '<div class="remainStatus" style="background:rgba(60,60,60,0.3);color:white;width:55px;border-radius:20px;text-align:center;">剩 {remainNum}</div>' +
				'</div>' +
			'</tpl>' +
		'<tpl else>' +
			'<div class="select{define4} soldout0"></div>' +
		'</tpl>';
		var specialSoldoutNotImgTpl2 = '<tpl if="isSpecialPrice==\'1\'">' +
			'<tpl if="isFrontSpecial==\'1\'">' +
				'<div class="cent special">' +
					'<div class="commodityname special">' +
						'<p class="text-overflow" title="{name}">{name}</p>' +
					'</div>' +
					'<div><span id="commodity{id}" class="special">￥{specialPrice}</span>' +
					'</div>' +
				'</div>' +
			'<tpl else>' +
				'<div class="cent">' +
					'<div class="commodityname">' +
						'<p class="text-overflow" title="{name}">{name}</p>' +
					'</div>' +
					'<div><span id="commodity{id}">￥{price}</span></div>' +
				'</div>' +
			'</tpl>' +
		'<tpl else>' +
			'<div class="cent">' +
			'<div class="commodityname">' +
				'<p class="text-overflow" title="{name}">{name}</p>' +
			'</div>' +
			'<div><span id="commodity{id}">￥{price}</span></div>' +
			'</div>' +
		'</tpl>';
		//商口外框
		commImageBorderTpl = '<div class="sp-dataview2" style="width:' + commodityWidth + ';height:' + commodityHeight + 'px;font-size:' + bdySetting.comFontSize + 'px;">' +
				'<div class="sp-dataview2-shadow">' +
					'<div class="pic picborder">' +
						'<tpl if="define1==\'\'"><tpl else>' + '<img src="{define1}">' + '</tpl>' +
						'<div id="cent-{id}" class="cent">' +
							specialSoldoutTpl +
						'</div>' +
                        '<div class="' + '<tpl if="isWeight!==\'1\'">hideE</tpl>' + '">' +
                              '<div class="commodity-of-weight" style="width: 35px;height: 40px;position: absolute;left: 0px;top: -1px;background: url(./resources/icon/public/commodityofweight.png) no-repeat;"></div>' +
                        '</div>' +
                        '<div class="' + '<tpl if="isTimePrice!==\'1\' && isTimePrice!==true">hideE</tpl>' + '">' +
                              '<div class="commodity-of-time" style="width: 35px;height: 40px;position: absolute;left: 0px;top: 0px;background: url(./resources/icon/public/isTimePrice.png) no-repeat;"></div>' +
                        '</div>' +
					'</div>' +
					specialSoldoutNotImgTpl2 +
				'</div>' +
			'</div>';
		if(isCommodityImage) {
			// if(isAndroidSys() && clientHeight<=600) this.commodityInfoPage.setLimitCount(10);
			// else this.commodityInfoPage.setLimitCount(15);
			Ext.getCmp('showyin-commodity-list').setItemTpl(['<tpl if="id == 0"><tpl if="Application.Ftype == Application.MASTER">'+ addCommImageTpl2 + '</tpl><tpl else>' + commImageBorderTpl + '</tpl>']);
		} else {
            // if(isAndroidSys() && clientHeight<=600) this.commodityInfoPage.setLimitCount(commodityTypeLineNums===2 ? 24:32);
			// else this.commodityInfoPage.setLimitCount(commodityTypeLineNums===2 ? 40:48);
			var noImgItemTpl = '' + 
			'<tpl if="id == 0"><tpl if="Application.Ftype == Application.MASTER">' +
				'<div class="sp-dataview" style="width:' + commodityWidth + ';height:' + commodityHeight + 'px;">' +
					'<div class="cent">' +
						'<div class="addcomimg"></div>' +
					'</div>' +
				'</div>' +
			'</tpl><tpl else>' +
				'<div class="sp-dataview" style="width:' + commodityWidth + ';height:' + commodityHeight + 'px;font-size:' + bdySetting.comFontSize + 'px;">' +
					'<div id="cent-{id}" class="cent">' +
	                     '<tpl if="isSpecialPrice==\'1\'">' +
	                         '<div class="commodityname">' +  // jz-center
	                         	'<tpl if="soldoutStatus==\'1\'&&(soldoutNum<=0||soldoutNum<0.01)">' +
	                         		'<tpl if="isFrontSpecial==\'1\'">' +
	                         			'<div class="specialStatus2"><div class="specialprice">￥{price}</div></div>' +
	                         		'</tpl>' +
	                             '<tpl elseif="soldoutStatus==\'1\'">' +
	                             	'<tpl if="isFrontSpecial==\'1\'">' +
	                             		'<div class="specialStatus2"><div class="specialprice">￥{price}</div></div>' +
	                             	'</tpl>' +
	                                 '<tpl if="!remainNum && remainNum!=0"><tpl else>' +
	                                     '<div class="remainStatus2 jz-center"><div class="remain">剩 {remainNum}</div></div>' +
	                                 '</tpl>' +
	                             '<tpl else>' +
	                                '<tpl if="isFrontSpecial==\'1\'">' +
		                          		'<div class="specialStatus2"><div class="specialprice">￥{price}</div></div>' +
		                          	'</tpl>' +
	                             '</tpl>' +
	                             '<div style="width:100%;height:100%;">' + /*class="jz-center" */
	                                 '<p>{[this.limitName(values.name)]}</p>' +
	                             '</div>' +
	                         '</div>' +
	                         '<tpl if="isFrontSpecial==\'1\'">' + 
	                         	'<span id="commodity{id}" class="jz-center"><span class="special">特</span>￥{specialPrice}</span>' +
	                         '<tpl else>' +
	                         	'<span id="commodity{id}" class="jz-center"><span class="special">特</span>￥{price}</span>' +
	                         '</tpl>' +
	                     '<tpl elseif="soldoutStatus==\'1\'&&(soldoutNum<=0||soldoutNum<0.01)">' +
			                    '<div class="commodityname">' + /* jz-center */
			                        '<p>{[this.limitName(values.name)]}</p>' +
			                    '</div>' +
			                    '<span id="commodity{id}" class="jz-center">￥{price}</span>' +
	                     '<tpl elseif="soldoutStatus==\'1\'">' +
	                         '<div class="commodityname">' +
	                             '<tpl if="!remainNum && remainNum!=0"><tpl else>' +
	                                 '<div class="remainStatusCenter"><div class="remain">剩 {remainNum}</div></div>' +
	                             '</tpl>' +
	                             '<div style="width:100%;height:100%;">' + /*class="jz-center" */
	                                 '<p>{[this.limitName(values.name)]}</p>' +
	                             '</div>' +
	                         '</div>' +
	                         '<span id="commodity{id}" class="jz-center">￥{price}</span>' +
	                     '<tpl else>' +
	                         '<div class="commodityname jz-center">' +
	                             '<p>{[this.limitName(values.name)]}</p>' +
	                         '</div>' +
	                         '<span id="commodity{id}" class="jz-center">￥{price}</span>' +
	                     '</tpl>' +
						'<tpl if="soldoutStatus==\'1\'&&(soldoutNum<=0||soldoutNum<0.01)">' +
							'<div class="select{define4} soldout1"></div>' +
						'<tpl elseif="soldoutStatus==\'1\'">' +
							'<div class="select{define4} soldout0"></div>' +
						'<tpl else>' +
							'<div class="select{define4} soldout0"></div>' +
						'</tpl>' +
                        '<div class="' + '<tpl if="isWeight!==\'1\'">hideE</tpl>' + '">' +
                              '<div class="commodity-of-weight" style="width: 35px;height: 40px;position: absolute;left: 0px;top: -1px;background: url(./resources/icon/public/commodityofweight.png) no-repeat;"></div>' +
                        '</div>' +
                        '<div class="' + '<tpl if="isTimePrice!==\'1\' && isTimePrice!==true">hideE</tpl>' + '">' +
                              '<div class="commodity-of-time" style="width: 35px;height: 40px;position: absolute;left: 0px;top: 0px;background: url(./resources/icon/public/isTimePrice.png) no-repeat;"></div>' +
                        '</div>' +
					'</div>' +
				'</div>' +
			'</tpl>';
			Ext.getCmp('showyin-commodity-list').setItemTpl(new Ext.XTemplate(noImgItemTpl, {
				limitName : function(name) {
					if(!name) return '';
					return this.strEllipsis(name);
				},
				strEllipsis : function(name) {
					var nlen = name.length;
					var charCount = 0;
					for(var ni=0; ni<nlen; ni++) {// 20个字符
						var charCode = name.charCodeAt(ni);
						if(charCode >= 19968 && charCode <= 40869) {
							charCount += 2;
						} else {
							charCount += 1;
						}
						if(charCount > 20) {
							return name.substring(0, ni-1) + '...';
						}
					}
					return name;
				}
			}));
		}
	},
	setItemTpl2 : function(isCommodityImage) {
		if (isCommodityImage) {
			//Ext.getCmp('showyin-commodity-list').setItemTpl(['<tpl if="id == 0"><div class="sp-dataview2"><div class="sp-dataview2-shadow"><div class="addcomimg"></div></div></div><tpl else><tpl if="define1==\'\'"><div class="sp-dataview2"><div class="sp-dataview2-shadow"><div class="pic picborder"><div class="cent"><div class="select{define4} soldout{soldoutStatus}"></div></div></div><div class="cent"><div class="commodityname"><p class="text-overflow" title="{name}">{name}</p></div><div><span id="commodity{id}">￥{price}</span></div></div></div></div><tpl else><div class="sp-dataview2"><div class="sp-dataview2-shadow"><div class="pic picborder"><img src="{define1}"><div class="select{define4} soldout{soldoutStatus}"></div></div><div class="cent"><div class="commodityname"><p class="text-overflow">{name}</p></div><div><span id="commodity{id}">￥{price}</span></div></div></div></div></tpl></tpl>'].join(''));
			//Ext.getCmp('showyin-commodity-list').setItemTpl(['<tpl if="id == 0"><div class="sp-dataview2"><div class="sp-dataview2-shadow"><div class="addcomimg"></div></div></div><tpl else><tpl if="define1==\'\'"><div class="sp-dataview2"><div class="sp-dataview2-shadow"><div class="pic picborder"><div class="cent"><div class=\"select{define4} ','<tpl if="soldoutStatus==\'1\'&&(!soldoutNum||soldoutNum<=0)">soldout1<tpl else>soldout0</tpl>\"></div><tpl if="soldoutStatus==\'1\'"><tpl if="!remainNum && remainNum!=0"><tpl else><div class="remainStatus">剩余 {remainNum}</div></tpl></tpl></div></div><div class="cent"><div class="commodityname"><p class="text-overflow" title="{name}">{name}</p></div><div><span id="commodity{id}">￥{price}</span></div></div></div></div><tpl else><div class="sp-dataview2"><div class="sp-dataview2-shadow"><div class="pic picborder"><img src="{define1}"><div class="select{define4} soldout{soldoutStatus}"></div></div><div class="cent"><div class="commodityname"><p class="text-overflow">{name}</p></div><div><span id="commodity{id}">￥{price}</span></div></div></div></div></tpl></tpl>'].join(''));
			// 时价菜设置, 沽清设置
			//Ext.getCmp('showyin-commodity-list').setItemTpl(['<tpl if="id == 0"><div class="sp-dataview2"><div class="sp-dataview2-shadow"><div class="addcomimg"></div></div></div><tpl else><tpl if="define1==\'\'"><div class="sp-dataview2"><div class="sp-dataview2-shadow"><div class="pic picborder"><div class="cent"><tpl if="soldoutStatus==\'1\'&&(!soldoutNum&&soldoutNum<=0)"><div class="select{define4} soldout1"></div><tpl elseif="soldoutStatus==\'1\'"><div class="select{define4} soldout0"></div><tpl if="!remainNum && remainNum!=0"><tpl else><div class="remainStatus">剩余 {remainNum}</div></tpl><tpl else><div class="select{define4} soldout0"></div></tpl></div></div><div class="cent"><div class="commodityname"><p class="text-overflow" title="{name}">{name}</p></div><div><span id="commodity{id}">￥{price}</span></div></div></div></div><tpl else><div class="sp-dataview2"><div class="sp-dataview2-shadow"><div class="pic picborder"><img src="{define1}"><div class="select{define4} soldout{soldoutStatus}"></div></div><div class="cent"><div class="commodityname"><p class="text-overflow">{name}</p></div><div><span id="commodity{id}">￥{price}</span></div></div></div></div></tpl></tpl>'].join(''));
			//Ext.getCmp('showyin-commodity-list').setItemTpl(['<tpl if="id == 0"><div class="sp-dataview2"><div class="sp-dataview2-shadow"><div class="addcomimg"></div></div></div><tpl else><tpl if="define1==\'\'"><div class="sp-dataview2"><div class="sp-dataview2-shadow"><div class="pic picborder"><div class="cent"><tpl if="isSpecialPrice==1"><div style="margin:0px 5px 0px;background-color:white;color:red;width:50px;border:1px solid #ccc;border-radius:15px;text-align:center;">特价</div></tpl><tpl if="soldoutStatus==\'1\'&&(!soldoutNum&&soldoutNum<=0)"><div class="select{define4} soldout1"></div><tpl elseif="soldoutStatus==\'1\'"><div class="select{define4} soldout0"></div><tpl if="!remainNum && remainNum!=0"><tpl else><div class="remainStatus" style="background-color:white;color:cornflowerblue;width:65px;border:1px solid #ccc;border-radius:20px;text-align:center;">剩余 {remainNum}</div></tpl><tpl else><div class="select{define4} soldout0"></div></tpl></div></div><div class="cent"><div class="commodityname special"><p class="text-overflow" title="{name}">{name}</p></div><div><tpl if="isSpecialPrice==\'1\'"><span id="commodity{id}" class="special">￥{specialPrice}</span><span id="commodity{id}" class="special" style="text-decoration:line-through;">￥{price}</span><tpl else><span id="commodity{id}" style="text-underline: middle;">￥{price}</span></tpl></div></div></div></div><tpl else><div class="sp-dataview2"><div class="sp-dataview2-shadow"><div class="pic picborder"><img src="{define1}"><div class="select{define4} soldout{soldoutStatus}"></div></div><div class="cent"><div class="commodityname"><p class="text-overflow">{name}</p></div><div><span id="commodity{id}">￥{price}</span></div></div></div></div></tpl></tpl>'].join(''));
			// 特价
			//Ext.getCmp('showyin-commodity-list').setItemTpl(['<tpl if="id == 0"><div class="sp-dataview2"><div class="sp-dataview2-shadow"><div class="addcomimg"></div></div></div><tpl else><tpl if="define1==\'\'"><div class="sp-dataview2"><div class="sp-dataview2-shadow"><div class="pic picborder"><div class="cent"><tpl if="isSpecialPrice==1"><div style="margin:0px 5px 0px;background-color:white;color:red;width:50px;border:1px solid #ccc;border-radius:15px;text-align:center;">特价</div></tpl><tpl if="soldoutStatus==\'1\'&&(!soldoutNum&&soldoutNum<=0)"><div class="select{define4} soldout1"></div><tpl elseif="soldoutStatus==\'1\'"><div class="select{define4} soldout0"></div><tpl if="!remainNum && remainNum!=0"><tpl else><div class="remainStatus" style="background-color:white;color:cornflowerblue;width:65px;border:1px solid #ccc;border-radius:20px;text-align:center;">剩余 {remainNum}</div></tpl><tpl else><div class="select{define4} soldout0"></div></tpl></div></div><tpl if="isSpecialPrice==\'1\'"><div class="cent special"><div class="commodityname special"><p class="text-overflow" title="{name}">{name}</p></div><div><span id="commodity{id}" class="special">￥{specialPrice}</span><span id="commodity{id}" class="special" style="text-decoration:line-through;">￥{price}</span></div><tpl else><div class="cent"><div class="commodityname"><p class="text-overflow" title="{name}">{name}</p></div><div><span id="commodity{id}">￥{price}</span></div></tpl></div></div></div></div><tpl else><div class="sp-dataview2"><div class="sp-dataview2-shadow"><div class="pic picborder"><img src="{define1}"><div class="select{define4} soldout{soldoutStatus}"></div></div><div class="cent"><div class="commodityname"><p class="text-overflow">{name}</p></div><div><span id="commodity{id}">￥{price}</span></div></div></div></div></tpl></tpl>'].join(''));
			Ext.getCmp('showyin-commodity-list').setItemTpl(['<tpl if="id == 0">' + '<div class="sp-dataview2">' + '<div class="sp-dataview2-shadow">' + '<div class="addcomimg"></div>' + '</div>' + '</div>' + '<tpl else>' + '<tpl if="define1==\'\'">' + '<div class="sp-dataview2">' + '<div class="sp-dataview2-shadow">' + '<div class="pic picborder">' + '<div id="cent-{id}" class="cent">' + '<tpl if="isSpecialPrice==1">' +
			//'<div style="margin:0px 5px 0px;background-color:white;color:red;width:50px;border:1px solid #ccc;border-radius:15px;text-align:center;">特</div>' +
			//'<div style="margin:0px 5px 0px;background-color:red;color:white;height:26px;width:26px;border-radius:50%;text-align:center;" class="jz-center">特</div>' +
			'<tpl if="isFrontSpecial==\'1\'">' + '<div style="position:absolute;width:50%;left:50%;bottom:3px;">' + '<div id="commodity{id}" style="float:right;text-decoration:line-through;margin:0 5px;color:white;display:inline-block;text-align:center;line-height:22px;width:40%;">￥{price}</div>' + '<div style="position:relative;float:right;background-color:red;color:white;height:22px;width:22px;line-height:22px;border-radius:50%;text-align:center;display:inline-block;" class="jz-center">特</div>' + '</div>' + '<tpl else>' + '<div style="position:absolute;width:50%;left:50%;bottom:3px;">' + '<div style="position:relative;float:right;margin:0px 8px 0px 0px;background-color:red;color:white;height:22px;width:22px;line-height:22px;border-radius:50%;text-align:center;display:inline-block;" class="jz-center">特</div>' + '</div>' + '</tpl>' + '</tpl>' +
			//'<tpl if="soldoutStatus==\'1\'&&(!soldoutNum&&soldoutNum<=0)">' +
			'<tpl if="soldoutStatus==\'1\'&&(soldoutNum<=0||soldoutNum<0.01)">' + '<div class="select{define4} soldout1"></div>' + '<tpl elseif="soldoutStatus==\'1\'">' + '<div class="select{define4} soldout0"></div>' + '<tpl if="!remainNum && remainNum!=0"><tpl else>' +
			//'<div class="remainStatus" style="background-color:white;color:cornflowerblue;width:65px;border:1px solid #ccc;border-radius:20px;text-align:center;">剩 {remainNum}</div>' +
			//'<div class="remainStatus" style="background-color:rgba(0,0,0,0.5);color:white;width:55px;border:1px solid #ccc;border-radius:20px;text-align:center;">剩 {remainNum}</div>' +
			'<div class="remainContainer' + ' <tpl if="isHideSoldout==\'1\'">hideE</tpl>' + '">' + '<div class="remainStatus" style="background:rgba(60,60,60,0.3);color:white;width:55px;border-radius:20px;text-align:center;">剩 {remainNum}</div>' + '</div>' + '</tpl>' + '<tpl else>' + '<div class="select{define4} soldout0"></div>' + '</tpl>' + '</div>' + '</div>' + '<tpl if="isSpecialPrice==\'1\'">' + '<tpl if="isFrontSpecial==\'1\'">' + '<div class="cent special">' + '<div class="commodityname special">' + '<p class="text-overflow" title="{name}">{name}</p>' + '</div>' + '<div><span id="commodity{id}" class="special">￥{specialPrice}</span>' +
			//'<span id="commodity{id}" class="special" style="text-decoration:line-through;">￥{price}</span>' +
			'</div>' + '</div>' + '<tpl else>' + '<div class="cent">' + '<div class="commodityname">' + '<p class="text-overflow" title="{name}">{name}</p>' + '</div>' + '<div><span id="commodity{id}">￥{price}</span></div>' + '</div>' + '</tpl>' + '<tpl else>' + '<div class="cent">' + '<div class="commodityname">' + '<p class="text-overflow" title="{name}">{name}</p>' + '</div>' + '<div><span id="commodity{id}">￥{price}</span></div>' + '</div>' + '</tpl>' + '</div>' + '</div>' + //</div></div>' +
			'<tpl else>' + '<div class="sp-dataview2">' + '<div class="sp-dataview2-shadow">' + '<div class="pic picborder">' + '<img src="{define1}">' +
			//'<div class="select{define4} soldout{soldoutStatus}"></div>' +
			'<div id="cent-{id}" class="cent">' + '<tpl if="isSpecialPrice==1">' +
			//'<div style="margin:0px 5px 0px;background-color:white;color:red;width:50px;border:1px solid #ccc;border-radius:15px;text-align:center;">特</div>' +
			//'<div style="margin:0px 5px 0px;background-color:red;color:white;height:26px;width:26px;border-radius:50%;text-align:center;" class="jz-center">特</div>' +
			'<tpl if="isFrontSpecial==\'1\'">' + '<div style="position:absolute;width:50%;left:50%;bottom:3px;">' + '<div id="commodity{id}" style="float:right;text-decoration:line-through;margin:0 5px;color:white;display:inline-block;text-align:center;line-height:22px;width:40%;">￥{price}</div>' + '<div style="position:relative;float:right;background-color:red;color:white;height:22px;width:22px;line-height:22px;border-radius:50%;text-align:center;display:inline-block;" class="jz-center">特</div>' + '</div>' + '<tpl else>' + '<div style="position:absolute;width:50%;left:50%;bottom:3px;">' + '<div style="position:relative;float:right;margin:0px 8px 0px 0px;background-color:red;color:white;height:22px;width:22px;line-height:22px;border-radius:50%;text-align:center;display:inline-block;" class="jz-center">特</div>' + '</div>' + '</tpl>' + '</tpl>' +
			//'<tpl if="soldoutStatus==\'1\'&&(!soldoutNum&&soldoutNum<=0.01)">' +
			'<tpl if="soldoutStatus==\'1\'&&(soldoutNum<=0||soldoutNum<0.01)">' + '<div class="select{define4} soldout1"></div>' + '<tpl elseif="soldoutStatus==\'1\'">' + '<div class="select{define4} soldout0"></div>' + '<tpl if="!remainNum && remainNum!=0"><tpl else>' +
			//'<div class="remainStatus" style="background-color:white;color:cornflowerblue;width:65px;border:1px solid #ccc;border-radius:20px;text-align:center;">剩 {remainNum}</div>' +
			//'<div class="remainStatus" style="background-color:rgba(0,0,0,0.5);color:white;width:55px;border:1px solid #ccc;border-radius:20px;text-align:center;">剩 {remainNum}</div>' +
			'<div class="remainContainer' + ' <tpl if="isHideSoldout==\'1\'">hideE</tpl>' + '">' + '<div class="remainStatus" style="background:rgba(60,60,60,0.3);color:white;width:55px;border-radius:20px;text-align:center;">剩 {remainNum}</div>' + '</div>' + '</tpl>' + '<tpl else>' + '<div class="select{define4} soldout0"></div>' + '</tpl>' + '</div>' + '</div>' + '<tpl if="isSpecialPrice==\'1\'">' + '<tpl if="isFrontSpecial==\'1\'">' + '<div class="cent special">' + '<div class="commodityname special">' + '<p class="text-overflow" title="{name}">{name}</p>' + '</div>' + '<div><span id="commodity{id}" class="special">￥{specialPrice}</span>' +
			//'<span id="commodity{id}" class="special" style="text-decoration:line-through;">￥{price}</span>' +
			'</div>' + '</div>' + '<tpl else>' + '<div class="cent">' + '<div class="commodityname">' + '<p class="text-overflow" title="{name}">{name}</p>' + '</div>' + '<div><span id="commodity{id}">￥{price}</span></div>' + '</div>' + '</tpl>' + '<tpl else>' + '<div class="cent">' + '<div class="commodityname">' + '<p class="text-overflow" title="{name}">{name}</p>' + '</div>' + '<div><span id="commodity{id}">￥{price}</span></div>' + '</div>' + '</tpl>' +
			/*'<tpl if="isSpecialPrice==\'1\'">' +
			 '<tpl if="isFrontSpecial==\'1\'">' +
			 '<div class="cent special">' +
			 '<div class="commodityname special">' +
			 '<p class="text-overflow" title="{name}">{name}</p>' +
			 '</div>' +
			 '<div><span id="commodity{id}" class="special">￥{specialPrice}</span>' +
			 '<span id="commodity{id}" class="special" style="text-decoration:line-through;">￥{price}</span>' +
			 '</div>' +
			 '</div>' +
			 '<tpl else>' +
			 '<div class="cent">' +
			 '<div class="commodityname">' +
			 '<p class="text-overflow" title="{name}">{name}</p>' +
			 '</div>' +
			 '<div><span id="commodity{id}">￥{price}</span></div>' +
			 '</div>' +
			 '</tpl>' +
			 '<tpl else>' +
			 '<div class="cent">' +
			 '<div class="commodityname">' +
			 '<p class="text-overflow" title="{name}">{name}</p>' +
			 '</div>' +
			 '<div><span id="commodity{id}">￥{price}</span></div>' +
			 '</div>' +
			 '</tpl>' +*/
			/*'<div class="cent">' +
			 '<div class="commodityname">' +
			 '<p class="text-overflow">{name}</p>' +
			 '</div>' +
			 '<div>' +
			 '<span id="commodity{id}">￥{price}</span>' +
			 '</div>' +
			 '</div>' +*/
			'</div>' + '</div>' + '</tpl>' + '</tpl>'].join(''));
		} else {
			// this.commodityInfoPage.setLimitCount(20);
			//Ext.getCmp('showyin-commodity-list').setItemTpl(['<tpl if="id == 0"><div class="sp-dataview"><div class="cent"><div class="addcomimg"></div></div></div><tpl else> <div class="sp-dataview"><div class="cent"><div class="select{define4} soldout{soldoutStatus}"></div><div class="commodityname jz-center"><p>{name}</p></div><div><span id="commodity{id}" class="jz-center">￥{price}</span></div></div></div></tpl>'].join(''));
			Ext.getCmp('showyin-commodity-list').setItemTpl(['<tpl if="id == 0">' + '<div class="sp-dataview">' + '<div class="cent">' + '<div class="addcomimg"></div>' + '</div>' + '</div>' + '<tpl else>' + '<div class="sp-dataview">' + '<div id="cent-{id}" class="cent">' +
			//'<tpl if="soldoutStatus==\'1\'&&(!soldoutNum&&soldoutNum<=0.01)">' +
			'<tpl if="soldoutStatus==\'1\'&&(soldoutNum<=0||soldoutNum<0.01)">' + '<div class="select{define4} soldout1"></div>' + '<tpl elseif="soldoutStatus==\'1\'">' + '<div class="select{define4} soldout0"></div>' +
			//'<tpl if="!remainNum && remainNum!=0"><tpl else>' +
			//	'<div class="remainStatus" style="background-color:white;color:cornflowerblue;width:65px;border:1px solid #ccc;border-radius:20px;text-align:center;font-size:12px;">剩余 {remainNum}</div>' +
			//'</tpl>' +
			'<tpl else>' + '<div class="select{define4} soldout0"></div>' + '</tpl>' +
			//'<div class="select{define4} soldout{soldoutStatus}"></div>' +
			'<tpl if="isSpecialPrice==\'1\'">' + '<div class="commodityname">' + // jz-center
			//'<div class="specialStatus2"><div class="specialprice">￥{price}</div><div class="special">特</div></div>' +
			'<tpl if="soldoutStatus==\'1\'&&(soldoutNum<=0||soldoutNum<0.01)">' + '<tpl if="isFrontSpecial==\'1\'">' + '<div class="specialStatusCenter jz-center"><div class="special">特</div><div class="specialprice">￥{price}</div></div>' + '<tpl else>' + '<div class="specialStatusCenter jz-center"><div class="special">特</div></div>' + '</tpl>' + '<tpl elseif="soldoutStatus==\'1\'">' + '<tpl if="isFrontSpecial==\'1\'">' + '<div class="specialStatus2"><div class="specialprice">￥{price}</div><div class="special">特</div></div>' + '<tpl else>' + '<div class="specialStatus2"><div class="special">特</div></div>' + '</tpl>' + '<tpl if="!remainNum && remainNum!=0"><tpl else>' + '<div class="remainStatus2 jz-center"><div class="remain">剩 {remainNum}</div></div>' + '</tpl>' + '<tpl else>' + '<tpl if="isFrontSpecial==\'1\'">' + '<div class="specialStatusCenter jz-center"><div class="special">特</div><div class="specialprice">￥{price}</div></div>' + '<tpl else>' + '<div class="specialStatusCenter jz-center"><div class="special">特</div></div>' + '</tpl>' + '</tpl>' + '<div class="jz-center" style="width:100%;height:100%;">' + '<p>{name}</p>' + '</div>' + '</div>' + '<tpl if="isFrontSpecial==\'1\'">' + '<span id="commodity{id}" class="jz-center">￥{specialPrice}</span>' + '<tpl else>' + '<span id="commodity{id}" class="jz-center">￥{price}</span>' + '</tpl>' +
			//'<div class="specialPriceDiv"><span id="commodity{id}" class="special jz-center">￥{specialPrice}</span>' +
			//    '</div>' +
			//<span id="commodity{id}" class="jz-center special" style="text-decoration:line-through;">￥{price}</span>
			'<tpl elseif="soldoutStatus==\'1\'&&(soldoutNum<=0||soldoutNum<0.01)">' + '<div class="commodityname jz-center">' + '<p>{name}</p>' + '</div>' + '<span id="commodity{id}" class="jz-center">￥{price}</span>' + '<tpl elseif="soldoutStatus==\'1\'">' + '<div class="commodityname">' + '<tpl if="!remainNum && remainNum!=0"><tpl else>' + '<div class="remainStatusCenter"><div class="remain">剩 {remainNum}</div></div>' + '</tpl>' + '<div class="jz-center" style="width:100%;height:100%;">' + '<p>{name}</p>' + '</div>' + '</div>' + '<span id="commodity{id}" class="jz-center">￥{price}</span>' + '<tpl else>' + '<div class="commodityname jz-center">' + '<p>{name}</p>' + '</div>' + '<span id="commodity{id}" class="jz-center">￥{price}</span>' + '</tpl>' + '</div>' + '</div>' + '</tpl>'].join(''));
		}
	},
	setCommodityInfoPageSize: function() {
		// -2018.11.21
		var me = this;
		me.commodityInfoPage = new $.PageUtil({
			limitCount: bdySetting.comLines * bdySetting.comColumns
		});
	},
	resetCmpData : function() {
		var me = this;
		me.parentContainer = null;
		me.longTimeClickTimeout = null;
		me.isLongTimeClick = false;
		/**
		 * 点击分类
		 */
		me.currCommodityTypeId = null;
		//分页工具
		if (me.commodityTypePage)
			me.commodityTypePage.reset();
		if (me.commodityInfoPage)
			me.commodityInfoPage.reset();
	},
	loadData : function() {
		var me = this;
		updateCommodityBdySetting();// 更新商品界面设置
		me.setCommodityInfoPageSize();// 更新商品显示总数
		this.parentContainer = Ext.getCmp(Ext.getCmp('select-commodity-view').getData().parentContainerId);
		if (setting.isCommodityImage == null || setting.isCommodityImage == 'null' 
			|| setting.isCommodityImage == 'undefined') {
			//this.setItemTpl(true);
			this.setItemTpl(false);
		} else {
			this.setItemTpl(setting.isCommodityImage == 'true' || setting.isCommodityImage == true);
		}
		this.clearCommodityType();
		this.getCommodityTypeTotalPage(function(success) {
			if (success) {
				CommodityDao.loadCommodityTypePage(me.commodityTypePage.getLimitCount(), me.commodityTypePage.getOffset(), function(success, res) {
					if (success) {
						Ext.getCmp('select-commodity-view').loadCommodityType(res);
					}
				});
			}
		});
	},
	refreshTypeData : function(typeId) {
		/* 根据id 来刷新数据 */
		var me = this;
		if (setting.isCommodityImage === null || setting.isCommodityImage === 'null' 
			|| setting.isCommodityImage === 'undefined') {
			this.setItemTpl(false);
		} else {
			this.setItemTpl(setting.isCommodityImage == 'true' || setting.isCommodityImage == true);
		}
		this.clearCommodityType();
		this.getCommodityTypeTotalPage(function(success) {
			if (success) {
				CommodityDao.loadCommodityTypePage(me.commodityTypePage.getLimitCount(), me.commodityTypePage.getOffset(), function(success, res) {
					if (success) {
						Ext.getCmp('select-commodity-view').loadCommodityTypeById(res, typeId);
					}
				});
			}
		});
	},
	refreshImage : function() {
		var storeCommodity = Ext.getStore('showyin-commodity-store');
		var allCount = storeCommodity.getAllCount();
		for (var i = 0; i < allCount; i++) {
			var record = storeCommodity.getAt(i);
			//console.log("i:"+i);
			this.setImage(record);
		}
	},
	setImage : function(record) {// 设置商品图片
		CommodityDao.getCommodityById(record.get("id"), function(success, commInfo) {
			if (commInfo && commInfo.define1) {
				//console.log(commInfo.define1);
				//record.set("define1", "data:image/png;base64," + commInfo.define1);
				//console.log('a');
                record.set("define1",  commInfo.define1);
			}
		});
	},
	pageCommodityType : function(pageExecutor) {
		// alert('get in to pageCommodityType');
		var me = this;
		pageExecutor(me.commodityTypePage, function(startPage, endPage) {
			Ext.getCmp('select-commodity-view').clearCommodityType();
			CommodityDao.loadCommodityTypePage(me.commodityTypePage.getLimitCount(), me.commodityTypePage.getOffset(), function(success, res) {
				if (success) {
					Ext.getCmp('select-commodity-view').loadCommodityType(res);
				}
			});
		});
	},
	upCommoditytype : function() {
		var me = this;
		me.pageCommodityType(upThingPage);
		return;
		var commoditytype = Ext.getCmp('showyin-commoditytype-list');
		Ext.getCmp('select-commodity-view').clearCommodityType();
		me.commodityTypePage.up();
		CommodityDao.loadCommodityTypePage(me.commodityTypePage.getLimitCount(), me.commodityTypePage.getOffset(), function(success, res) {
			if (success) {
				Ext.getCmp('select-commodity-view').loadCommodityType(res);
			}
		});
	},
	downCommoditytype : function() {
		var me = this;
		me.pageCommodityType(downThingPage);
		return;
		Ext.getCmp('select-commodity-view').clearCommodityType();
		me.commodityTypePage.down();
		CommodityDao.loadCommodityTypePage(me.commodityTypePage.getLimitCount(), me.commodityTypePage.getOffset(), function(success, res) {
			if (success) {
				Ext.getCmp('select-commodity-view').loadCommodityType(res);
			}
		});
	},
	getCommodityTypeTotalPage : function(callBack) {
		var me = this;
		CommodityDao.getCommodityTypeTotalCount(function(success, totalCount) {
			if (success) {
				me.commodityTypePage.countPage(Application.Ftype == Application.SLAVE ? totalCount : totalCount + 1);
				if (callBack) {
					callBack(true);
				}
			} else {
				if (callBack) {
					callBack(false);
				}
			}
		});
	},
	clearCommodityType : function() {
		var store = Ext.getStore('showyin-commoditytype-store');
		store.removeAll();
		this.clearCommodityInfo();
	},
	loadCommodityTypeById : function(datas, typeId) {
		/* 根据id来操作商品类型 */
		var me = Ext.getCmp('select-commodity-view');
		var store = Ext.getStore('showyin-commoditytype-store');
		store.removeAll();
		var item;
		var first;
		store.add(datas);
		var typeRecord = store.findRecord('id', typeId);
		var name = "";
		if(typeRecord) {
			me.currCommodityTypeId = typeId;
			name = typeRecord.get('name');
		} else {
			if(datas.length > 0) {
				me.currCommodityTypeId = datas[0].id;
				name = datas[0].name;
			}
		}
		if(me.currCommodityTypeId)
			me.commodityTypeClick($("#commoditytype"+me.currCommodityTypeId)[0], me.currCommodityTypeId, name);
		
		var allCount = store.getAllCount();
		var k = allCount % me.commodityTypePage.getLimitCount();

		if (me.commodityTypePage.getCurrPage() == me.commodityTypePage.getTotalPage()) {
			store.add({
				id : '0',
				name : ''
			});
		}
	},
	loadCommodityType : function(datas) {
		var me = Ext.getCmp('select-commodity-view');
		var store = Ext.getStore('showyin-commoditytype-store');
		if(Ext.getCmp('select-commodity-view'))
        	var currCommodityTypeId = Ext.getCmp('select-commodity-view').currCommodityTypeId;
		// console.log(store);
		store.removeAll();
		var item;
		var first;
		var clickCommodityTypeId = null;
		for (var i = 0, len = datas.length; i < len; i++) {
			item = datas[i];
			store.add(item);
			/*if (currCommodityTypeId) {
				//刷新按钮  不跳转菜单方法
                Ext.getCmp('select-commodity-view').commodityTypeClick($("#commoditytype" + currCommodityTypeId)[0], currCommodityTypeId, '111');
			} else */if (i == 0) {
				me.currCommodityTypeId = item.id;
				me.commodityTypeClick($("#commoditytype"+me.currCommodityTypeId)[0], me.currCommodityTypeId, item.name);
			}
		}
		var allCount = store.getAllCount();
		var k = allCount % me.commodityTypePage.getLimitCount();

		if (me.commodityTypePage.getCurrPage() == me.commodityTypePage.getTotalPage()) {
            me.loadCommodityTypeButton();
			/*store.add({
				id : '0',
				name : ''
			});*/
		}
	},
	/**
	 * 清空
	 */
	clearCommodityInfo : function() {
		var store = Ext.getStore('showyin-commodity-store');
		store.removeAll();
	},
	calcRemainNumFromCart : function(commInfo) {// 从购物车计算剩余沽清数量
		if (commInfo.soldoutStatus == '1') {
			var cartPageStore = getPageStore();
			if (cartPageStore.getCount() <= 0) {
				commInfo.remainNum = commInfo.soldoutNum ? commInfo.soldoutNum : 0;
			} else {
				var isSellInfo = false;
				if (Ext.getCmp('shouyinMainView').sellInfo)
					isSellInfo = true;
				var cartRecords = cartPageStore.queryBy(function(record, id) {
					if (record.get('commodityId') == commInfo.id) {
						if (isSellInfo) {
							if (record.get('type') == 1 || record.get('type') == 2)
								return true;
						} else
							return true;
					}
					return false;
				});
				var cartRecordNum = cartRecords.getCount();
				var cartCommNum = 0;
				if (cartRecordNum > 0) {
					for (var ci = 0; ci < cartRecordNum; ci++) {
						var cartRecord = cartRecords.getAt(ci);
						if (cartRecord.get('commodityId') == commInfo.id) {
							cartCommNum += cartRecord.get('sellNum');
						}
					}
				}
				if (commInfo.remainNum > cartCommNum)
					commInfo.remainNum = commInfo.remainNum - cartCommNum;
				else
					commInfo.remainNum = 0;
			}
		}
	},
	setCommodityPriceString : function(commInfo) {
		// 设置商品价格显示规则
		/**
		 * 1. 末位不为零时,不精简
		 * 2. 末位为零时，查倒数第二位
		 */
		var cutPriceString = parseFloat(commInfo.price).toFixed(2);
		var cutPriceInt = parseInt(cutPriceString * 100);
		var dotNum = cutPriceInt % 10;
		// first
		commInfo.price = cutPriceString;
		if (dotNum > 0) {
		} else {
			cutPriceInt = parseInt(cutPriceString * 10);
			dotNum = cutPriceInt % 10;
			// second
			if (dotNum > 0) {
				commInfo.price = parseFloat(commInfo.price).toFixed(1);
			} else {
				commInfo.price = parseInt(cutPriceString);
			}
		}
	},
	setCommoditySpecialPrice : function(commInfo, special) {
		var specialPriceCommodityArr = [];// 其作用为，避免先后进行判断的顺序导致特价菜属性被覆盖
        for (var sppi = 0, spplen = special.length; sppi < spplen; sppi++) {
            /**
             * Edit by bobol
             * 修改前备份
             * bug描述：初始化数据时候，没有根据时间判断设置isSpecialPrice属性
             */
            /*if (special[sppi].commodityId == commInfo.id && SpecialPriceCompute.isValid(special[sppi], '1')) {
                commInfo.isSpecialPrice = '1';
                commInfo.specialPrice = special[sppi].specialPrice ? special[sppi].specialPrice : 0;
                break;
            }*/
            if (special[sppi].commodityId != commInfo.id) continue;
            if (SpecialPriceCompute.isValid(special[sppi], '1')) {
                commInfo.isSpecialPrice = '1';
                commInfo.specialPrice = special[sppi].specialPrice ? special[sppi].specialPrice : 0;
                specialPriceCommodityArr.push(commInfo.id);
                /*CommodityDao.updateCommodity({'isSpecialPrice': '1'}, special[sppi].commodityId, function (success, info) {
                    if (!success) showAlert('提示', info);
                });
                break;*/
            } else {
                if (specialPriceCommodityArr.indexOf(commInfo.id) == -1) {
                    commInfo.isSpecialPrice = '0';
                    CommodityDao.updateCommodity({'isSpecialPrice': '0'}, special[sppi].commodityId, function (success, info) {
                        if (!success) showAlert('提示', info);
                    });
                    // break;
                }
            }
			updateSpecialPriceTask(special[sppi]);
        }
    },
	loadCommodityInfo : function(datas, typeId) {
		var _self = this;
		SpecialPriceDao.getSpecialPriceNotDel(function(success, special) {
			if (!special || special.length <= 0)
				_self.loadCommodityInfoSpecial(datas, typeId, []);
			else
				_self.loadCommodityInfoSpecial(datas, typeId, special);
		});
	},
	loadCommodityInfoSpecial : function(datas, typeId, special) {
		var me = Ext.getCmp('select-commodity-view');
		var store = Ext.getStore('showyin-commodity-store');
		store.removeAll();
		var commodityData = [];
		var i = 0;
		var k = 0;
		while (i < datas.length) {
			commodityData[k] = {};
			commodityData[k] = datas[i];
			commodityData[k].sellNum = 0;
			me.setCommodityPriceString(commodityData[k]);
			commodityData[k].logo = (isOnline || Ext.os.is.Windows) ? (commodityData[k].logo ? (webHost + "/file/downPic?fileName=" + commodityData[k].logo) : '') : '';
			//me.calcRemainNumFromCart(commodityData[k]);
			calcRemainNumFromCart(commodityData[k]);
			commodityData[k].soldoutNum = commodityData[k].soldoutNum ? parseFloat(commodityData[k].soldoutNum).toFixed(2) : commodityData[k].soldoutNum;
			commodityData[k].remainNum = commodityData[k].remainNum ? parseFloat(commodityData[k].remainNum).toFixed(2) : commodityData[k].remainNum;
			commodityData[k].isTimePrice = commodityData[k].isTimePrice == '1' ? commodityData[k].isTimePrice : '0';
			me.setCommoditySpecialPrice(commodityData[k], special);
			commodityData[k].specialNorms = commodityData[k].specialNorms ? commodityData[k].specialNorms : '{}';
			commodityData[k].isFrontSpecial = '0';
			if (commodityData[k].isSupportNorms == '1') {// 规格或套餐商品不能是时价菜
				commodityData[k].isTimePrice = '0';
				// 特价价格是否显示在cent页面
				var commodityPrice = commodityData[k].price;
				var specialNorms = Ext.JSON.decode(commodityData[k].specialNorms);
				if (specialNorms && commodityData[k].specialNorms != '{}') {// 是否显示规格特价
					console.warn(specialNorms);
					for (var ni = 1; ni < 9; ni++) {
						if (commodityPrice == commodityData[k]['normsPrice' + ni] && specialNorms[commodityData[k]['normsName' + ni]] >= 0) {
							// 指定规格特价并与显示价格一致
							commodityData[k].isFrontSpecial = '1';
							commodityData[k].specialPrice = specialNorms[commodityData[k]['normsName' + ni]];
							break;
						}
					}
				} else {
					commodityData[k].isFrontSpecial = '0';
				}
			} else {
				if (commodityData[k].isSpecialPrice == '1')
					commodityData[k].isFrontSpecial = '1';
			}
			//console.log(commodityData[k].define1);
			//commodityData[k].define1 = commodityData[k].define1 ? ("data:image/png;base64," + commodityData[k].define1) : '';
           /* if(commodityData[k].define1!=null && commodityData[k].define1.lastIndexOf('data:image')<0)
			{
                commodityData[k].define1 = commodityData[k].define1 ? ("data:image/png;base64," + commodityData[k].define1) : '';
            }
			else {
                commodityData[k].define1 = commodityData[k].define1 ? (commodityData[k].define1) : '';
            }*/
			//alert(commodityData[k].define1)
			commodityData[k].define1 = commodityData[k].define1 && (toString(commodityData[k].define1).valueOf().toLowerCase()!="null".toLowerCase()) ? (commodityData[k].define1 + '?time=' + new Date().getTime()) : '';
			if (!commodityData[k].unit || commodityData[k].unit == '') {
				commodityData[k].unit = '例';
			} else {
				commodityData[k].unit = commodityData[k].unit;
			}
			commodityRemainSetting(commodityData[k]);
			if(commodityData[k].specialPrice > 0) {
				commodityData[k].specialPrice = numberFormat(commodityData[k].specialPrice);
			}
			k++;

			/*if (k > 5) {
				for (var j = 0, len = commodityData.length; j < len; j++) {
					store.add(commodityData[j]);
				}
				k = 0;
				commodityData = [];
			}*/
			i++;
		}
		if (commodityData) {
			/*for (var j = 0, len1 = commodityData.length; j < len1; j++) {
				store.add(commodityData[j]);
			}*/
			store.add(commodityData);
			commodityData = null;
			k = 0;
		}
		if (me.commodityInfoPage.getCurrPage() == me.commodityInfoPage.getTotalPage()) {// 最后一页
			me.loadCommodityInfoButton(typeId);
		}
        //reloadRemainNum();
		setTimeout(function() {
			me.fillSelectCommodity();
		}, 100);
	},
	loadCommodityInfoSpecial2 : function(datas, typeId, special) {
		var me = Ext.getCmp('select-commodity-view');
		var store = Ext.getStore('showyin-commodity-store');
		store.removeAll();
		var commodityData;
		var i = 0;
		var k = 0;
		//console.log('isOnline:'+isOnline);
		while (i < datas.length) {
			if (!commodityData) {
				commodityData = [];
			}
			//item = datas[i];
			//commodityData[k++] = item;
			//item.price = parseFloat(item.price).toFixed(2);
			commodityData[k] = {};
			commodityData[k].id = datas[i].id;
			commodityData[k].name = datas[i].name;
			commodityData[k].barCode = datas[i].barCode;
			/**
			 * 1. 末位不为零时,不精简
			 * 2. 末位为零时，查倒数第二位
			 */
			var cutPriceString = parseFloat(datas[i].price).toFixed(2);
			var cutPriceInt = parseInt(cutPriceString * 100);
			var dotNum = cutPriceInt % 10;
			// first
			commodityData[k].price = cutPriceString;
			if (dotNum > 0) {
			} else {
				cutPriceInt = parseInt(cutPriceString * 10);
				dotNum = cutPriceInt % 10;
				// second
				if (dotNum > 0) {
					commodityData[k].price = parseFloat(datas[i].price).toFixed(1);
				} else {
					commodityData[k].price = parseInt(cutPriceString);
				}
			}
			//commodityData[k].price = parseFloat(datas[i].price).toFixed(2);
			commodityData[k].isTimecard = datas[i].isTimecard;
			commodityData[k].timeNum = datas[i].timeNum;
			commodityData[k].timeCommodityId = datas[i].timeCommodityId;
			commodityData[k].logo = (isOnline || Ext.os.is.Windows) ? (datas[i].logo ? (webHost + "/file/downPic?fileName=" + datas[i].logo) : '') : '';
			commodityData[k].typeId = datas[i].typeId;
			commodityData[k].soldoutStatus = datas[i].soldoutStatus;
			commodityData[k].soldoutNum = datas[i].soldoutNum ? datas[i].soldoutNum : 0;
			commodityData[k].remainNum = datas[i].soldoutNum ? datas[i].soldoutNum : 0;
			//me.calcRemainNumFromCart(commodityData[k]);
			calcRemainNumFromCart(commodityData[k]);
			commodityData[k].soldoutNum = parseFloat(commodityData[k].soldoutNum).toFixed(2);
			commodityData[k].remainNum = parseFloat(commodityData[k].remainNum).toFixed(2);
			commodityData[k].isTimePrice = datas[i].isTimePrice == '1' ? datas[i].isTimePrice : '0';
			//commodityData[k].isSpecialPrice = datas[i].isSpecialPrice ? datas[i].isSpecialPrice : '0';
			//commodityData[k].specialPrice = datas[i].specialPrice ? datas[i].specialPrice : 0;
			commodityData[k].isSpecialPrice = '0';
			commodityData[k].specialPrice = 0;
			for (var sppi = 0, spplen = special.length; sppi < spplen; sppi++) {
				//if(special[sppi].commodityId == datas[i].id && special[sppi].status == '1') {
				if (special[sppi].commodityId == datas[i].id && SpecialPriceCompute.isValid(special[sppi], '1')) {
					commodityData[k].isSpecialPrice = '1';
					commodityData[k].specialPrice = special[sppi].specialPrice ? special[sppi].specialPrice : 0;
					break;
				}
			}
			commodityData[k].specialNorms = datas[i].specialNorms ? datas[i].specialNorms : '{}';
			commodityData[k].isFrontSpecial = '0';
			commodityData[k].isSupportNorms = datas[i].isSupportNorms;
			commodityData[k].normsName1 = datas[i].normsName1;
			commodityData[k].normsPrice1 = datas[i].normsPrice1;
			commodityData[k].normsName2 = datas[i].normsName2;
			commodityData[k].normsPrice2 = datas[i].normsPrice2;
			commodityData[k].normsName3 = datas[i].normsName3;
			commodityData[k].normsPrice3 = datas[i].normsPrice3;
			commodityData[k].normsName4 = datas[i].normsName4;
			commodityData[k].normsPrice4 = datas[i].normsPrice4;
			commodityData[k].normsName5 = datas[i].normsName5;
			commodityData[k].normsPrice5 = datas[i].normsPrice5;
			commodityData[k].normsName6 = datas[i].normsName6;
			commodityData[k].normsPrice6 = datas[i].normsPrice6;
			commodityData[k].normsName7 = datas[i].normsName7;
			commodityData[k].normsPrice7 = datas[i].normsPrice7;
			commodityData[k].normsName8 = datas[i].normsName8;
			commodityData[k].normsPrice8 = datas[i].normsPrice8;
			if (commodityData[k].isSupportNorms == '1') {
				commodityData[k].isTimePrice = '0';
				// 特价价格是否显示在cent页面
				var commodityPrice = commodityData[k].price;
				var specialNorms = Ext.JSON.decode(commodityData[k].specialNorms);
				if (specialNorms) {
					for (var ni = 1; ni < 9; ni++) {
						if (commodityPrice == commodityData[k]['normsPrice' + ni] && specialNorms[commodityData[k]['normsName' + ni]] >= 0) {
							// 指定规格特价并与显示价格一致
							commodityData[k].isFrontSpecial = '1';
							commodityData[k].specialPrice = specialNorms[commodityData[k]['normsName' + ni]];
							break;
						}
					}
				} else {
					commodityData[k].isFrontSpecial = '0';
				}
			} else {
				if (commodityData[k].isSpecialPrice == '1')
					commodityData[k].isFrontSpecial = '1';
			}
			commodityData[k].category = datas[i].category;
			commodityData[k].comboMealsJson = datas[i].comboMealsJson;
			commodityData[k].sequence = datas[i].sequence;
			commodityData[k].expectedTime = datas[i].expectedTime;
			//commodityData[k].define1 = datas[i].define1 ? ("data:image/png;base64," + datas[i].define1) : '';
			// console.log("aa");
			// console.log(datas[i].define1);
            commodityData[k].define1 = datas[i].define1 ? (datas[i].define1) : '';
			//: "resources/img/commodity-error.png";
			commodityData[k].kitchenPrint = datas[i].kitchenPrint;
			commodityData[k].labelPrint = datas[i].labelPrint;
			commodityData[k].status = datas[i].status;
			if (!datas[i].unit || datas[i].unit == '') {
				commodityData[k].unit = '例';
			} else {
				commodityData[k].unit = datas[i].unit;
			}
			commodityRemainSetting(commodityData[k]);

			k++;

			if (k > 5) {
				for (var j = 0, len = commodityData.length; j < len; j++) {
					store.add(commodityData[j]);
				}
				k = 0;
				commodityData = null;
			}
			i++;
		}
		if (commodityData) {
			for (var j = 0, len1 = commodityData.length; j < len1; j++) {
				// commodityData[j].logo = (isOnline || Ext.os.is.Windows) ? (commodityData[j].logo ? (webHost + "/file/downPic?fileName=" + commodityData[j].logo) : '') : '';
				// console.log('logo1:'+commodityData[j].logo);
				store.add(commodityData[j]);
			}
			commodityData = null;
			k = 0;
		}
		if (me.commodityInfoPage.getCurrPage() == me.commodityInfoPage.getTotalPage()) {
			store.add({
				id : 0,
				name : '添加商品',
				barCode : '',
				price : 0,
				isTimecard : 0,
				timeNum : 0,
				timeCommodityId : 0,
				logo : '',
				typeId : typeId

			});
		}
		setTimeout(function() {
			Ext.getCmp('select-commodity-view').fillSelectCommodity();
		}, 100);
	},
	/**
	 * 加载商品
	 * @param {Object} datas
	 * @param {Object} typeId
	 */
	loadCommodityInfoOriginal : function(datas, typeId) {
		var me = Ext.getCmp('select-commodity-view');
		var store = Ext.getStore('showyin-commodity-store');
		store.removeAll();
		var commodityData;
		var i = 0;
		var k = 0;
		//console.log('isOnline:'+isOnline);
		while (i < datas.length) {
			if (!commodityData) {
				commodityData = [];
			}
			//item = datas[i];
			//commodityData[k++] = item;
			//item.price = parseFloat(item.price).toFixed(2);
			commodityData[k] = {};
			commodityData[k].id = datas[i].id;
			commodityData[k].name = datas[i].name;
			commodityData[k].barCode = datas[i].barCode;
			/**
			 * 1. 末位不为零时,不精简
			 * 2. 末位为零时，查倒数第二位
			 */
			var cutPriceString = parseFloat(datas[i].price).toFixed(2);
			var cutPriceInt = parseInt(cutPriceString * 100);
			var dotNum = cutPriceInt % 10;
			// first
			commodityData[k].price = cutPriceString;
			if (dotNum > 0) {
			} else {
				cutPriceInt = parseInt(cutPriceString * 10);
				dotNum = cutPriceInt % 10;
				// second
				if (dotNum > 0) {
					commodityData[k].price = parseFloat(datas[i].price).toFixed(1);
				} else {
					commodityData[k].price = parseInt(cutPriceString);
				}
			}
			//commodityData[k].price = parseFloat(datas[i].price).toFixed(2);
			commodityData[k].isTimecard = datas[i].isTimecard;
			commodityData[k].timeNum = datas[i].timeNum;
			commodityData[k].timeCommodityId = datas[i].timeCommodityId;
			commodityData[k].logo = (isOnline || Ext.os.is.Windows) ? (datas[i].logo ? (webHost + "/file/downPic?fileName=" + datas[i].logo) : '') : '';
			commodityData[k].typeId = datas[i].typeId;
			commodityData[k].soldoutStatus = datas[i].soldoutStatus;
			commodityData[k].soldoutNum = datas[i].soldoutNum ? datas[i].soldoutNum : 0;
			commodityData[k].remainNum = datas[i].soldoutNum ? datas[i].soldoutNum : 0;
			commodityData[k].isTimePrice = datas[i].isTimePrice == '1' ? datas[i].isTimePrice : '0';
			commodityData[k].isSpecialPrice = datas[i].isSpecialPrice ? datas[i].isSpecialPrice : '0';
			commodityData[k].specialPrice = datas[i].specialPrice ? datas[i].specialPrice : 0;
			commodityData[k].isSupportNorms = datas[i].isSupportNorms;
			commodityData[k].normsName1 = datas[i].normsName1;
			commodityData[k].normsPrice1 = datas[i].normsPrice1;
			commodityData[k].normsName2 = datas[i].normsName2;
			commodityData[k].normsPrice2 = datas[i].normsPrice2;
			commodityData[k].normsName3 = datas[i].normsName3;
			commodityData[k].normsPrice3 = datas[i].normsPrice3;
			commodityData[k].normsName4 = datas[i].normsName4;
			commodityData[k].normsPrice4 = datas[i].normsPrice4;
			commodityData[k].normsName5 = datas[i].normsName5;
			commodityData[k].normsPrice5 = datas[i].normsPrice5;
			commodityData[k].normsName6 = datas[i].normsName6;
			commodityData[k].normsPrice6 = datas[i].normsPrice6;
			commodityData[k].normsName7 = datas[i].normsName7;
			commodityData[k].normsPrice7 = datas[i].normsPrice7;
			commodityData[k].normsName8 = datas[i].normsName8;
			commodityData[k].normsPrice8 = datas[i].normsPrice8;
			commodityData[k].category = datas[i].category;
			commodityData[k].comboMealsJson = datas[i].comboMealsJson;
			commodityData[k].sequence = datas[i].sequence;
			commodityData[k].expectedTime = datas[i].expectedTime;
			//commodityData[k].define1 = datas[i].define1 ? ("data:image/png;base64," + datas[i].define1) : '';
            commodityData[k].define1 = datas[i].define1 ? (datas[i].define1) : '';
			//: "resources/img/commodity-error.png";
			commodityData[k].kitchenPrint = datas[i].kitchenPrint;
			commodityData[k].labelPrint = datas[i].labelPrint;
			commodityData[k].status = datas[i].status;

			k++;

			if (k > 5) {
				for (var j = 0, len = commodityData.length; j < len; j++) {
					store.add(commodityData[j]);
				}
				k = 0;
				commodityData = null;
			}
			i++;
		}
		if (commodityData) {
			for (var j = 0, len1 = commodityData.length; j < len1; j++) {
				// commodityData[j].logo = (isOnline || Ext.os.is.Windows) ? (commodityData[j].logo ? (webHost + "/file/downPic?fileName=" + commodityData[j].logo) : '') : '';
				// console.log('logo1:'+commodityData[j].logo);
				store.add(commodityData[j]);
			}
			commodityData = null;
			k = 0;
		}
		if (me.commodityInfoPage.getCurrPage() == me.commodityInfoPage.getTotalPage()) {
			store.add({
				id : 0,
				name : '添加商品',
				barCode : '',
				price : 0,
				isTimecard : 0,
				timeNum : 0,
				timeCommodityId : 0,
				logo : '',
				typeId : typeId

			});
		}
		setTimeout(function() {
			Ext.getCmp('select-commodity-view').fillSelectCommodity();
		}, 100);
	},
	loadCommodityInfoButton : function(typeId) {// 商品 '+'
        if(Application.Ftype == Application.SLAVE) return;
		var store = Ext.getStore('showyin-commodity-store');
		store.add({
			id : 0,
			name : '添加商品',
			barCode : '',
			price : 0,
			isTimecard : 0,
			timeNum : 0,
			timeCommodityId : 0,
			logo : '',
			typeId : typeId
		});
	},
	loadCommodityTypeButton : function() {// 商品分类 '+'
		if(Application.Ftype == Application.SLAVE) return;
		var store = Ext.getStore('showyin-commoditytype-store');
		store.add({
			id : '0',
			name : ''
		});
	},
	pageCommodity : function(pageExecutor) {
		var me = this;
		if (!me.currCommodityTypeId) {
			showAlert("提示", "请先增加分类！");
			return;
		}
		//me.commodityInfoPage.up();
		pageExecutor(me.commodityInfoPage, function(startPage, endPage) {
			me.clearCommodityInfo();
			CommodityDao.loadCommodityInfoPageByTypeId(me.currCommodityTypeId, me.commodityInfoPage.getLimitCount(), me.commodityInfoPage.getOffset(), function(success, res) {
				if (success) {
					if (res.length > 0) {
						me.loadCommodityInfo(res, me.currCommodityTypeId);
					} else {
						me.loadCommodityInfoButton(me.currCommodityTypeId);
					}
				}
			});
			Ext.getCmp('sy-total-label').setHtml(me.commodityInfoPage.getCurrPage() + "/" + me.commodityInfoPage.getTotalPage());
		});
	},
	/**
	 * 向上滚动
	 */
	upCommodity : function() {
		var me = this;
		me.pageCommodity(upThingPage);
		return;
		if (!me.currCommodityTypeId) {
			showAlert("提示", "请先增加分类！");
			return;
		}
		//me.commodityInfoPage.up();
		upThingPage(me.commodityInfoPage, function(startPage, endPage) {
			me.clearCommodityInfo();
			CommodityDao.loadCommodityInfoPageByTypeId(me.currCommodityTypeId, me.commodityInfoPage.getLimitCount(), me.commodityInfoPage.getOffset(), function(success, res) {
				if (success) {
					if (res.length > 0) {
						me.loadCommodityInfo(res, me.currCommodityTypeId);
					} else {
						me.loadCommodityInfoButton(me.currCommodityTypeId);
					}
				}
			});
			Ext.getCmp('sy-total-label').setHtml(me.commodityInfoPage.getCurrPage() + "/" + me.commodityInfoPage.getTotalPage());
		});
	},
	/**
	 * 向下滚动
	 */
	downCommodity : function() {
		var me = this;
		me.pageCommodity(downThingPage);
		return;
		if (!me.currCommodityTypeId) {
			showAlert("提示", "请先增加分类！");
			return;
		}
		//me.commodityInfoPage.down();
		downThingPage(me.commodityInfoPage, function(startPage, endPage) {
			Ext.getCmp('select-commodity-view').clearCommodityInfo();
			CommodityDao.loadCommodityInfoPageByTypeId(me.currCommodityTypeId, me.commodityInfoPage.page.limitCount, me.commodityInfoPage.getOffset(), function(success, res) {
				if (success) {
					if (res.length > 0) {
						Ext.getCmp('select-commodity-view').loadCommodityInfo(res, me.currCommodityTypeId);
					} else {
						Ext.getCmp('select-commodity-view').loadCommodityInfoButton(me.currCommodityTypeId);
					}
				}
			});
			Ext.getCmp('sy-total-label').setHtml(me.commodityInfoPage.getCurrPage() + "/" + me.commodityInfoPage.getTotalPage());
		});
	},
	getCommodityInfoTotalPageByTypeId : function(currCommodityTypeId, callBack) {
		var me = this;
		CommodityDao.getCommodityInfoTotalCountByTypeId(currCommodityTypeId, function(success, totalCount) {
			if (success) {
				me.commodityInfoPage.countPage(Application.Ftype==Application.SLAVE? totalCount : totalCount + 1);
				Ext.getCmp('sy-total-label').setHtml(me.commodityInfoPage.getCurrPage() + "/" + me.commodityInfoPage.getTotalPage());
				if (callBack) {
					callBack(true);
				}
			} else {
				if (callBack) {
					callBack(false);
				}
			}
		});
	},
	/**
	 * 删除时清理样式(取消选中)
	 * @param {Object} commodityId
	 */
	removeSelectCommodity : function(commodityId) {
		var store = Ext.getStore('showyin-commodity-store');
		var record = store.findRecord("id", commodityId);
		if (record) {
			record.set("define4", "");
		}
	},
	/**
	 * 回显已经选中的商品
	 */
	fillSelectCommodity : function() {
		var store = getPageStore();
		var storeCommodity = Ext.getStore('showyin-commodity-store');
        /**
		 * Edit by bobol
		 * 因为持续快速点击菜单，导致多次调用次此方法，使得菜单右上角数字标签倍数增长。
		 * 现在用interval写成任务，若任务存在，打断任务再执行，若任务不存在，执行任务。
         */
		if (typeof(fillSelectCommoditiesTask) == "undefined" || fillSelectCommoditiesTask == []) {
            fillSelectCommoditiesTask = setInterval(function () {
                for (var i = 0, len = store.getAllCount(); i < len; i++) {
                    var record = store.getAt(i);
                    Ext.getCmp('shouyinMainView').removeCommodityNum(record.get("commodityId"), record.get("commodityTypeId"));
                }

                for (var i = 0, len = store.getAllCount(); i < len; i++) {
                    var record = store.getAt(i);
                    var recordCommodity = storeCommodity.findRecord("id", record.get("commodityId"));
                    if (recordCommodity) {
                        recordCommodity.set("define4", "1");
                    }
                    Ext.getCmp('shouyinMainView').addCommodityNum(record.get("commodityId"), record.get("commodityTypeId"), record.get("sellNum"));
                }
                if (typeof(fillSelectCommoditiesTask) != "undefined") {
                	window.clearInterval(fillSelectCommoditiesTask);
                	delete fillSelectCommoditiesTask;
				}
            },90)
        } else {
            window.clearInterval(fillSelectCommoditiesTask);
            delete fillSelectCommoditiesTask;
            this.fillSelectCommodity();
		}
	},
	deleteCommodity : function(record) {
		var store = Ext.getStore('showyin-commodity-store');
		store.remove(record);
	},
	deleteCommodityType : function(record) {
		var store = Ext.getStore('showyin-commoditytype-store');
		store.remove(record);
		me = this;
		this.getCommodityTypeTotalPage(function(success) {
			if (success) {
				CommodityDao.loadCommodityTypePage(me.commodityTypePage.getLimitCount(), me.commodityTypePage.getOffset(), function(success, res) {
					if (success) {
						if (res.length > 0)
							Ext.getCmp('select-commodity-view').loadCommodityType(res);
						else {
							Ext.getCmp('select-commodity-view').loadCommodityTypeButton();
							me.clearCommodityInfo();
						}
					}
				});
			}
		});
	},
	commodityTypeClick : function(element, id, name) {
		if (!name) {
			return;
		}
		var me = Ext.getCmp('select-commodity-view');
		me.commodityInfoPage.reset();
		me.currCommodityTypeId = id;
		console.log(new Date().format("yyyy-MM-dd hh:mm:ss.S"));
		/*Ext.query(".commoditytype-button").forEach(function(ele, index, array) {
			if (ele == element) {
				setTimeout(function() {
					if (Ext.get($("#commoditytype" + id)[0]))
						Ext.get($("#commoditytype"+id)[0]).addCls('commoditytype-button-select');
                    console.log(new Date().format("yyyy-MM-dd hh:mm:ss.S"));
				}, 10);
			} else {
				Ext.get(ele).removeCls('commoditytype-button-select');
			}
		});*/
		Ext.query(".commoditytype-button").forEach(function(ele, index, array) {
			if(ele == element);
			else Ext.get(ele).removeCls("commoditytype-button-select");
		});
        if (Ext.get($("#commoditytype" + id)[0])) {
            Ext.get($("#commoditytype" + id)[0]).addCls('commoditytype-button-select');
            console.log(new Date().format("yyyy-MM-dd hh:mm:ss.S"));
        }
		me.doSelectCommodiyType(id);
	},
	doSelectCommodiyType : function(id) {
		if (Application.Ftype ==Application.SLAVE) {
            Ext.getCmp('showyin-commodity-list').setEmptyText('<center><font style="opacity: 0.3; line-height:450px ;font-size: 50px;font-weight: 400;color: #000;">正在获取商品 请稍后……</font></center>');
		};
		var me = this;
		me.clearCommodityInfo();
		me.getCommodityInfoTotalPageByTypeId(id, function(success) {
			if (!success) return;
			CommodityDao.loadCommodityInfoPageByTypeId(id, me.commodityInfoPage.getLimitCount(), me.commodityInfoPage.getOffset(), function(success, res) {
                if (!success)
                    return;
                if (res.length > 0) {
                    me.loadCommodityInfo(res, id);
                    // Ext.getCmp('no-commodity-label').setHidden(true);
                } else if (Application.Ftype == Application.SLAVE && res.length == 0) {
					// Ext.getCmp('no-commodity-label').setHidden(false);
                    Ext.getCmp('showyin-commodity-list').setEmptyText('<center><font style="opacity: 0.3; line-height:450px ;font-size: 50px;font-weight: 400;color: #000;">该商品分类下无商品！</font></center>');
                    Ext.getCmp('select-commodity-view').fillSelectCommodity();
				} else {
					me.loadCommodityInfoButton(id);
                    // Ext.getCmp('no-commodity-label').setHidden(true);
                    Ext.getCmp('select-commodity-view').fillSelectCommodity();
				}
			});
		});
	},
	/**
	 * 点击增加分类
	 */
	addCommodityType2 : function(element) {
		var addCommodityTypeView = Ext.Viewport.add({
			xtype : 'panel',
			id : 'addCommodityTypeView',
			modal : true,
			hideOnMaskTap : false,
			centered : true,
			width : 500,
			height : 180,
			scrollable : false,
			items : [{
				xtype : 'addcommoditytype'
			}]
		});
		addCommodityTypeView.show();
		Ext.getCmp('commodityType-add-view').setParentContainer(addCommodityTypeView);
		Ext.getCmp('commodityType-add-view').loadData();
	},
	/**
	 * 点击增加分类
	 */
	addCommodityType: function(element) {
		if (Ext.getCmp('optComTypeViewSub')) {
			Ext.getCmp('optComTypeViewSub').show();
			Ext.getCmp('commodityTypeForm').reset();
		} else {
			// var addCommodityTypeView = addViewportCenter('addCommodityTypeViewSub', 'addcommoditytypesub', 500, 180, true);
			var addCommodityTypeView = addViewportCenter('optComTypeViewSub', 'commoditytypesub', 500, 180, true);
			showBy(addCommodityTypeView, Ext.getCmp('shouyinMainView'));
			Ext.getCmp('commodityType-view').setParentContainer(addCommodityTypeView);
		}
		Ext.getCmp('commodityType-view').setAddData();
		Ext.getCmp('commodityType-view').loadData();
	},
	/**
	 * 点击增加商品
	 */
	addCommodity : function(element, typeId) {
		if (!typeId) {
			showAlert("提示", "请先增加分类！");
			return;
		}
		if (Ext.getCmp('optCommodityView')) {
			Ext.getCmp('optCommodityView').show();
			Ext.getCmp('commodityForm').reset();
		} else {
			// var addCommodityView = addViewportCenter('addCommodityView', 'addcommoditysub', 500, 370, true);
			var addCommodityView = addViewportCenter('optCommodityView', 'commoditysub', 500, 370, true);
			showBy(addCommodityView, Ext.getCmp('shouyinMainView'));
			Ext.getCmp('commodity-view').setParentContainer(addCommodityView);
		}
		Ext.getCmp('commodity-view').setAddData();
		Ext.getCmp('commodity-view').typeId = typeId;
	},
	isLoad : function() {
		var store = Ext.getStore('showyin-commoditytype-store');
		return store.getAllCount() > 0;
	}
});

function showTimePriceView(record, normsName, normsPrice, callback) {
	if (!record)
		return;
	var me = this;
	var timePriceView = null;
	var name = normsName ? record.get('name') + '(' + normsName + ')' : record.get('name');
	var price = normsPrice ? normsPrice : record.get('price');
    price = record.get('isSpecialPrice') == 1 ? record.get('specialPrice')  : price;
    // alert(record.isSpecialPrice);
	// if (Ext.getCmp('id-time-price-view')) {
	// 	Ext.getCmp('id-time-price-view').show();
	// 	Ext.getCmp('time-price-toolbar').setTitle(name); // 商品名称
	// 	Ext.getCmp('id-time-price-commodity-price').setValue(price); // 单价
	// 	Ext.getCmp('id-time-price-commodity-num').setValue('1'); // 数量
	// 	return;
	// }
	var soldoutStatus = record.get('soldoutStatus');
	var soldoutNum = parseFloat(record.get('soldoutNum'));
	var remainNum = parseFloat(record.get('remainNum'));
	var isClickSoldout = false;
	if (soldoutStatus == '1' && soldoutNum > 0 && remainNum > 0) {
		isClickSoldout = true;
	}
	var currInputField = null;
	//function getInputField() {
	var getInputField = function() {
		return currInputField;
		var commodityPriceCmp = Ext.getCmp('id-time-price-commodity-price');
		var commodityNumCmp = Ext.getCmp('id-time-price-commodity-num');
		var priceCls = commodityPriceCmp.getCls();
		if(priceCls instanceof Array) {
			for(var priceClsKey in priceCls) {
				if(priceCls.hasOwnProperty(priceClsKey) && priceCls[priceClsKey] == 'x-field-focused') {
					return commoditiyPriceCmp;
				}
			}
		} else if(priceCls.indexOf('x-field-focused') > -1) {
			return commodityPriceCmp;
		}
		var numCls = commodityNumCmp.getCls();
		if(numCls instanceof Array) {
			for(var numClsKey in numCls) {
				if(numCls.hasOwnProperty(numClsKey) && numCls[numClsKey] == 'x-field-focused') {
					return commodityNumCmp;
				}
			}
		} else if(numCls.indexOf('x-field-focused') > -1) {
			return commodityNumCmp;
		}
		
		return null;
		/*if(commodityPriceCmp.getCls().indexOf('x-field-focused') > -1) {
			return commodityPriceCmp;
		} else if(commodityNumCmp.getCls().indexOf('x-field-focused') > -1) {
			return commodityNumCmp;
		} else return null;*/
	}
	//function numberCallBack() {
	var numberCallBack = function() {
		var fieldCmp = getInputField();
		if(fieldCmp.id === "id-time-price-commodity-price") {
			var timePriceEle = $("input[name=commodityTimePrice]");
			if(timePriceEle && timePriceEle[0]) {
				var eleValue = timePriceEle[0].value;
				var eleSelectStart = timePriceEle[0].selectionStart;
				var eleSelectEnd = timePriceEle[0].selectionEnd;
				if(eleValue.substring(eleSelectStart, eleSelectEnd) == eleValue)
					return true;
			}
		}
		return false;
	}
	//function confirmHandler() {
	var confirmHandler = function() {
		var timePriceCommPrice = Ext.getCmp('id-time-price-commodity-price').getValue();
		var timePriceCommNum = Ext.getCmp('id-time-price-commodity-num').getValue();
		new Promise(function(resolve, reject) {
			if(price!=timePriceCommPrice) {
				checkPermissions(PERMISSIONS.TIMEPRICEMODIFY, true, "对不起,您没有权限修改时价菜价格!")
				.then(function() {resolve();})
				.catch(function() {reject();});
	    	} else resolve();
		}).then(function() {confirmHandler2();});
	}
	//function confirmHandler2() {
	var confirmHandler2 = function() {
		var timePriceCommPrice = Ext.getCmp('id-time-price-commodity-price').getValue();
		var timePriceCommNum = Ext.getCmp('id-time-price-commodity-num').getValue();
		if (!timePriceCommPrice) {
			showAlert('提示', '请输入商品时价!');
			return;
		} else if (!checkPositiveNumber(timePriceCommPrice)) {
			showAlert('提示', '请输入商品时价的正确格式!');
			return;
		}
		if (getNumDigitLength(timePriceCommPrice)[0] > 8) {
            showAlert('提示', '输入金额过大！<br>整数位仅允许 8 位');
            return;
		}
		if (!timePriceCommNum) {
			showAlert('提示', '请输入商品数量!');
			return;
		} else if (!checkPositiveNumber(timePriceCommNum) || parseFloat(timePriceCommNum) == 0) {
			showAlert('提示', '请输入商品数量的正确格式!');
			return;
		}
        if (getNumDigitLength(timePriceCommNum)[0] > 4) {
            showAlert('提示', '输入数量过大！<br>整数位仅允许 4 位');
            return;
        }
        
		timePriceCommPrice = parseFloat(timePriceCommPrice);
		timePriceCommNum = parseFloat(timePriceCommNum);
		if (Ext.getCmp('shouyinMainView').shouhanMode == '2') {
		} else {
			if (isClickSoldout) {
				if ((remainNum || soldoutNum) && timePriceCommNum > remainNum) {
					if (Ext.getCmp('shouyinMainView').shouhanMode != '2') {
						showCommoditySoldout({
							name : name
						});
						return;
					}
				}
				if (!remainNum && remainNum != 0) {
					record.set('remainNum', parseFloat(soldoutNum - timePriceCommNum).toFixed(2));
				} else
					record.set('remainNum', parseFloat(remainNum - timePriceCommNum).toFixed(2));
			}
		}
		var copyRecord = record.copy(record.get('id'));
		copyRecord.set('price', timePriceCommPrice);
		if (Ext.getCmp('search_view') && !Ext.getCmp('search_view').getHidden()) {
			// 搜索框已初始化且显示
			var commStore = Ext.getCmp('showyin-commodity-list').getStore();
			var commRecord = commStore.findRecord('id', copyRecord.get('id'));
			if (commRecord) {
				commRecord.set('price', timePriceCommPrice);
                commRecord.set('sellCommNum', timePriceCommNum);
                // 在搜索页点菜时同步收银页商品剩余数量
				if (isClickSoldout && record != commRecord) {
					if (!remainNum && remainNum != 0) {
						commRecord.set('remainNum', parseFloat(soldoutNum - timePriceCommNum).toFixed(2));
					} else
						commRecord.set('remainNum', parseFloat(remainNum - timePriceCommNum).toFixed(2));
				}
			}
		}
		//copyRecord.set('sellNum', timePriceCommNum);
		copyRecord.set('sellCommNum', timePriceCommNum);
		var updateCommData = null;
		if (normsName && normsPrice >= 0) {
			if (record.get('price') == normsPrice && record.get('price') != timePriceCommPrice) {
				record.set('price', timePriceCommPrice);
				if (!updateCommData)
					updateCommData = {};
				updateCommData.price = timePriceCommPrice;
			}
			var normsPriceArray = ['1', '2', '3', '4', '5', '6', '7', '8'];
			for (var ni = 0, nlen = normsPriceArray.length; ni < nlen; ni++) {
				var normsPriceTxt = 'normsPrice' + normsPriceArray[ni];
				var normsPriceVal = record.get(normsPriceTxt);
				if (normsPriceVal == normsPrice && normsPriceVal != timePriceCommPrice) {
					// (规格大小)修改之后的价格与之前的价格不同
					record.set(normsPriceTxt, timePriceCommPrice);
					if (!updateCommData)
						updateCommData = {};
					updateCommData[normsPriceTxt] = timePriceCommPrice;
					break;
				}
			}
		} else {
			if (price != timePriceCommPrice) {
				record.set('price', timePriceCommPrice);
				if (!updateCommData)
					updateCommData = {};
				updateCommData.price = timePriceCommPrice;
			}
		}
		if (updateCommData) {
			updateCommData.syned = '0';
			CommodityDao.updateCommodity(updateCommData, record.get('id'), function(success) {
				sendCommodityUpdate();
			});
		}
		callback && callback();
		Ext.getCmp('shouyinMainView').addCommodity(copyRecord, normsName, timePriceCommPrice);
		//me.parentContainer.addCommodity(copyRecord, normsName, timePriceCommPrice);
		if (Ext.getCmp('id-time-price-view')) {
			Ext.getCmp('id-time-price-view').hide();
			// Ext.getCmp('id-time-price-view').destroy();
		}
	}
	
	if (Ext.getCmp('id-time-price-view')) {
		timePriceView = Ext.getCmp('id-time-price-view');
		Ext.getCmp('time-price-toolbar').setTitle(name); // 商品名称
		Ext.getCmp('id-time-price-commodity-price').setValue(price); // 单价
		Ext.getCmp('id-time-price-commodity-num').setValue('1'); // 数量
	} else {
		timePriceView = Ext.Viewport.add({
			xtype : 'panel',
			id : 'id-time-price-view',
			layout : 'vbox',
			//width : 360,
			//height : 200,
			width : 450,
			height : 400,
			modal : true,
			centered : true,
			hideOnMaskTap : false,
			items : [{
				xtype : 'toolbar',
				title : name, //'时价菜设置',
				docked : 'top',
				id: 'time-price-toolbar',
				items : [getDefaultToolbarLeftViewForHandler(function() {
					if (Ext.getCmp('id-time-price-view')) {
						Ext.getCmp('id-time-price-view').hide();
						// Ext.getCmp('id-time-price-view').destroy();
					}
				}), {
					xtype : 'button',
					cls : 'close-button',
					hidden : true,
					handler : function() {
						if (Ext.getCmp('id-time-price-view'))
							Ext.getCmp('id-time-price-view').destroy();
					}
				}, {
					xtype : 'spacer'
				}, {
					xtype : 'button',
					cls : 'sy-tm-button',
					hidden : true,
					text : '确定',
					handler : function() {
						confirmHandler();
					}
				}]
			}, {
				xtype : 'panel',
				layout : 'vbox',
				flex : 1,
				items : [{
					xtype : 'fieldset',
					margin : '5 5 5 5',
					id : 'time-price-field-set',
					flex : 1,
					defaults : {
						labelWidth : 130
					},
					items : [{
						//xtype : 'numberfield',
						xtype : 'textfield',
						label : '单价',
						placeHolder : '最多两位小数',
						maxLength : 11,
						//name : 'commodityPrice',
						focus : true,
						name : 'commodityTimePrice',
						id : 'id-time-price-commodity-price',
						value : price,
						listeners : {
							focus : function(curView, e, eOpts) {
								currInputField = Ext.getCmp('id-time-price-commodity-price');
							},
	                        clearicontap : function (curView, e, eOpts) {
								Ext.getCmp('id-time-price-commodity-price').focus();
	                        }
						}
					}, {
						//xtype : 'numberfield',
						xtype : 'textfield',
						label : '数量',
						maxLength : 7,
						placeHolder : '最多两位小数',
						name : 'commodityNum',
						id : 'id-time-price-commodity-num',
						value : 1,
						listeners : {
							focus : function(curView, e, eOpts) {
								currInputField = Ext.getCmp('id-time-price-commodity-num');
							},
	                        clearicontap : function (curView, e, eOpts) {
	                            Ext.getCmp('id-time-price-commodity-num').focus();
	                        }
						}
					}, {
						xtype : 'textfield',
						label : '商品名称',
						value : name,
						hidden : true,
						id : 'id-time-price-commodity-name',
						name : 'commodityName',
						readOnly : true
					}]
				}]
			}, {
				xtype : 'formpanel',
				hidden : true,
				id : 'time-price-form-panel',
				flex : 1,
				items : [{
					xtype : 'fieldset',
					margin : '0 0 0 0',
					instructions : '',
					flex : 1,
					defaults : {
						labelWidth : 130
					},
					items : [{
						xtype : 'textfield',
						label : '商品名称',
						value : record.get('name'),
						name : 'commodityName',
						readonly : true,
					}, {
						xtype : 'textfield',
						label : '商品价格',
						name : 'commodityPrice',
						value : record.get('price'),
					}, {
						xtype : 'numberfield',
						label : '商口数量',
						name : 'commodityNum',
						value : 1
					}]
				}]
			}, getInputNumberViewTimePrice(getInputField, numberCallBack, confirmHandler)]
		});
	}
	timePriceView.show();
	Ext.getCmp('id-time-price-view').setZIndex(99);
	var inputNumberCmp = Ext.getCmp("input-number-view-button");
	if(inputNumberCmp) inputNumberCmp.setHandler(function(){confirmHandler&&confirmHandler();});
	var timePricePanel = Ext.getCmp("id-time-price-commodity-price");
	if(timePricePanel) timePricePanel.focus();
	var inputPriceEle = $("input[name=commodityTimePrice]");
	if(inputPriceEle && inputPriceEle.select) inputPriceEle.select();
}
function showSearch() {
	var searchView = Ext.getCmp('search_view');
	if (searchView) {
        searchView.setHeight($(window).height());
        Ext.getCmp('search-commodityinfo-list').setHeight($(window).height() - 450);
        Ext.getCmp('search-commodityinfo-panel').setHeight($(window).height() - 385);
        Ext.getCmp('commoditySearchField').setValue('');
        var store = Ext.getStore('search-commodityinfo-store');
        store.removeAll();
        showBy(searchView, Ext.getCmp('shouyinMainView'));
        searchView.setParentContainer(searchView);
        return;
	}
	searchView = Ext.Viewport.add(Ext.create('Seller.view.shouyin.CommoditySearch'));
	showBy(searchView, Ext.getCmp('shouyinMainView'));
	searchView.setParentContainer(searchView);
}

function showCommoditySoldout(commInfo) {
	showAlert('提示', '<span style="color:red;">' + commInfo.name + '</span> 商品数量不足!');
}
//从购物车计算剩余沽清数量
function calcRemainNumFromCart(commInfo) {
	if (commInfo.soldoutStatus == '1') {
		var cartPageStore = getPageStore();
		if (cartPageStore.getCount() <= 0) {
			commInfo.remainNum = commInfo.soldoutNum ? commInfo.soldoutNum : 0;
		} else {
			var isSellInfo = false;
			if (Ext.getCmp('shouyinMainView').sellInfo)
				isSellInfo = true;
			var cartRecords = cartPageStore.queryBy(function(record, id) {
				if (record.get('commodityId') == commInfo.id) {
					if (isSellInfo) {
						if (record.get('type') == 1 || record.get('type') == 2)
							return true;
					} else
						return true;
				}
				return false;
			});
			var cartRecordNum = cartRecords.getCount();
			var cartCommNum = 0;
			if (cartRecordNum > 0) {
				for (var ci = 0; ci < cartRecordNum; ci++) {
					var cartRecord = cartRecords.getAt(ci);
					if (cartRecord.get('commodityId') == commInfo.id) {
						cartCommNum += parseFloat(cartRecord.get('sellNum'));
					}
				}
			}
			//if (commInfo.remainNum > cartCommNum)
				//commInfo.remainNum = commInfo.remainNum - cartCommNum;
			if(commInfo.soldoutNum > cartCommNum)
				commInfo.remainNum = parseFloat(commInfo.soldoutNum - cartCommNum).toFixed(2);
			else
				commInfo.remainNum = 0;
		}
	}
}
//沽清商品操作
function optCommodityForSoldout(record) {
	var remainNum = parseFloat(record.get('remainNum'));
	var soldoutNum = parseFloat(record.get('soldoutNum'));
	if (!remainNum && remainNum != 0) {
		record.set('define3', soldoutNum); // 剩下的数量
		if (soldoutNum < 1 && soldoutNum > 0) {
			record.set('remainNum', 0);
		} else {
			record.set('remainNum', parseFloat(soldoutNum - 1).toFixed(2));
		}
	} else {
		record.set('define3', remainNum);
		if (remainNum > 0 && remainNum < 1) {
			record.set('remainNum', 0);
		} else {
			record.set('remainNum', parseFloat(remainNum - 1).toFixed(2));
		}
	}
}
/* 刷新商品沽清数量 */
function refreshCommodityForSoldout(record) {
	var commodityStore = Ext.getStore('showyin-commodity-store');
	var commodityRecord = commodityStore.findRecord('id', record.get('id'));
	if(!commodityRecord) {
		commodityRecord.set('remainNum', record.get('remainNum'));
	}
}

//重量数据解析
 /**
 *
 * @param comName 可空
 * @param callback fucntion(flag1, sign, weight, unit, isZero, isNetWeight, isWeightAbnormal)
 *                      Flag1：1字节，状态： ‘F’：重量溢出，或没有开机归零。 ‘S’：重量稳定。 ‘U’：重量不稳定。
 *                      Sign：1字节，符号：  ‘－’：重量为负。  ‘ ’：重量为正。
 *                      Weight：6字节，重量
 *                      Unit：2字节，单位
 *                      isZero：当前重量是否为零
 *                      isNetWeight：当前在是否在去皮模式
 *                      isWeightAbnormal：当前是否重量溢出，或没有开机归零
 */
var tempSerialWeight = [];
var isKeepRead = false;
function getWeight(){
	var _weightInfo = [];
	//console.log('serialWeightInfo',serialWeightInfo);
	if(!serialWeightInfo && serialWeightInfo.length < 0){
		return;
	}

	if(serialWeightInfo[0] == 0x01){
		isKeepRead = true;
		for(var i = 0; i < serialWeightInfo.length; i++){
			tempSerialWeight.push(serialWeightInfo[i]);
		}
		if(tempSerialWeight.length < 16){
			return;
		}
	}else if(isKeepRead && tempSerialWeight.length < 16){
		for(var j = 0; j < serialWeightInfo.length; j++){
			tempSerialWeight.push(serialWeightInfo[j]);
		}
		return;
	}
	if(!isKeepRead && tempSerialWeight.length < 16){
		return;
	}

	//检测数据是否有效
/*	var dataArray = tempSerialWeight
	var data0 = dataArray[0];
	for (var datai = 0, leng = dataArray.length; datai < leng; datai++){
		if (data0 == 0x01){
			_weightInfo.push(dataArray[datai]);
		} else {
			return;
		}
	}
	if (_weightInfo.length == 16){
		if (_weightInfo[0] == 0x01 && _weightInfo[1] == 0x02){
			if (_weightInfo[13] == 0x03 && _weightInfo[14] == 0x04){
				//handler data
				OS2XWeightInfo = _weightInfo;
			}
		}
	}*/
    var checkDataIndex = 0;
	for(var k = 0; k < tempSerialWeight.length; k++){
		if(tempSerialWeight[k] == 1 || tempSerialWeight[k] == 2 || tempSerialWeight[k] == 3){
			checkDataIndex++
		}
		if(tempSerialWeight[k] == 4 || tempSerialWeight[k] == 0){
			checkDataIndex++
		}

	}
	if(checkDataIndex > 5){
		//console.log('tempSerialWeigh无效',tempSerialWeight);
		tempSerialWeight = [];
		return
	}

	var dataArray1;

	if (tempSerialWeight.length == 16){
		if (tempSerialWeight[0] == 0x01 && tempSerialWeight[1] == 0x02){
			if (tempSerialWeight[13] == 0x03 && tempSerialWeight[14] == 0x04){
				//handler data
				dataArray1 = tempSerialWeight;
			}
		}
	}

	//console.log('dataArray1',dataArray1);

	if(dataArray1)
	{
		var flag1, sign, weight, unit, isZero, isNetWeight, isWeightAbnormal;

		var index = 0;

		index++;
		index++;

		flag1 = String.fromCharCode(dataArray1[index++]);

		sign = String.fromCharCode(dataArray1[index++]);

		weight = (function() {
			var _weight = "";
			for(var i =0; i < 6; i++) {
				_weight += String.fromCharCode(dataArray1[index++]);
			}
			return _weight;
		})();

		unit = String.fromCharCode(dataArray1[index++]) + String.fromCharCode(dataArray1[index++]);

		index++;
		index++;
		index++;

		isZero = dataArray1[index] & 1 << 4 ? true :false;
		isNetWeight = dataArray1[index] & 1 << 5 ? true :false;
		isWeightAbnormal = dataArray1[index] & 1 << 6 ? true :false;

		//OS2XManager.prototype.dataReceivedHandler(flag1, sign, weight, unit, isZero, isNetWeight, isWeightAbnormal);
		//callback && callback(flag1, sign, weight, unit, isZero, isNetWeight, isWeightAbnormal);

		tempSerialWeight = [];
		serialWeightInfo = [];
		isKeepRead = false;
		return {
			'flag1' : flag1,
			'sign'  :sign,
			'commodityWeight': weight,
			'unit'  : unit
		};
	}
}

var tempDHSerialWeight = [];
var isDHKeepRead = false;
function getDHWeight(){
	var _weightInfo = [];
	if(!serialDHWeightInfo && serialDHWeightInfo.length < 0 && serialDHWeightInfo.length < 7){
		return;
	}
	if(serialDHWeightInfo.length > 11){
		return;
	}
	var tempDHSerialWeight = serialDHWeightInfo;

	var dataArray1;

	if(elebalanceSetting.answerMode == 'ASU'){//大华称应答上传
		if (tempDHSerialWeight.length == 11){//大华称应答模式数据长度11位
			if (tempDHSerialWeight[0] == 2 && tempDHSerialWeight[9] == 75 && tempDHSerialWeight[10] == 71 ){
				dataArray1 = tempDHSerialWeight;
			}
		}
	}
	if(elebalanceSetting.answerMode == 'AUU'){//大华称自动上传
		if (tempDHSerialWeight.length == 7){//大华称自动上传模式数据长度7位
			if (tempDHSerialWeight[0] == 10){
				dataArray1 = tempDHSerialWeight;
			}
		}
	}

	if(dataArray1)
	{
		var flag1, sign, weight, unit;

		var index = 0;

		if(dataArray1.length == 7){//大华称自动上传模式数据处理
			index++;

			weight = '';
			weight += String.fromCharCode(dataArray1[index++]);
			weight += String.fromCharCode(dataArray1[index++]);
			weight += String.fromCharCode(dataArray1[index++]);
			weight += '.';
			weight += String.fromCharCode(dataArray1[index++]);
			weight += String.fromCharCode(dataArray1[index++]);
			weight += String.fromCharCode(dataArray1[index++]);

			if(weight.indexOf('-') != -1){
				sign = '-';
				weight = weight.replace(/(^\s*)-/, '');
			}
		}

		if(dataArray1.length == 11){//大华称应答上传模式数据处理
		    index ++ ;
			weight = '';
			weight += String.fromCharCode(dataArray1[index++]);
			weight += String.fromCharCode(dataArray1[index++]);
			weight += String.fromCharCode(dataArray1[index++]);
			weight += String.fromCharCode(dataArray1[index++]);
			weight += String.fromCharCode(dataArray1[index++]);
			weight += String.fromCharCode(dataArray1[index++]);
			weight += String.fromCharCode(dataArray1[index++]);

		}

		tempDHSerialWeight = [];
		serialDHWeightInfo = [];
		isKeepRead = false;
		return {
			'flag1' : 'S',
			'sign'  :sign,
			'commodityWeight': weight,
			'unit'  : 'kg'
		};
	}
}


function stopSerialPort(){
	serialPortController.serialPortStop = true;
	serialPortController.serialPortStart = false;
	serialPortController.startAnswerModeTimer = false;
    serialPortController.stopAnswerModeTimer = true;
	serialPortSocket && serialPortSocket.send(JSON.stringify(serialPortController));
}

//启动电子秤
function launchElebalance(record) {
	//负数情况要处理  Sign：1字节，符号：  ‘－’：重量为负。  ‘ ’：重量为正。
	serialPortController = {};
	//防止重复点击
	if(isAlreadyLanuchEbalance){
		return;
	}
	isAlreadyLanuchEbalance = true;
	var alreadyLanuchEbalanceTimer = setTimeout(function(){
		isAlreadyLanuchEbalance = false;
		clearTimeout(alreadyLanuchEbalanceTimer);
	}, 500);
    
    //如果是关闭状态开启serialPortSocket服务
	if(!serialPortSocket || serialPortSocket.readyState == 3){
		connectSerialPortSocket();
	}
	
	//正在关闭状态
    if(serialPortSocket.readyState == 2 || serialPortSocket.readyState == 0){
		showAlert("提示", "正在初始化电子秤数据，请重试!");
		return;
	}
	
	var elebalanceDalay = 10;
	
	//判断秤类型
	var isDHEleBalance = (elebalanceSetting.elebalanceType == 'D');
	
	if(isDHEleBalance && elebalanceSetting.answerMode == 'ASU'){
		serialPortController.startAnswerModeTimer = true;
		serialPortController.stopAnswerModeTimer = false;
		elebalanceDalay = 200;
	}

	//非弹窗取重
	if(elebalanceSetting.isPopreadweightMode === 'F') {

		var isSerialSuccess = false;

		serialPortController.serialPortStart = true;
		serialPortController.serialPortStop = false;
		serialPortController.storageCOM = elebalanceSetting.elebalancePort;
		console.log(serialPortController.storageCOM);
		serialPortSocket && serialPortSocket.send(JSON.stringify(serialPortController));

		showLoading("正在获取商品重量，请稍后...");
		
		//数据置空，防止缓存
		serialDHWeightInfo = [];
		serialWeightInfo = [];
		
		lanuchEbalance_timer = setInterval(function(){
			var weightInfo = isDHEleBalance ? getDHWeight() : getWeight();
			if(weightInfo && (weightInfo.flag1 == 'S') && (weightInfo.sign != '-')){
				weightInfo.flag1 = '';
				isSerialSuccess = true;
				clearInterval(lanuchEbalance_timer);
				closeLoading();
				if(parseFloat(weightInfo.commodityWeight).toFixed(2) <= 0){

					stopSerialPort();

					showAlert("提示", "重量不能为零或获取数据有误，请重新称重!");
					return;
				}
				
				stopSerialPort();
				
				//将数据存进组件
				var weight = elebalanceSetting.weightBase*weightInfo.commodityWeight;
				//将数据存进组件
				record.set({'sellCommNum': Math.round(weight*100)/100 });
							
				//添加商品
				Ext.getCmp('select-commodity-view').optCommodityForNeed(record);
				
			}
		}, elebalanceDalay);

		//超时处理
		setTimeout(function(){
			if(!isSerialSuccess){
				clearInterval(lanuchEbalance_timer);
				
				stopSerialPort();
				
				closeLoading();
				showAlert("提示", "数据读取有误或电子秤配置有误，可重试或在系统设置处测试正确配置！", null, null, 200, null, null, 280);
			}
		}, 5000);

	}//弹窗取重
	else if(elebalanceSetting.isPopreadweightMode === 'T'){

		var isSerialSuccess = false;

		serialPortController.serialPortStart = true;
		serialPortController.serialPortStop = false;
		serialPortController.storageCOM = elebalanceSetting.elebalancePort;
		serialPortSocket && serialPortSocket.send(JSON.stringify(serialPortController));


		// var commodityWeightView = addViewportCenter('commodityWeightView', 'commodityweight', 500, 300, true);
		// showBy(commodityWeightView,Ext.getCmp('shouyinMainView'));
		showCommodityWeightView();

		var commodityWeightContent = Ext.getCmp('commodityweight-view');
		var weightBase = parseFloat(elebalanceSetting.weightBase);//重量系数
		var weightName =  Ext.getCmp('weight-name');
		var weightprice = Ext.getCmp('weight-price');
		var weightSumPrice = Ext.getCmp('weight-sum-price');
		var commodityWeight = Ext.getCmp('commodity-weight');

		weightName.setValue(record.get('name') + '  (单位：'+record.get('unit')+')');
		weightprice.setValue(record.get('price'));
		var price = weightprice.getValue();
		weightprice.setValue(record.get('price'));
		var sumPrice;
		
		//数据置空，防止缓存
		serialDHWeightInfo = [];
		serialWeightInfo = [];

		lanuchEbalance_timer = setInterval(function(){
		
			var weightInfo = isDHEleBalance ? getDHWeight() : getWeight();

			if(weightInfo && (weightInfo.flag1 == 'S') && (weightInfo.sign != '-')){

				isSerialSuccess = true;

				eleWeightData[0] = weightInfo.commodityWeight;
				if(eleWeightData[0] !== eleWeightData[1]){

					sumPrice = (weightBase*weightInfo.commodityWeight * price).toFixed(2);
					commodityWeight.setValue((weightBase*weightInfo.commodityWeight).toFixed(3));
					weightSumPrice.setValue(sumPrice);

					//将数据存进组件
					record.set({'sellCommNum': (weightBase*weightInfo.commodityWeight).toFixed(2)});
					//record.set({'unit': 'KG'});
					commodityWeightContent.setData(record);
					console.log('更新数据');

				}

				eleWeightData[1] = weightInfo.commodityWeight;

				//弹窗取重自动关闭窗口
				if (elebalanceSetting.isAutoConfirm === 'T') {

					 clearInterval(lanuchEbalance_timer);

					 var val = parseFloat(Ext.getCmp('commodity-weight').getValue());

					 if(val === 0){

						 stopSerialPort();
						 showAlert('提示', '重量不能为零，请重新称重！');
						 hideCommodityWeightView();
						 // Ext.getCmp('commodityweight-view').getParent().destroy();
						 return;
					 }

					 eleWeightData[1] = null;
					 eleWeightData[0] = undefined;

					 var closeTimer = setTimeout(function () {
					 
					     stopSerialPort();
						 
						 window.clearTimeout(closeTimer);
						 record.set({'price': parseFloat(weightprice.getValue())});
						 record.set({'sellCommNum': Math.round(commodityWeight.getValue()*100)/100});
						 Ext.getCmp('select-commodity-view').optCommodityForNeed(record);
						 hideCommodityWeightView();
						 // Ext.getCmp('commodityweight-view').getParent().destroy();
					 }, 1000);
				 }
			}
		}, elebalanceDalay);

		//超时处理
		setTimeout(function(){
			if(!isSerialSuccess){
				clearInterval(lanuchEbalance_timer);
				
				stopSerialPort();
				hideCommodityWeightView();
				// Ext.getCmp('commodityweight-view').getParent().destroy();
				closeLoading();
				showAlert("提示", "数据读取有误或电子秤配置有误，可重试或在系统设置处测试正确配置！", null, null, 200, null, null, 280);
			}
		}, 5000);

	}

}

function canOrder(record,type,amount,callback) {
    /*CommodityDao.getCommodityInfoById(jsonDataPar[i].commodityId,function(success,items) {
            if (success) {
                var cmRecord = cmStore.findRecord('id', items.id);
                if(cmRecord.get('remainNum') < 1) {
                    alert('remain < 1');
                    //return false;
                    callback && callback(false);
                }
            }
        })*/
    var cmList = Ext.getCmp('showyin-commodity-list');
    var cmStore = cmList.getStore();
    var liStore = getPageStore();

    if(type == 0 || type == 1) {
        if(type == 0) {
            var jsonData = record.get('comboMealsJson');
            var jsonDataPar = JSON.parse(jsonData);
        }else if(type == 1){
            var jsonData = record;
            var jsonDataPar = JSON.parse(jsonData);
        }else alert('check if can order error!');

        var liRecord, orderedCommodityInfo4load = [], jsonPar, soldoutNum_temp, orderedCommodityInfo = [],
            unfoundElementList = [], unfoundElementList4load = [], list = [], orderedComboMealsDetail = [],
            requireNum = [], unfoundComboList = [];
        // alert(jsonDataPar.length);
        for (var i = 0; i < jsonDataPar.length; i++) {
            // alert('i : ' + i);
            var comboObject = jsonDataPar[i];
            // alert('comboObject : ' + comboObject.commodityName);
            var cmRecord = cmStore.findRecord('id', comboObject.commodityId);
            // alert('cmRecord : ' + cmRecord);
            if (cmRecord && cmRecord.get('soldoutStatus') == '1') {
                if (cmRecord.get('remainNum') < comboObject.commodityNum * amount) {
                    return callback && callback(false);
                    // return false;
                }
            } else if (!cmRecord) {
                unfoundElementList4load.push("\'" + comboObject.commodityId + "\'");
                unfoundElementList.push(comboObject.commodityId);
                // requireNum.push(comboObject.commodityId);
                requireNum.push(comboObject.commodityNum);
                // alert(unfoundElementList);
                // unfoundComboList.push(requireNum);
            }
        }

        for (var i = 0; i < liStore.getCount(); i++) {//获取已下单菜品
            liRecord = liStore.getAt(i);
            orderedCommodityInfo4load.push("\'" + liRecord.get('commodityId') + "\'");
            orderedCommodityInfo.push(liRecord.get('commodityId'));
            orderedCommodityInfo.push(liRecord.get('sellNum'));
        }
        if (unfoundElementList4load) {
            CommodityDao.loadCommodityInfoByIds(unfoundElementList4load, function (eleSuccess, elementsInfo) {
                CommodityDao.loadCommodityInfoByIds(orderedCommodityInfo4load, function (ordSuccess, ordInfo) {
                    if (eleSuccess && ordSuccess) {
                        for (var k = 0; k < elementsInfo.length; k++) {//将正下单商品 和 已下单商品 进行对比 if中查看 已下单套餐中是否有重复，若有，输出 套餐id + 该套餐包含多少元素
                            for (var i = 0; i < ordInfo.length; i++) {
                                if (ordInfo[i].category == '2') {
                                    jsonPar = JSON.parse(ordInfo[i].comboMealsJson);
                                    for (var t = 0; t < jsonPar.length; t++) {
                                        if (jsonPar[t].commodityId == elementsInfo[k].id && elementsInfo[k].soldoutStatus == '1') {
                                            list.push(jsonPar[t].commodityId);
                                            list.push(jsonPar[t].commodityNum);
                                        }
                                    }
                                    list.unshift(ordInfo[i].id);
                                    // alert(list);
                                    orderedComboMealsDetail.push(list);
                                    list = [];
                                }
                            }
                            // alert(orderedComboMealsDetail);
                        }
                        for (var i = 0; i < elementsInfo.length; i++) {
                            soldoutNum_temp = elementsInfo[i].soldoutNum;
                            // alert(soldoutNum_temp);
                            for (var j = 0; j < orderedCommodityInfo.length; j += 2) {
                                if (orderedCommodityInfo[j] == elementsInfo[i].id) {
                                    soldoutNum_temp -= orderedCommodityInfo[j + 1];
                                } else {
                                    for (var k = 0; k < orderedComboMealsDetail.length; k++) {
                                        if (orderedCommodityInfo[j] == orderedComboMealsDetail[k][0]) {
                                            for (var t = 1; t < orderedComboMealsDetail[k].length; t += 2) {
                                                if (elementsInfo[i].id == orderedComboMealsDetail[k][t]) {
                                                    soldoutNum_temp -= orderedCommodityInfo[j + 1] * orderedComboMealsDetail[k][t + 1];
                                                    // alert(soldoutNum_temp);

                                                }
                                            }
                                        }
                                    }
                                }
                            }
                            // alert(soldoutNum_temp);

                            for (var l = 0; l < jsonDataPar.length; l++) {
                                if (jsonDataPar[l].commodityId == elementsInfo[i].id) {
                                    if (soldoutNum_temp < jsonDataPar[l].commodityNum * amount) {
                                        // alert('limit');
                                        return callback && callback(false);
                                        // return false;
                                    }
                                }
                            }
                        }
                        return callback && callback(true);
                        // return true;
                    }
                    else {
                        alert('load data failed')
                    }
                })
            })
        } else {
            // alert ('get in');
            return callback && callback(true);
            // return true;
        }
        // return true;
        // else if(!cmRecord){
        // 	for(var i = 0; i < liStore.getCount(); i++){

        // liRecord = liStore.getAt(i);
        // list.push("\'" + liRecord.get('commodityId') + "\'");
        // idList.push(liRecord.get('commodityId'));
        // idList.push(liRecord.get('sellNum'));
        // 	}
        // 	list.unshift("\'" + comboObject.commodityId + "\'");
        // 	alert(idList);
        // 	alert(list);
        //
        //    CommodityDao.loadUseCommodityInfoByIds(list,function (success, cominfos) {
        //    	alert('loading');
        //    	if(!success)alert('fail to load');
        // 		if(success) {
        // 			alert('11');
        // 			for (var i = 0; i < cominfos.length+1; i++) {//把已下单的菜品提出 挑选出 套餐
        // 				if(cominfos[i].id == comboObject.commodityId) {
        //                    soldoutNum_temp = cominfos[i].soldoutNum;
        //                    alert('soldoutNum_temp' + soldoutNum_temp);
        //                }
        // 				if (cominfos[i].category == '2') {
        // 					jsonPar = JSON.parse(cominfos[i].comboMealsJson);
        // 					var comboMealsList = [];
        // 					for (var t = 0; t < jsonPar.length; t++) {//格式为：套餐名,包含份数
        // 						if(jsonPar[t].commodityId == comboObject.commodityId){
        // 							comboMealsList.push(jsonPar.comboId);
        // 							comboMealsList.push(jsonPar.commodityNum);
        // 						}
        // 					}
        // 					// alert(comboMealsList);
        // 					// jsonList.unshift(cominfos[i].id);
        // 					// comboMealsList.push(jsonList);
        // 				}
        // 			}
        //
        //            for(var i = 0; i < idList.length; i+=2){
        // 				if(comboObject.commodityId == idList[i]){
        // 					alert('11');
        // 					soldoutNum_temp -= idList[i+1];
        // 				}else for(var j = 0; j <comboMealsList.length; j+=2){
        // 					if(comboMealsList[j] == idList[i]){
        // 						soldoutNum_temp -= comboMealsList[j+1] * idList[i+1];
        // 					}
        // 				}
        //            }
        //            alert(soldoutNum_temp + ',' + comboObject.commodityNum)
        //            if(soldoutNum_temp < comboObject.commodityNum) {
        // 				return false;
        //            }
        //            // return true;
        // 		}
        //    })
        // }


        /**
         else if(!cmRecord){
            CommodityDao.getCommodityInfoById(jsonDataPar[i].commodityId,function(success,items) {
                if (success) {
                	var remainNum_temp = items.soldoutNum;
                	for(var i = 0; i < liStore.getCount(); i++){
                		liRecord = liStore.getAt(i);
                		if(liRecord.get('commodityId') == comboObject.commodityId){
                			remainNum_temp -= liRecord.get('sellNum');
						}else{
                			CommodityDao.getCommodityInfoById(liRecord.get('commodityId'),function(success,liItems) {
                				if(success && liItems.category == '2'){
                					var jsonDataPar_temp = JSON.parse(liItems.comboMealsJson);
                					for(var t = 0; t < jsonDataPar_temp.length; t++) {
                                        if (jsonDataPar_temp[t].commodityId == comboObject.commodityId) {
                                            remainNum_temp -= liRecord.get('sellNum') * jsonDataPar_temp[t].commodityNum;
                                        }
                                    }
								}
                            })
                        }
					}
				}
            })
		}*/
        // }
        return true;
    }
    if(type == 2){
        var orderedCommodityInfo4load = [],orderedCommodityInfo = [];
        var soldoutNum_temp;
        var liRecord, jsonPar;
        for (var i = 0; i < liStore.getCount(); i++) {//获取已下单菜品
            liRecord = liStore.getAt(i);
            orderedCommodityInfo4load.push("\'" + liRecord.get('commodityId') + "\'");
            orderedCommodityInfo.push(liRecord.get('commodityId'));
            orderedCommodityInfo.push(liRecord.get('sellNum'));
        }

        CommodityDao.getCommodityById(record.get('commodityId'),function(findInvisibleSuccess,invisibleItem) {
            CommodityDao.loadCommodityInfoByIds(orderedCommodityInfo4load, function (findOrderedSuccess, orderedItems) {
                if(findInvisibleSuccess && findOrderedSuccess){
                    soldoutNum_temp = invisibleItem.soldoutNum/* - record.get('sellNum')*/;
                    // alert(soldoutNum_temp);
                    for (var i = 0; i < orderedCommodityInfo.length; i+=2){
                        if (orderedCommodityInfo[i] == record.get('commodityId')){
                            soldoutNum_temp -= orderedCommodityInfo[i+1];
                            continue;
                        }
                        for (var j = 0; j < orderedItems.length; j++) {
                            if (orderedCommodityInfo[i] != orderedItems[j].id || orderedItems[j].category != '2') continue;
                            // alert(orderedItems[j].name);
                            jsonPar = JSON.parse(orderedItems[j].comboMealsJson);
                            for (var k = 0; k < jsonPar.length; k++){
                                if (record.get('commodityId') == jsonPar[k].commodityId){
                                    soldoutNum_temp -= jsonPar[k].commodityNum * orderedCommodityInfo[i+1];
                                }
                            }
                        }
                    }
                    // alert(soldoutNum_temp);
                    if(soldoutNum_temp >= amount){
                        return callback && callback(true);
                    }else{
                        return callback && callback(false);
                    }
                }
            })
        })
    }
}