/**
 * 口味管理
 */
Ext.define('Seller.controller.BuyCarRemarkEditorController', {
    extend : 'Ext.app.Controller',
    config : {
        /*refs : {

        },*/
        control : {
            //选择口味
            'button[id=BuyCarremarkEditor-sve]' : {tap : function (curView, e, eOpts) {
            	preventEventBubble(e);
                var content = "";
                var remarkIds = "";
                $(".sys_spec_text").each(function() {
                    var i = $(this);
                    var p = i.find("li");
                    p.each(function() {
                        if ($(this).hasClass("selected")) {
                            var remark = $(this).attr("remark");
                            var price = $(this).attr("price");
                            var remarkId = $(this).attr("remarkId");
                            if (content) {
                                if (Ext.getCmp('buyCarRemarkView').buyCarRecord) {
                                    content += "," + remark + ( price ? ((parseFloat(price).toFixed(2) == '0.00') ? "" : ("+" + parseFloat(price).toFixed(2))) : "");
                                } else {
                                    content += "," + remark;
                                }
                                remarkIds += "," + remarkId;
                            } else {
                                if (Ext.getCmp('buyCarRemarkView').buyCarRecord) {
                                    content = remark + ( price ? ((parseFloat(price).toFixed(2) == '0.00') ? "" : ("+" + parseFloat(price).toFixed(2))) : "");
                                } else {
                                    content += remark;
                                }
                                remarkIds = remarkId;
                            }
                        }
                    });
                });
                //alert(content);
                if (Ext.getCmp('buyCarRemarkView').buyCarRecord) {
                    //setRemark(Ext.getCmp('buyCarRemarkView').buyCarRecord, content, remarkIds);
                    setRemarkDetail(Ext.getCmp('buyCarRemarkView').buyCarRecord, content, remarkIds);
                    Ext.getCmp('buyCarRemarkView').buyCarRecord = null;
                } else {
                    Ext.getCmp('putup-edit-view').setPutupRemark(content, remarkIds);
                    Ext.getCmp('buyCarRemarkView').putupRemarkIds = null;
                }
                //$(".sys_spec_text").empty();
                Ext.getCmp('buyCarRemarkView').destroy();
            }},
            //编辑
            'button[id=buyCarEditorButton]' : {tap : function (curView, e, eOpts) {
            	preventEventBubble(e);
                if (Ext.getCmp('buyCarEditorTootar2').getHidden()) {
                    Ext.getCmp('buyCarEditorTootar2').setHidden(false);
                    Ext.getCmp('buyCarEditorButton').setText("返回");
                    disSelect();
                } else {
                    Ext.getCmp('buyCarEditorTootar2').setHidden(true);
                    Ext.getCmp('buyCarEditorButton').setText("编辑");
                    var remarkIds = Ext.getCmp('buyCarRemarkView').buyCarRecord.get("remarkIds");
                    setSelect(remarkIds);
                }
            }},
            //添加口味
            'button[id=BuyCarremarkEditor-add]' : {
                tap : function (curView, e, eOpts) {
                	preventEventBubble(e);
                	checkPermissions("16", true)
					.then(function() {
						showRemarkEditor('', 0, '');
					}).catch(function() {});
                }
            },
            //删除
            'button[id=BuyCarremarkEditor-Delete]' : {
                tap : function (curView, e, eOpts) {
                	preventEventBubble(e);
            		$(".sys_spec_text").each(function() {
                        var i = $(this);
                        var p = i.find("li");
                        p.each(function() {
                        	var me = this;
                            if ($(this).hasClass("selected")) {
                            	checkPermissions("5", true).then(function() {
                            		deleteRemark($(me));
                            	}).catch(function() {});
                            }
                        });
                    });
                    /*if (!checkPermissions("5", true)) {
                        return;
                    }
                    $(".sys_spec_text").each(function() {
                        var i = $(this);
                        var p = i.find("li");
                        p.each(function() {
                            if ($(this).hasClass("selected")) {
                                deleteRemark($(this));
                            }
                        });
                    });*/
                }
            },
            //修改
            'button[id=BuyCarremarkEditor-update]' : {
                tap : function (curView, e, eOpts) {
                	preventEventBubble(e);
                	//checkPermissions("7", true).then(function() {
            		var count = 0;
                    var remarkId;
                    $(".sys_spec_text").each(function() {
                        var i = $(this);
                        var p = i.find("li");
                        p.each(function() {
                            if ($(this).hasClass("selected")) {
                                count++;
                                remarkId = $(this).attr("remarkId");
                            }
                        });
                    });
                    if (count > 1) {
                        showAlert('提示', '一次只能修改一条备注！');
                    } else {
                        if (!remarkId) {
                            return;
                        }
                        checkPermissions("7", true).then(function() {
	                        SellerRemarkDao.getSellerRemarkById(remarkId, function(success, res) {
	                            if (success) {
	                                showRemarkEditor(remarkId, res.sequence, res.price, res.remark);
	                            }
	                        });
                        }).catch(function() {});
                    }
                	//}).catch(function() {});
                    /*if (!checkPermissions("7", true)) {
                        return;
                    }
                    var count = 0;
                    var remarkId;
                    $(".sys_spec_text").each(function() {
                        var i = $(this);
                        var p = i.find("li");
                        p.each(function() {
                            if ($(this).hasClass("selected")) {
                                count++;
                                remarkId = $(this).attr("remarkId");
                            }
                        });
                    });
                    if (count > 1) {
                        showAlert('提示', '一次只能修改一条备注！');
                    } else {
                        if (!remarkId) {
                            return;
                        }
                        SellerRemarkDao.getSellerRemarkById(remarkId, function(success, res) {
                            if (success) {
                                showRemarkEditor(remarkId, res.sequence, res.price, res.remark);
                            }
                        });
                    }*/
                }
            }
        }
    },
});
