Ext.define('Seller.controller.PutupQueryTakeController', {
    extend : 'Ext.app.Controller',
    config : {
        refs : {
            fhTMainCartListView : 'button[id=putup-query-view-close]',//返回
            DownMainCartListView : 'button[id=putup-Down]',//上一页
            UpMainCartListView : 'button[id=putup-up]',//下一页
            cxTMainListView : 'button[id=Putup-cx]',//撤销

        },
        control : {
            //已下单
            'radiofield[id=statusOrder-one]' : {
                check : function(filed, e, eOpts) {
                    var categoryList = Ext.getCmp("putup-take-categoryList");
                    if(categoryList)
                    categoryList.deselectAll();
                    Ext.getCmp('putup-take-view').page.reset();
                    Ext.getCmp('putup-take-view').loadData();
                    Ext.getCmp("putup-take-categoryList").setMode('MULTI');
                    Ext.getCmp('putup-take-checkAll').setHidden(false);
                    Ext.getCmp('putup-take-order-btn').setHidden(true);
                    Ext.getCmp('putup-take-acount-btn').setHidden(false);

                    /**
                     * 查询 相同方法
                     */
                    /*setTimeout(function() {
                        var categoryList = Ext.getCmp("putup-take-categoryList");
                        if (categoryList)
                            categoryList.deselectAll();
                        var store = categoryList.getStore();
                        store.clearFilter();
                        var imployeeSelect = Ext.getCmp('putup-take-sale-imployee');
                        var imployeeName = imployeeSelect.getRecord().get('text');
                        var value = Ext.getCmp('putup-query').getValue();
                        if (!value && !imployeeName)
                            return;
                        store.filterBy(function(record) {
                            var customerMobile = record.get('customerMobile');
                            var customerAddress = record.get('customerAddress');
                            var waiterName = record.get('waiterName');
                            if (imployeeName && value) {
                                if (waiterName && waiterName.indexOf(imployeeName) != -1) {
                                } else
                                    return false;
                            } else if (imployeeName) {
                                if (waiterName && waiterName.indexOf(imployeeName) != -1) {
                                    return true;
                                } else
                                    return false;
                            }
                            if (customerMobile && customerMobile.indexOf(value) != -1) {
                                return true;
                            }
                            if (customerAddress && customerAddress.indexOf(value) != -1) {
                                return true;
                            }
                            return false;
                        });
                    },25)*/
                }
            },
            //未下单
            'radiofield[id=statusOrder-two]' : {
                check : function(filed, e, eOpts) {
                    var categoryList = Ext.getCmp("putup-take-categoryList");
                    if(categoryList)
                    categoryList.deselectAll();
                    Ext.getCmp('putup-take-view').page.reset();
                    Ext.getCmp('putup-take-view').loadData();
                    Ext.getCmp("putup-take-categoryList").setMode('');
                    Ext.getCmp('putup-take-checkAll').setHidden(true);
                    Ext.getCmp('putup-take-order-btn').setHidden(false);
                    Ext.getCmp('putup-take-acount-btn').setHidden(true);
                    /**
                     * 查询 相同方法
                     */
                    /*setTimeout(function() {
                        var categoryList = Ext.getCmp("putup-take-categoryList");
                        if (categoryList)
                            categoryList.deselectAll();
                        var store = categoryList.getStore();
                        store.clearFilter();
                        var imployeeSelect = Ext.getCmp('putup-take-sale-imployee');
                        var imployeeName = imployeeSelect.getRecord().get('text');
                        var value = Ext.getCmp('putup-query').getValue();
                        if (!value && !imployeeName)
                            return;
                        store.filterBy(function(record) {
                            var customerMobile = record.get('customerMobile');
                            var customerAddress = record.get('customerAddress');
                            var waiterName = record.get('waiterName');
                            if (imployeeName && value) {
                                if (waiterName && waiterName.indexOf(imployeeName) != -1) {
                                } else
                                    return false;
                            } else if (imployeeName) {
                                if (waiterName && waiterName.indexOf(imployeeName) != -1) {
                                    return true;
                                } else
                                    return false;
                            }
                            if (customerMobile && customerMobile.indexOf(value) != -1) {
                                return true;
                            }
                            if (customerAddress && customerAddress.indexOf(value) != -1) {
                                return true;
                            }
                            return false;
                        });
                    },25)*/
                }
            },
            //送货员
            'selectfield[id=putup-take-sale-imployee]' : {
                change: function (sel, newValue, oldValue, eOpts) {
                	Ext.getCmp('putup-take-view').page.setCurrPage(1);
                	Ext.getCmp('putup-take-view').loadPageData();
                }
            },
            'dataview[id=putup-take-categoryList]' : {
            	itemtap : function(curView, index, target, record, e, eOpts) {
					if(e) {
						if(e.stopPropagation) e.stopPropagation();
						if(e.stopEvent) e.stopEvent();
					}
				},
                deselect : function (view, record, supressed, eOpts) {//取消选中
                    if (Ext.getCmp('putup-take-checkAll') && Ext.getCmp('putup-take-checkAll').isChecked()) {
                        Ext.getCmp('putup-take-view').putupQtAllSelStatus = true;
                        Ext.getCmp('putup-take-checkAll').uncheck();
                    }
                    if (Ext.getCmp('putup-take-view').putupQtAllSelNotDetail) {
                        if (Ext.getCmp('putup-take-view').putupQtAllSelNotDetailNum > 0) {
                            Ext.getCmp('putup-take-view').putupQtAllSelNotDetailNum -= 1;
                        }
                        if (Ext.getCmp('putup-take-view').putupQtAllSelNotDetailNum <= 0) {
                            Ext.getCmp('putup-take-view').putupQtAllSelNotDetail = false;
                        }
                    }
                    setTimeout(function() {
                        var selectionCount = Ext.getCmp("putup-take-categoryList").getSelectionCount();
                        if (selectionCount == 1) {
                            Ext.getCmp('putup-take-view').loadDetail(view.getSelection()[0]);
                        } else {
                            Ext.getCmp('putup-take-view').clearDetail();
                        }
                    }, 200);
                    $("input[name='tomato']").each(function() {
                        var id = $(this).attr('id');
                        var parentId = $(this).parent().parent().parent().attr('id');
                        var box = Ext.getCmp(parentId);
                        if (box.getValue() == record.get('id')) {
                            box.uncheck();
                        }
                    });
                },
                select : function (view, record, eOpts) {//选中
                    var selectionCount = view.getSelectionCount();
                    var categoryList = Ext.getCmp("putup-take-categoryList");
                    var store = categoryList.getStore();
                    var allCount = store.getAllCount();
                    if (categoryList.getSelection().length > 0 && categoryList.getSelection().length === allCount) {
                        if (Ext.getCmp('putup-take-checkAll') && !Ext.getCmp('putup-take-checkAll').isChecked()) {
                            Ext.getCmp('putup-take-view').putupQtAllSelStatus = true;
                            Ext.getCmp('putup-take-checkAll').check();
                        }
                    }
                    if (Ext.getCmp('putup-take-view').putupQtAllSelNotDetail) {
                        var menuList = Ext.getCmp("putup-take-menuList");
                        var store = menuList.getStore();
                        store.removeAll();
                        Ext.getCmp('putup-take-view').clearDetail();
                        if (Ext.getCmp('putup-take-view').putupQtAllSelNotDetailNum > 0) {
                            Ext.getCmp('putup-take-view').putupQtAllSelNotDetailNum -= 1;
                        }
                        if (Ext.getCmp('putup-take-view').putupQtAllSelNotDetailNum <= 0) {
                            Ext.getCmp('putup-take-view').putupQtAllSelNotDetail = false;
                        }
                    } else {
                        if (selectionCount == 1) {
                            Ext.getCmp('putup-take-view').loadDetail(view.getSelection()[0]);
                        } else {
                            var menuList = Ext.getCmp("putup-take-menuList");
                            var store = menuList.getStore();
                            store.removeAll();
                            Ext.getCmp('putup-take-view').clearDetail();
                        }
                    }
                    $("input[name='tomato']").each(function() {
                        var id = $(this).attr('id');
                        var parentId = $(this).parent().parent().parent().attr('id');
                        var box = Ext.getCmp(parentId);
                        if (box.getValue() == record.get('id')) {
                            box.check();
                        }
                    });
                }
            },
            'button[id=putup-take-acount-btn]' : {tap : function () {
                //收款
                ReceivablesPutup();
            }},
            'button[id=putup-take-order-btn]' :{tap :function () {PutupPlaceAnOrder();}},//下单
            'button[id=putup-take-Update]' : {tap : function () {//修改
                var categoryList = Ext.getCmp("putup-take-categoryList");
                var store = categoryList.getStore();
                if (categoryList.getSelection().length > 0) {
                    if (categoryList.getSelection().length > 1) {
                        showAlert('提示', "一次只能修改一条！");
                        return;
                    }
                    var record = categoryList.getSelection()[0];
                    Ext.getCmp('putup-take-view').parentContainer.destroy();
                    Ext.getCmp('shouyinMainView').loadDataBySellId(record.getData());
                }
            }},
            'checkboxfield[id=putup-take-checkAll]' : {change : function (filed, newValue, oldValue, eOpts) {
                //全选
                if (Ext.getCmp('putup-take-view').putupQtAllSelStatus) {
                    Ext.getCmp('putup-take-view').putupQtAllSelStatus = false;
                    return;
                }

                var categoryList = Ext.getCmp("putup-take-categoryList");
                var store = categoryList.getStore();
                var allCount = store.getAllCount();

                if (allCount == 1) {
                    if (filed.isChecked()) {
                        if (categoryList.getSelection().length > 0)
                            return;
                        else
                            categoryList.select(store.getAt(0), true);
                    } else {
                        if (categoryList)
                            categoryList.deselectAll();
                    }
                } else if (allCount > 1) {
                    /*if(filed.isChecked())
                     categoryList.selectAll();
                     else
                     categoryList.deselectAll();*/
                    Ext.getCmp('putup-take-view').putupQtAllSelNotDetail = true;
                    Ext.getCmp('putup-take-view').putupQtAllSelNotDetailNum = allCount;
                    for (var i = 0; i < allCount; i++) {
                        if (filed.isChecked()) {
                            categoryList.select(store.getAt(i), true);
                        } else {
                            categoryList.deselect(store.getAt(i));
                        }
                    }
                    if (filed.isChecked()) {
                        Ext.getCmp('putup-take-view').clearDetail();
                        var menuList = Ext.getCmp("putup-take-menuList");
                        var store = menuList.getStore();
                        store.removeAll();
                    }
                }
            }},
            'textfield[id=putup-query]' : {//查找
                keyup : function (filed, e, eOpts) {
                    var categoryList = Ext.getCmp("putup-take-categoryList");
                    if (categoryList)
                        categoryList.deselectAll();
                    var store = categoryList.getStore();
                    store.clearFilter();
                    var imployeeSelect = Ext.getCmp('putup-take-sale-imployee');
                    var imployeeName = imployeeSelect.getRecord().get('text');
                    var value = filed.getValue();
                    if (!value && !imployeeName)
                        return;
                    /*store.filterBy(function(record) {
                        var customerMobile = record.get('customerMobile');
                        var customerAddress = record.get('customerAddress');
                        var waiterName = record.get('waiterName');
                        if (imployeeName && value) {
                            if ((waiterName && waiterName.indexOf(imployeeName) != -1) || imployeeName == '全部') {
                            } else
                                return false;
                        } else if (imployeeName) {
                            if (waiterName && waiterName.indexOf(imployeeName) != -1) {
                                return true;
                            } else
                                return false;
                        }
                        if (customerMobile && customerMobile.indexOf(value) != -1) {
                            return true;
                        }
                        if (customerAddress && customerAddress.indexOf(value) != -1) {
                            return true;
                        }
                        return false;
                    });*/
                    Ext.getCmp('putup-take-view').page.setCurrPage(1);
                    Ext.getCmp('putup-take-view').loadPageData();
                },
                clearicontap : function (filed, e, eOpts) {
                    /*var categoryList = Ext.getCmp("putup-take-categoryList");
                    if (categoryList)
                        categoryList.deselectAll();
                    var store = categoryList.getStore();
                    store.clearFilter();
                    var imployeeSelect = Ext.getCmp('putup-take-sale-imployee');
                    var imployeeName = imployeeSelect.getRecord().get('text');
                    if (imployeeName) {
                        store.filterBy(function(record) {
                            var customerMobile = record.get('customerMobile');
                            var customerAddress = record.get('customerAddress');
                            var waiterName = record.get('waiterName');
                            if (waiterName && waiterName.indexOf(imployeeName) != -1) {
                                return true;
                            }
                            return false;
                        });
                    }*/
                	Ext.getCmp('putup-take-view').page.setCurrPage(1);
                	Ext.getCmp('putup-take-view').loadPageData();
                }
            },
            cxTMainListView : {
                //撤销
                tap : 'cxTDisListClike',
            },
            WxdTMainListView : {
                //未下单
                check : 'WxdTDislistClike',
            },
            YxdTMainListView : {
                //已下单
                check : 'YxdTDisListClike',
            },
            shyMainCartListView : {
                //送货员
                change : 'shyDisListClike',
            },
            DownMainCartListView : {
                //上一页
                tap : 'DownDisListClike',
            },
            UpMainCartListView : {
                //下一页
                tap : 'UpDisListClike',
            },
            fhTMainCartListView : {
                //返回
                tap : 'fhTDislisyClike' ,
            },
        }
    },
    cxTDisListClike : function () {
        //撤销
        var categoryList = Ext.getCmp("putup-take-categoryList");
        var store = categoryList.getStore();
        var records = categoryList.getSelection();
        if (records.length < 1) {
            return;
        }
        var me = this;
        checkPermissions("6", true).then(function() {
        	var takeCancelBtn = me.getCxTMainListView();
            var takeMainView = takeCancelBtn.up("container#putup-take-view");
            var cancelDialogIds = showConfirm('提示', '您确定要撤销吗?', function(buttonId) {
                if (buttonId == "yes") {
                    for (var i = 0; i < records.length; i++) {
                        //Ext.getCmp('putup-take-view').removeRecord(store, records[i]);
                        var status = records[i].get('status');
                        if(status == '-1') // 挂起的撤销单据
                            Ext.getCmp('putup-take-view').removeSellInfo(store, records[i]);
                        else {
                            Ext.getCmp('putup-take-view').removeRecord(store, records[i]);
                        }
                        console.log('操作单据：外卖订单' + records[i].get('id') + '被撤销了--' + new Date().format('yyyy-MM-dd hh:mm:ss'))
                    }
                    Ext.getCmp('putup-take-view').clearDetail();
                    Ext.getCmp('putup-take-view').loadData();
                }
                takeMainView.cancelDialogId = null;
            });
            if(takeMainView && cancelDialogIds && cancelDialogIds.length > 0) {
            	takeMainView.cancelDialogId = cancelDialogIds[cancelDialogIds.length-1];
            }
        }).catch(function() {});
        /*if (!checkPermissions("6", true)) {
            return;
        }
        var takeCancelBtn = this.getCxTMainListView();
        var takeMainView = takeCancelBtn.up("container#putup-take-view");
        var cancelDialogIds = showConfirm('提示', '您确定要撤销吗?', function(buttonId) {
            if (buttonId == "yes") {
                for (var i = 0; i < records.length; i++) {
                    //Ext.getCmp('putup-take-view').removeRecord(store, records[i]);
                    var status = records[i].get('status');
                    if(status == '-1') // 挂起的撤销单据
                        Ext.getCmp('putup-take-view').removeSellInfo(store, records[i]);
                    else {
                        Ext.getCmp('putup-take-view').removeRecord(store, records[i]);
                    }
                }
                Ext.getCmp('putup-take-view').clearDetail();
                Ext.getCmp('putup-take-view').loadData();
            }
            takeMainView.cancelDialogId = null;
        });
        //console.log(takeMainView.cancelDialogId);
        if(takeMainView && cancelDialogIds && cancelDialogIds.length > 0) {
        	takeMainView.cancelDialogId = cancelDialogIds[cancelDialogIds.length-1];
        }*/
    },
    DownDisListClike: function () {
        //上一页
        Ext.getCmp('putup-take-view').down();
    },
    UpDisListClike : function () {
        //下一页
        Ext.getCmp('putup-take-view').up();
    },
    fhTDislisyClike : function () {
        //返回
        Ext.getCmp('putup-take-view').parentContainer.destroy();
    }
});
