/**
 * employeeNavigation  员工菜单权限
 * employee 员工
 * comboMeals 套餐
 * units     单位
 * discounts  折扣
 * servicePlaceTypes  餐桌分类
 * servicePlaces   餐桌
 * remarks     口味
 * sellerCustomerTypes  会员类型
 * sellerCustomers  会员
 * supplierInfos   供应商
 * sellerPayConfigs  基础支付信息
 * sellerPayTypes   自定义支付信息
 * openPlaceSetInfos  开台设置信息
 * sellerCouponConfigs  满减配置
 * sellerKitchenPrinter  厨打设置
 * sellerSpecialConfigs  特价菜配置
 * sellerTipsDetail   小票设置
 */
/*this.tableFunction = {
    "sellerEmployeeNavigation" : "updateEmployeeNavigation",
    "selleremployee" : "updateSellerEmployeeWs",
    "comboMeals" : "updateComboMeals",
    "sellerunit" : "updateUnits",
    "discount" : "updateDiscount",
    "serviceplacetype" : "updateServicePlaceType",
    "serviceplace" : "updateServicePlace",
    "sellerremark" : "updateRemark",
    "sellercustomertype" : "updateSellerCustomerType",
    "sellercustomerinfo" : "updateSellerCustomer",
    "supplierinfo" : "updateSupplierInfo",
    "payconfig" : "updatePayConfig",
    "sellerpaytypes" : "updateSellerPayTypeWs",//,"updateSellerPayType",
    "openplaceset" : "updateSellerOpenPlace",
    "couponconfig" : "updateCouponConfig",
    "kitchenprinter" : "updateSellerKitchenPrinter",
    "specialprice" : "updateSellerSpecialConfig",
    "tipsdetail" : "updateTipsDetail",
    "commodityinfo" : "updateCommodityInfo",
    "commoditytype" : "updateCommodityTypeWs"//,"updateCommodityType"
};*/
var DownloadDao = {
    tableFunction : {
        "sellerEmployeeNavigation" : "updateData",
        "selleremployee" : "updateData",
        "combomeals" : "updateData",
        "sellerunit" : "updateData",
        "discount" : "updateData",
        "serviceplacetype" : "updateData",
        "serviceplace" : "updateData",
        "sellerremark" : "updateData",
        "sellercustomertype" : "updateData",
        "sellercustomerinfo" : "updateData",
        "supplierinfo" : "updateData",
        "payconfig" : "updateData",
        "sellerpaytypes" : "updateData",
        "openplaceset" : "updateData",
        "couponconfig" : "updateData",
        "kitchenprinter" : "updateData",
        "specialprice" : "updateData",
        "tipsdetail" : "updateData",
        "commodityinfo" : "updateData",
        "commoditytype" : "updateData"
    },
    tableCols : {
        "selleremployeenavigation" : ["id","navId","workType","sellerId","syned","status"],
        "selleremployee" : ["id", "workId", "password", "workName", "type", "permissions", "eraseZeroMaxAmount", "sellerId", "mobile","syned","commissionScale","birthday","status"],
        "combomeals" : ["id","comboId","commodityId","commodityName","commodityPrice","commodityNum","sumAmount","normName","sellerId","createId","createTime","status",'lastUpdateTime','syned'],
        "sellerunit" : ["id","unitName","sellerId","lastUpdateTime"],
        "discount" : ["id", "discount", "isSupportPwd", "sellerId", "password", "remark", "define1", "define2", "lastUpdateTime", "status", "syned"],
        "serviceplacetype" : ["id", "typeName", "sequence", "remark", "sellerId", "parentSellerId", "isDelete", "teaUnitPrice", "lastUpdateTime", "status", "syned"],
        "serviceplace" : ["id", "placeName", "typeId", "typeName", "sequence", "remark", "personNum", "sellerId", "parentSellerId", "status", "isDelete", "lastUpdateTime", "syned"],
        "sellerremark" : ["id","remark","sequence","price","sellerId","syned","status","lastUpdateTime"],
        "sellercustomertype" : ["id","typeName","parentId","sequence","typeLevel","sellerId","parentSellerId","ecode","status","syned","lastUpdateTime"],
        "sellercustomerinfo" : ["id", "name", "mobile", "birthday", "sellerId", "address", "sex", "nickName", "qq", "createDate", "type", "syned",
            "define1", "define2", "define3", "define4", "password", "remark", "customerId", "attentionStatus", "rechargeAmount", "useAmount", "presentAmount",
            "discount", "status", "parentSellerId", "openId", "cardNum", "lastUpdateTime"],
        "supplierinfo" : ["id","sellerId","status","name","syned","linkMan","linkSex","linkEmail","deliveryRebate","fixedRebate","addr","remark","createId","createTime","lastUpdateId","lastUpdateTime"],
        "payconfig" : ['id','sellerId','payType','openStatus','status','syned','payTypeName','lastUpdateTime','defaultPayType'],
        "sellerpaytypes" : ["id","sellerId","payTypeName","status","syned","lastUpdateTime"],
        "openplaceset" : ["id","commodityId","commodityName","commodityPrice","commodityNum","commodityTypeId","sumAmount",
            "normName","sellerId","kitchenPrint","labelPrint","isDiscount","lastUpdateTime","status","syned"],
        "couponconfig" : ["id","sellerId","couponRange","costMoney","subtractMoney","couponCycle","couponStartTime","couponEndTime",
            "couponStartDate","couponEndDate","couponWeek","couponName","commodityTypeId","status","syned","isDeleted",
            "lastUpdateTime"],
        "kitchenprinter" : ["id","sellerId","ktPrintName","ktPrintIp","isDeleted","syned","mode","interface","printQuantity",
            "paperWidth","customWidth","rowledge","model","port","baudrate","beepEnable","autoCut","roll","status","lastUpdateTime"],
        "specialprice" : ["id","sellerId","specialName","specialPrice","commodityId","specialPriceRange","specialPriceCycle",
            "specialPriceStartTime","specialPriceEndTime","specialPriceStartDate","specialPriceEndDate",
            "specialPriceWeek","specialNormsName","status","isDeleted","syned","lastUpdateTime"],
        "tipsdetail" : ["id", "printFontSize", "printFontList", "printHeader", "printBottom", "printLogo", "printQrCode", "lastUpdateTime", "syned","sellerId"],
        "commodityinfo" : ["id","name","price","logo","sequence","typeId","pinyinCode","barCode","vipPrice","tradePrice","isDiscount","costPrice","oriPrice","category","sellNum","style1","style2",
            "isPoints","define1","define2","define3","define4","status","parentCommodityId","isTimecard","timeNum","timeCommodityId","soldoutStatus","soldoutNum","sellerId","parentSellerId","syned",
            "isSupportNorms","normsName1","normsName2","normsName3","normsName4","normsName5","normsName6","normsName7","normsName8","normsPrice1","normsPrice2","normsPrice3","normsPrice4",
            "normsPrice5","normsPrice6","normsPrice7","normsPrice8","comboMealsJson","expectedTime","kitchenPrint","labelPrint","isTimePrice","circleId","selected",
            "content","sendTime","lastOrderTime","stock","minStock","maxStock","supplierId","guaranteePeriod","negativeStock","presentAmount","image1","image2","image3","image4","image5","parentCommodityTypeId",
            "parentSupplierId","timeTommodityId","boxNum","minOrderCount","unit","lastUpdateTime","isDelete","isSpecialPrice","specialPrice","specialNorms"],
        "commoditytype" : ['id', 'name', 'sequence','typeLevel','parentId','parentSellerId', 'parentCommodityTypeId', 'sellerId', 'iskitchenprint', 'kitchenPrintJson', 'isDiscount', 'isInventory', 'syned','lastUpdateTime',"selected","status"]
    },
    updateData : function(tableName, data, callBack) {
        var tableCols = {
            "sellerEmployeeNavigation" : ["id","navId","workType","sellerId","syned","status"],
            "selleremployee" : ["id", "workId", "password", "workName", "type", "permissions", "eraseZeroMaxAmount", "sellerId", "mobile","syned","commissionScale","birthday","status"],
            "comboMeals" : ["id","comboId","commodityId","commodityName","commodityPrice","commodityNum","sumAmount","normName","sellerId","createId","createTime","status",'lastUpdateTime','syned'],
            "sellerunit" : ["id","unitName","sellerId","lastUpdateTime"],
            "discount" : ["id", "discount", "isSupportPwd", "sellerId", "password", "remark", "define1", "define2", "lastUpdateTime", "status", "syned"],
            "serviceplacetype" : ["id", "typeName", "sequence", "remark", "sellerId", "parentSellerId", "isDelete", "teaUnitPrice", "lastUpdateTime", "status", "syned"],
            "serviceplace" : ["id", "placeName", "typeId", "typeName", "sequence", "remark", "personNum", "sellerId", "parentSellerId", "status", "isDelete", "lastUpdateTime", "syned"],
            "sellerremark" : ["id","remark","sequence","price","sellerId","syned","status","lastUpdateTime"],
            "sellercustomertype" : ["id","typeName","parentId","sequence","typeLevel","sellerId","parentSellerId","ecode","status","syned","lastUpdateTime"],
            "sellercustomerinfo" : ["id", "name", "mobile", "birthday", "sellerId", "address", "sex", "nickName", "qq", "createDate", "type", "syned",
                "define1", "define2", "define3", "define4", "password", "remark", "customerId", "attentionStatus", "rechargeAmount", "useAmount", "presentAmount",
                "discount", "status", "parentSellerId", "openId", "cardNum", "lastUpdateTime"],
            "supplierinfo" : ["id","sellerId","status","name","syned","linkMan","linkSex","linkEmail","deliveryRebate","fixedRebate","addr","remark","createId","createTime","lastUpdateId","lastUpdateTime"],
            "payconfig" : ['id','sellerId','payType','openStatus','status','syned','payTypeName','lastUpdateTime','defaultPayType'],
            "sellerpaytypes" : ["id","sellerId","payTypeName","status","syned","lastUpdateTime"],
            "openplaceset" : ["id","commodityId","commodityName","commodityPrice","commodityNum","commodityTypeId","sumAmount",
                "normName","sellerId","kitchenPrint","labelPrint","isDiscount","lastUpdateTime","status","syned"],
            "couponconfig" : ["id","sellerId","couponRange","costMoney","subtractMoney","couponCycle","couponStartTime","couponEndTime",
                "couponStartDate","couponEndDate","couponWeek","couponName","commodityTypeId","status","syned","isDeleted",
                "lastUpdateTime"],
            "kitchenprinter" : ["id","sellerId","ktPrintName","ktPrintIp","isDeleted","syned","mode","interface","printQuantity",
                "paperWidth","customWidth","rowledge","model","port","baudrate","beepEnable","autoCut","roll","status","lastUpdateTime"],
            "specialprice" : ["id","sellerId","specialName","specialPrice","commodityId","specialPriceRange","specialPriceCycle",
                "specialPriceStartTime","specialPriceEndTime","specialPriceStartDate","specialPriceEndDate",
                "specialPriceWeek","specialNormsName","status","isDeleted","syned","lastUpdateTime"],
            "tipsdetail" : ["id", "printFontSize", "printFontList", "printHeader", "printBottom", "printLogo", "printQrCode", "lastUpdateTime", "syned","sellerId"],
            "commodityinfo" : ["id","name","price","logo","sequence","typeId","pinyinCode","barCode","vipPrice","tradePrice","isDiscount","costPrice","oriPrice","category","sellNum","style1","style2",
                "isPoints","define1","define2","define3","define4","status","parentCommodityId","isTimecard","timeNum","timeCommodityId","soldoutStatus","soldoutNum","sellerId","parentSellerId","syned",
                "isSupportNorms","normsName1","normsName2","normsName3","normsName4","normsName5","normsName6","normsName7","normsName8","normsPrice1","normsPrice2","normsPrice3","normsPrice4",
                "normsPrice5","normsPrice6","normsPrice7","normsPrice8","comboMealsJson","expectedTime","kitchenPrint","labelPrint","isTimePrice","circleId","selected",
                "content","sendTime","lastOrderTime","stock","minStock","maxStock","supplierId","guaranteePeriod","negativeStock","presentAmount","image1","image2","image3","image4","image5","parentCommodityTypeId",
                "parentSupplierId","timeTommodityId","boxNum","minOrderCount","unit","lastUpdateTime","isDelete","isSpecialPrice","specialPrice","specialNorms"],
            "commoditytype" : ['id', 'name', 'sequence','typeLevel','parentId','parentSellerId', 'parentCommodityTypeId', 'sellerId', 'iskitchenprint', 'kitchenPrintJson', 'isDiscount', 'isInventory', 'syned','lastUpdateTime',"selected","status"]
        };
        var cols = tableCols[tableName];
        fgDB.transaction(function(tx) {
            for (var di = 0, dlen = data.length; di < dlen; di++) {
                var params = [];
                var tableData = data[di];
                var tableColumns = {};
                /*for(var ci=0,clen=cols.length;ci<clen;ci++) {
                    var columnName = cols[ci];
                    tableColumns[columnName] = columnName;
                    if (columnName == "syned") {
                        params.push("1");
                        continue;
                    } else if(columnName == 'sellerId') {
                        params.push(seller.id);
                        continue;
                    } else if(columnName == 'lastUpdateTime') {
                        params.push(new Date(tableData[columnName]).format("yyyy-MM-dd hh:mm:ss"));
                        continue;
                    } else if(tableData[columnName]) {
                        params.push(tableData[columnName]);
                    } else params.push(null);
                }
                params.push(tableData.id);
                var sql = "INSERT INTO " + tableName + "(" + cols.join(",") + ") SELECT " + new Array(cols.length).fill('?').join(",") + " WHERE NOT EXISTS(SELECT 1 FROM " + tableName + " WHERE id=?)";
                tx.executeSql(sql, params);
                var updateParams = params.concat([new Date(tableData.lastUpdateTime).format("yyyy-MM-dd hh:mm:ss")]);
                var sqlu = "UPDATE " + tableName + " SET " + Object.keysEx(tableColumns, "=?").join(",") + " WHERE id=? AND (IFNULL(lastUpdateTime,'')='' OR (CASE WHEN typeof(lastUpdateTime)='integer' " +
                    "THEN strftime('%Y-%m-%d %H:%M:%S',lastUpdateTime/1000,'unixepoch','localtime') ELSE lastUpdateTime END)<?)";
                tx.executeSql(sqlu, updateParams);*/
                DownloadDao.updateDataCommon(tx, tableName, tableData, cols);
                //console.log(sql, updateParams);
                //var updateParams = params.concat([tableData.lastUpdateTime]);
                //tx.executeSql("UPDATE " + tableName + " SET " + Object.keysEx(tableColumns, "=?").join(",") + " WHERE id=? AND (IFNULL(lastUpdateTime,'')='' OR strftime('%Y-%m-%d %H:%M:%S', lastUpdateTime)<?)", params);

                //console.log(sqlu, updateParams);
            }
        }, function() {
            callBack && callBack(true);
        }, function(err) {
            callBack && callBack(false);
        });
        //console.log(data);
    },
    updateDataCommon : function(tx, tableName, tableData, cols, callBack) {
        var tableColumns = {};
        var params = [];
        for(var ci=0,clen=cols.length;ci<clen;ci++) {
            var columnName = cols[ci];
            tableColumns[columnName] = columnName;
            if (columnName == "syned") {
                params.push("1");
                continue;
            } else if(columnName == 'sellerId') {
                params.push(seller.id);
                continue;
            } else if(columnName == 'lastUpdateTime') {
                if(!(columnName in tableData)) tableData[columnName] = new Date().format("yyyy-MM-dd hh:mm:ss");
                params.push(new Date(tableData[columnName]).format("yyyy-MM-dd hh:mm:ss"));
                continue;
            } else if(isValidValue(tableData[columnName])) {
                params.push(tableData[columnName]);
            } else params.push(null);
        }
        params.push(tableData.id);
        var sql = "INSERT INTO " + tableName + "(" + cols.join(",") + ") SELECT " + new Array(cols.length).fill('?').join(",") + " WHERE NOT EXISTS(SELECT 1 FROM " + tableName + " WHERE id=?)";
        tx.executeSql(sql, params);
        var updateParams = params.concat([new Date(tableData.lastUpdateTime).format("yyyy-MM-dd hh:mm:ss")]);
        var sqlu = "UPDATE " + tableName + " SET " + Object.keysEx(tableColumns, "=?").join(",") + " WHERE id=? AND (IFNULL(lastUpdateTime,'')='' OR (CASE WHEN typeof(lastUpdateTime)='integer' " +
            "THEN strftime('%Y-%m-%d %H:%M:%S',lastUpdateTime/1000,'unixepoch','localtime') ELSE lastUpdateTime END)<?)";
        tx.executeSql(sqlu, updateParams);
    },
    /* 所有表批量更新 */
    updateDataBatch: function(updateData, callBack) {
        var me = this;
        fgDB.transaction(function(tx) {
            for(var uKey in updateData) {
                if(!updateData.hasOwnProperty(uKey)) continue;
                var tableName = uKey;
                var cols = me.tableCols[tableName];
                var data = updateData[tableName];
                for (var di = 0, dlen = data.length; di < dlen; di++) {
                    var params = [];
                    var tableData = data[di];
                    var tableColumns = {};

                    /*for(var ci=0,clen=cols.length;ci<clen;ci++) {
                        var columnName = cols[ci];
                        tableColumns[columnName] = columnName;
                        if (columnName == "syned") {
                            params.push("1");
                            continue;
                        } else if(columnName == 'sellerId') {
                            params.push(seller.id);
                            continue;
                        } else if(columnName == 'lastUpdateTime') {
                            params.push(new Date(tableData[columnName]).format("yyyy-MM-dd hh:mm:ss"));
                            continue;
                        } else if(tableData[columnName]) {
                            params.push(tableData[columnName]);
                        } else params.push(null);
                    }
                    params.push(tableData.id);
                    var sql = "INSERT INTO " + tableName + "(" + cols.join(",") + ") SELECT " + new Array(cols.length).fill('?').join(",") + " WHERE NOT EXISTS(SELECT 1 FROM " + tableName + " WHERE id=?)";
                    tx.executeSql(sql, params);
                    var updateParams = params.concat([new Date(tableData.lastUpdateTime).format("yyyy-MM-dd hh:mm:ss")]);
                    var sqlu = "UPDATE " + tableName + " SET " + Object.keysEx(tableColumns, "=?").join(",") + " WHERE id=? AND (IFNULL(lastUpdateTime,'')='' OR (CASE WHEN typeof(lastUpdateTime)='integer' " +
                        "THEN strftime('%Y-%m-%d %H:%M:%S',lastUpdateTime/1000,'unixepoch','localtime') ELSE lastUpdateTime END)<?)";
                    tx.executeSql(sqlu, updateParams);*/
                    DownloadDao.updateDataCommon(tx, tableName, tableData, cols);
                }
            }
        }, function() {
            callBack && callBack(true);
        }, function(err) {
            callBack && callBack(false);
        });
    },
    downloadData : function(downData, tableName, callBack) {
        var me = this;
        return new Promise(function(resolve, reject) {
            var dataUrl = webDataURL;
            var ajaxParams = {
                tableName : table_reflect_name[tableName.toLowerCase()]
            };
            //console.log(tableName);
            //setTimeout(function() {
                console.log(tableName);
            getBySqlParam("SELECT lastUpdateTime FROM " + tableName + " WHERE sellerId=? ORDER BY IFNULL(lastUpdateTime,'') DESC LIMIT 0,1", [seller.id], function(success, data) {
                if(success && data) {
                    if(data.lastUpdateTime) {
                        ajaxParams.sysUpdatedTime = new Date(data.lastUpdateTime).getTime();
                    }
                }
                nativePostRequest(dataUrl + "/api/datadownload/download?time="+new Date().getTime(), ajaxParams, function(result) {
                    if(!result.state) {console.log("下载数据失败"); resolve&&resolve(false);return;}
                    /* 映射到本地 */
                    var localTableName = tableName;//table_reflect_name[tableName.toLowerCase()];
                    if(localTableName in me.tableFunction) {
                        var newResultData = [];
                        try {
                            var reflectInfo = window[localTableName + "_reflect_keys"];
                            for (var ri = 0, rlen = result.data.length; ri < rlen; ri++) {
                                var tableData = result.data[ri];
                                var keys = Object.keys(reflectInfo);
                                var values = Object.values(reflectInfo);
                                var newTableData = {};
                                for (var tKey in tableData) {
                                    if (!tableData.hasOwnProperty(tKey)) continue;
                                    for (var vi = 0, vlen = values.length; vi < vlen; vi++) {
                                        if (values[vi] == tKey) {
                                            newTableData[keys[vi]] = tableData[tKey];
                                            break;
                                        }
                                    }
                                }
                                newResultData.push(newTableData);
                            }
                        } catch(err) {}
                        DownloadDao[me.tableFunction[localTableName]](localTableName, newResultData, function() {
                            resolve && resolve(true);
                            //me.afterOperator(localTableName, newResultData, result.imagePath);
                        });//.then(function() {
                            //me.refreshView(localTableName, newResultData, result.imagePath);
                            //me.afterOperator(localTableName, newResultData, result.imagePath);
                        //});
                    } else {resolve&&resolve(true);}
                }, function(msg) {
                    console.log(msg);
                    resolve&&resolve(false);
                });
            });//}, 60000);
        });
    },
    downloadDataAll : function(callBack) {
        var tableNameData = DownloadDao.tableFunction;
        var promises = [];
        //var keys = Object.keys(tableNameData);
        for(var fkey in tableNameData) {
            if(tableNameData.hasOwnProperty(fkey)) {
                promises.push(DownloadDao.downloadData({}, fkey));
            }
        }
        Promise.all(promises).timeout(45000).then(function() {
            console.log("登录下载数据完成!");
            callBack && callBack(true);
        })/*.catch(function() {
            console.log("登录下载数据失败!");
            callBack && callBack(false);
        })*/.catch(Promise.TimeoutError, function(e) {
            console.log("登录下载数据超时!");
            callBack && callBack(false);
        });
    },
    downloadDataInterceptor : function(data) {
        if(("supplierInfo".toLowerCase()) in data) {
            var supplierInfoData = data["supplierInfo".toLowerCase()];
            for(var si=0,slen=supplierInfoData.length;si<slen;si++) {
                if(supplierInfoData[si].status === '1') supplierInfoData[si].status = '9';
            }
        } else if(("commodityinfo".toLowerCase()) in data) { // 增加商品图片入库
            var commodityInfoData = data["commodityinfo".toLowerCase()];
            for(var di=0,dlen=commodityInfoData.length;di<dlen;di++) {
                if(commodityInfoData[di].logo)
                    commodityInfoData[di].define1="file:///img/"+commodityInfoData[di].id+".png";
            }
        }
    },
    downloadDataBatch : function(callBack) {
        var me = this;
        /* 批量下载数据 */
        var tableNameData = DownloadDao.tableFunction;
        var tableNames = Object.keys(tableNameData);

        var sql = "";
        /*for(var ti=0,tlen=tableNames.length;ti<tlen;ti++) {
            var tableName = tableNames[ti];
            if(!tableName) continue;
            if(tableName=="comboMeals"||tableName=="combomeals") continue;
            if(sql) sql += " UNION ";
            /!* lastUpdateTime不为空且不是毫秒值 *!/
            sql += "SELECT * FROM (SELECT '" + table_reflect_name[tableName.toLowerCase()] + "' tableName, lastUpdateTime downloadTime FROM " + tableName + " WHERE IFNULL(lastUpdateTime,'')<>'' AND typeof(lastUpdateTime)<>'integer' ORDER BY lastUpdateTime DESC LIMIT 0,1)";
        }*/
        var sql = "SELECT cloudTableName tableName,downloadTime FROM sysdownload WHERE sellerId=? AND tableName<>'combomeals'";
        console.log(sql);
        //loadBySqlParam(sql, [], function(success, tableInfos) {
        loadBySqlParam(sql, [seller.id], function(success, tableInfos) {
            console.log(success, tableInfos);
            if(!success || !tableInfos || tableInfos.length<=0) {callBack && callBack(false);console.log("未查到lastUpdateTime!");return;}
            var dataUrl = webDataURL;
            for(var ti=0,tlen=tableInfos.length;ti<tlen;ti++) {
                if(tableInfos[ti].tableName === "wp_seller_unit") delete tableInfos[ti].downloadTime;
                else if(!tableInfos[ti].downloadTime || isNaN(new Number(tableInfos[ti].downloadTime))) delete tableInfos[ti].downloadTime;
                else tableInfos[ti].downloadTime = parseInt(tableInfos[ti].downloadTime);
                //tableInfos[ti].tableName = table_reflect_name[tableInfos[ti].tableName];
                //if(!tableInfos[ti].downloadTime) delete tableInfos[ti].downloadTime;
                //tableInfos[ti].downloadTime = new Date(tableInfos[ti].downloadTime).getTime();
            }
            //console.log(tableInfos);
            try {
                tableInfos = Ext.JSON.encode(tableInfos);
            } catch(err) {tableInfos=""};
            if(!tableInfos) {callBack && callBack(false); return;}
            nativePostRequest(dataUrl + "/api/datadownload/batch?time="+new Date().getTime(), {tableInfo:tableInfos}, function(result) {
                if(!result.state) {console.log("下载数据失败"); callBack && callBack(false);return;}
                if(!result.data) {console.log("未找到更新的数据!"); callBack && callBack(true); return;}
                //console.log(result);
                var retTableDatas = {};
                for(var key in result.data) {
                    if(!result.data.hasOwnProperty(key)) continue;
                    var localTableName = table_reflect_name[new String(key).toLowerCase()];
                    if(!localTableName) continue; /* 未找到本地表映射 */
                    if(!(localTableName in me.tableFunction)) continue;/* 未找到需要更新数据的表 */
                    /* 字段名转换 */
                    var newResultData = [];
                    var cloudTableData = result.data[key];
                    try {
                        var reflectInfo = window[localTableName + "_reflect_keys"];
                        for (var ri = 0, rlen = cloudTableData.length; ri < rlen; ri++) {
                            var tableData = cloudTableData[ri];
                            var keys = Object.keys(reflectInfo);
                            var values = Object.values(reflectInfo);
                            var newTableData = {};
                            for (var tKey in tableData) {
                                if (!tableData.hasOwnProperty(tKey)) continue;
                                for (var vi = 0, vlen = values.length; vi < vlen; vi++) {
                                    if (values[vi] == tKey) {
                                        newTableData[keys[vi]] = tableData[tKey];
                                        break;
                                    }
                                }
                            }
                            newResultData.push(newTableData);
                        }
                    } catch(err) {}
                    retTableDatas[localTableName] = newResultData;
                }
                if(("combomeals" in retTableDatas) && ("commodityinfo" in retTableDatas)) {
                    var cmmData = retTableDatas["commodityinfo"];
                    var comboSql = [];
                    for(var ci=0,clen=cmmData.length;ci<clen;ci++) {
                        if(cmmData[ci].category !== "2") continue;
                        var comboData = retTableDatas["combomeals"];
                        var currCommCombo = [];
                        var comboIds = [];
                        for(var cbi=0,cblen=comboData.length;cbi<cblen;cbi++) {
                            if(comboData[cbi].comboId === cmmData[ci].id) {
                                currCommCombo.push(comboData[cbi]);
                            }
                            comboIds.push(comboData[cbi].id);
                        }
                        /* combomeals 在云后台是直接删除的 */
                        var sql = "UPDATE combomeals SET status='9' WHERE sellerId=? AND comboId=? AND id NOT IN (" + new Array(comboIds.length).fill("?").join(",") + ")";
                        var params = [seller.id, cmmData[ci].id].concat(comboIds);
                        if(comboIds.length <= 0) {
                            sql = "UPDATE combomeals SET status='9' WHERE sellerId=? AND comboId=?";
                            params = [seller.id, cmmData[ci].id];
                        }
                        comboSql.push({
                            sql : sql,
                            params : params
                        });
                        try {
                            cmmData[ci].comboMealsJson = Ext.JSON.encode(currCommCombo);
                        } catch(err) {console.log(err);}
                    }
                }
                DownloadDao.downloadDataInterceptor(retTableDatas);
                DownloadDao.updateDataBatch(retTableDatas, function() {
                    /* 开启软件更新数据，不需要更新副机(主机需要先启动) */
                    callBack && callBack(true);
                    if(comboSql && comboSql.length > 0) {
                        fgDB.transaction(function (tx) {
                            for(var csi=0,cslen=comboSql.length;csi<cslen;csi++) {
                                tx.executeSql(comboSql[csi].sql, comboSql[csi].params);
                            }
                        }, function() {console.log("batch download combomeals data fixed!")},
                           function(err) {console.log("batch download combomeals fixed failed!")});
                    }
                    DownloadDao.updateDataAfterDownload(retTableDatas, result.imagePath);
                    executeSqlParams("UPDATE sysDownload SET lastUpdateTime=?,syned='0',downloadTime=? WHERE sellerId=?", [new Date().format("yyyy-MM-dd hh:mm:ss"), result.downloadTime, seller.id]);
                });
            }, function(msg) {
                console.log(msg);
                callBack && callBack(false);
            });
        });
    },
    /* 更新完数据之后的操作 */
    updateDataAfterDownload : function(retTableDatas, filePath) {
        if("commodityinfo" in retTableDatas) {
            var cminfo = retTableDatas["commodityinfo"]; // 加载图片
            for (var i = 0, len = cminfo.length; i < len; i++) {
                if (cminfo[i].logo) {
                    LoadDataDao.toLoadImage(cminfo[i].id, filePath + cminfo[i].logo + "@400w_300h_100Q_c_0");
                }
            }
        }
    }
};