Ext.define("Ext.ux.CbItem", {
	extend : "Ext.dataview.component.ListItem",
	xtype : "cbItem",
	config : {
		cbView : true,
		dataMap : {
			getCbView : {
				setCbName : 'name',
				setCbChecked : 'selected',
				setCbId : 'cbId'
			}
		},
		layout : "hbox"
	},
	
	applyCbView : function(config) {
		return Ext.factory(config, "Ext.ux.CbView", this.getCbView());
	},
	updateCbView : function(newCbView, oldCbView) {
		if(newCbView) this.insert(0, newCbView);
	},
	updateRecord : function(record) {
		if(!record) return;
		
		this.callParent(arguments);
	}
})